import c3 from 'c3';
import { Dropdown, Popover, install } from 'uiv';
import Vue from 'vue';

function _typeof(obj) {
  if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
    _typeof = function (obj) {
      return typeof obj;
    };
  } else {
    _typeof = function (obj) {
      return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
    };
  }

  return _typeof(obj);
}

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

function ownKeys(object, enumerableOnly) {
  var keys = Object.keys(object);

  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    if (enumerableOnly) symbols = symbols.filter(function (sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    });
    keys.push.apply(keys, symbols);
  }

  return keys;
}

function _objectSpread2(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i] != null ? arguments[i] : {};

    if (i % 2) {
      ownKeys(Object(source), true).forEach(function (key) {
        _defineProperty(target, key, source[key]);
      });
    } else if (Object.getOwnPropertyDescriptors) {
      Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
    } else {
      ownKeys(Object(source)).forEach(function (key) {
        Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
      });
    }
  }

  return target;
}

function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null) return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;

  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0) continue;
    target[key] = source[key];
  }

  return target;
}

function _objectWithoutProperties(source, excluded) {
  if (source == null) return {};

  var target = _objectWithoutPropertiesLoose(source, excluded);

  var key, i;

  if (Object.getOwnPropertySymbols) {
    var sourceSymbolKeys = Object.getOwnPropertySymbols(source);

    for (i = 0; i < sourceSymbolKeys.length; i++) {
      key = sourceSymbolKeys[i];
      if (excluded.indexOf(key) >= 0) continue;
      if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
      target[key] = source[key];
    }
  }

  return target;
}

function _slicedToArray(arr, i) {
  return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest();
}

function _toConsumableArray(arr) {
  return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread();
}

function _arrayWithoutHoles(arr) {
  if (Array.isArray(arr)) {
    for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) arr2[i] = arr[i];

    return arr2;
  }
}

function _arrayWithHoles(arr) {
  if (Array.isArray(arr)) return arr;
}

function _iterableToArray(iter) {
  if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter);
}

function _iterableToArrayLimit(arr, i) {
  if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) {
    return;
  }

  var _arr = [];
  var _n = true;
  var _d = false;
  var _e = undefined;

  try {
    for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
      _arr.push(_s.value);

      if (i && _arr.length === i) break;
    }
  } catch (err) {
    _d = true;
    _e = err;
  } finally {
    try {
      if (!_n && _i["return"] != null) _i["return"]();
    } finally {
      if (_d) throw _e;
    }
  }

  return _arr;
}

function _nonIterableSpread() {
  throw new TypeError("Invalid attempt to spread non-iterable instance");
}

function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance");
}

var version = "0.1.4";

//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
var script = {
  name: 'pf-aggregate-status-card',
  props: {
    title: String,
    count: [String, Number],
    href: String,
    icon: String,
    layout: String,
    accented: {
      type: Boolean,
      default: true
    }
  }
};

function normalizeComponent(template, style, script, scopeId, isFunctionalTemplate, moduleIdentifier
/* server only */
, shadowMode, createInjector, createInjectorSSR, createInjectorShadow) {
  if (typeof shadowMode !== 'boolean') {
    createInjectorSSR = createInjector;
    createInjector = shadowMode;
    shadowMode = false;
  } // Vue.extend constructor export interop.


  var options = typeof script === 'function' ? script.options : script; // render functions

  if (template && template.render) {
    options.render = template.render;
    options.staticRenderFns = template.staticRenderFns;
    options._compiled = true; // functional template

    if (isFunctionalTemplate) {
      options.functional = true;
    }
  } // scopedId


  if (scopeId) {
    options._scopeId = scopeId;
  }

  var hook;

  if (moduleIdentifier) {
    // server build
    hook = function hook(context) {
      // 2.3 injection
      context = context || // cached call
      this.$vnode && this.$vnode.ssrContext || // stateful
      this.parent && this.parent.$vnode && this.parent.$vnode.ssrContext; // functional
      // 2.2 with runInNewContext: true

      if (!context && typeof __VUE_SSR_CONTEXT__ !== 'undefined') {
        context = __VUE_SSR_CONTEXT__;
      } // inject component styles


      if (style) {
        style.call(this, createInjectorSSR(context));
      } // register component module identifier for async chunk inference


      if (context && context._registeredComponents) {
        context._registeredComponents.add(moduleIdentifier);
      }
    }; // used by ssr in case component is cached and beforeCreate
    // never gets called


    options._ssrRegister = hook;
  } else if (style) {
    hook = shadowMode ? function (context) {
      style.call(this, createInjectorShadow(context, this.$root.$options.shadowRoot));
    } : function (context) {
      style.call(this, createInjector(context));
    };
  }

  if (hook) {
    if (options.functional) {
      // register for functional component in vue file
      var originalRender = options.render;

      options.render = function renderWithStyleInjection(h, context) {
        hook.call(context);
        return originalRender(h, context);
      };
    } else {
      // inject component registration as beforeCreate hook
      var existing = options.beforeCreate;
      options.beforeCreate = existing ? [].concat(existing, hook) : [hook];
    }
  }

  return script;
}

var isOldIE = typeof navigator !== 'undefined' && /msie [6-9]\\b/.test(navigator.userAgent.toLowerCase());

/* script */
const __vue_script__ = script;
/* template */
var __vue_render__ = function (_h,_vm) {var _c=_vm._c;return _c('div',_vm._g(_vm._b({staticClass:"card-pf card-pf-aggregate-status",class:[_vm.data.class, _vm.data.staticClass, {
    'card-pf-accented': _vm.props.accented,
    'card-pf-aggregate-status-alt': _vm.props.layout === 'tall',
    'card-pf-aggregate-status-mini': _vm.props.layout === 'mini',
  }],style:([_vm.data.style, _vm.data.staticStyle])},'div',_vm.data.attrs,false),_vm.listeners),[_c('h2',{staticClass:"card-pf-title"},[_c(_vm.props.href ? 'a' : 'span',{tag:"span",attrs:{"href":_vm.props.href}},[_c('pf-icon',{attrs:{"name":_vm.props.icon}}),_vm._v(" "),(_vm.props.count)?_c('span',{staticClass:"card-pf-aggregate-status-count"},[_vm._v(_vm._s(_vm.props.count))]):_vm._e(),_vm._v(" "),_c('span',{staticClass:"card-pf-aggregate-status-title"},[_vm._v(_vm._s(_vm.props.title))])],1)],1),_vm._v(" "),_c('div',{staticClass:"card-pf-body"},[_c('p',{directives:[{name:"show",rawName:"v-show",value:(_vm.props.layout !== 'mini' || _vm.props.icon || _vm.props.count),expression:"props.layout !== 'mini' || props.icon || props.count"}],staticClass:"card-pf-aggregate-status-notifications"},[_vm._t("default")],2)])])};
var __vue_staticRenderFns__ = [];

  /* style */
  const __vue_inject_styles__ = undefined;
  /* scoped */
  const __vue_scope_id__ = undefined;
  /* module identifier */
  const __vue_module_identifier__ = undefined;
  /* functional template */
  const __vue_is_functional_template__ = true;
  /* style inject */
  
  /* style inject SSR */
  
  /* style inject shadow dom */
  

  
  const __vue_component__ = normalizeComponent(
    { render: __vue_render__, staticRenderFns: __vue_staticRenderFns__ },
    __vue_inject_styles__,
    __vue_script__,
    __vue_scope_id__,
    __vue_is_functional_template__,
    __vue_module_identifier__,
    false,
    undefined,
    undefined,
    undefined
  );

function checkMountedSlots(vm) {
  var slots = {};

  for (var _i = 0, _Object$keys = Object.keys(vm.withSlot); _i < _Object$keys.length; _i++) {
    var k = _Object$keys[_i];
    slots[k] = false;
  }

  for (var _i2 = 0, _Object$entries = Object.entries(vm.$scopedSlots); _i2 < _Object$entries.length; _i2++) {
    var _ref7 = _Object$entries[_i2];

    var _ref2 = _slicedToArray(_ref7, 2);

    var _k = _ref2[0];
    var v = _ref2[1];
    slots[_k] = slots[_k] || typeof v !== 'undefined';
  }

  for (var _i3 = 0, _Object$entries2 = Object.entries(vm.$slots); _i3 < _Object$entries2.length; _i3++) {
    var _ref8 = _Object$entries2[_i3];

    var _ref4 = _slicedToArray(_ref8, 2);

    var _k2 = _ref4[0];
    var _v = _ref4[1];
    slots[_k2] = slots[_k2] || Boolean(Array.isArray(_v) ? _v.length : _v);
  }

  for (var _i4 = 0, _Object$entries3 = Object.entries(slots); _i4 < _Object$entries3.length; _i4++) {
    var _ref9 = _Object$entries3[_i4];

    var _ref6 = _slicedToArray(_ref9, 2);

    var _k3 = _ref6[0];
    var _v2 = _ref6[1];

    if (_v2) {
      vm.$set(vm.withSlot, _k3, _v2);
    } else {
      vm.$delete(vm.withSlot, _k3);
    }
  }
}

var SlotMonitor = {
  data: function data() {
    return {
      withSlot: {}
    };
  },
  mounted: function mounted() {
    checkMountedSlots(this);
  },
  updated: function updated() {
    checkMountedSlots(this);
  }
};

//
var script$1 = {
  name: 'pf-application-launcher',
  mixins: [SlotMonitor],
  model: {
    prop: 'open',
    event: 'update:open'
  },
  props: {
    label: {
      type: String,
      default: 'Application Launcher'
    },
    disabled: Boolean,
    list: Boolean,
    open: Boolean
  },
  mounted: function mounted() {
    document.documentElement.addEventListener('click', this.hide);
  },
  destroyed: function destroyed() {
    document.documentElement.removeEventListener('click', this.hide);
  },
  methods: {
    toggle: function toggle() {
      this.$emit('update:open', !this.open);
    },
    hide: function hide() {
      if (this.open) {
        this.$emit('update:open', false);
      }
    }
  }
};

/* script */
const __vue_script__$1 = script$1;
/* template */
var __vue_render__$1 = function () {var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('li',{staticClass:"applauncher-pf dropdown",class:{'applauncher-pf-block-list': !_vm.list, open: _vm.open && !_vm.disabled}},[_c('a',{staticClass:"dropdown-toggle drawer-pf-trigger-icon nav-item-iconic",class:{disabled: _vm.disabled || !_vm.withSlot.default},attrs:{"id":("pf-application-launcher-" + _vm._uid),"href":"javascript:void(0)"},on:{"click":function($event){$event.stopPropagation();return _vm.toggle($event)}}},[_c('pf-icon',{staticClass:"applauncher-pf-icon",attrs:{"name":"fa-th","aria-hidden":"true","tag":"i"}}),_vm._v(" "),_c('span',{staticClass:"applauncher-pf-title"},[_vm._v("\n      "+_vm._s(_vm.label)+"\n      "),_c('span',{staticClass:"caret",attrs:{"aria-hidden":"true"}})])],1),_vm._v(" "),_c('ul',{staticClass:"dropdown-menu dropdown-menu-right",attrs:{"role":"menu","aria-labelledby":("pf-application-launcher-" + _vm._uid)},on:{"click":function($event){$event.stopPropagation();return _vm.hide($event)}}},[_vm._t("default")],2)])};
var __vue_staticRenderFns__$1 = [];

  /* style */
  const __vue_inject_styles__$1 = undefined;
  /* scoped */
  const __vue_scope_id__$1 = "data-v-334ffc1c";
  /* module identifier */
  const __vue_module_identifier__$1 = undefined;
  /* functional template */
  const __vue_is_functional_template__$1 = false;
  /* style inject */
  
  /* style inject SSR */
  
  /* style inject shadow dom */
  

  
  const __vue_component__$1 = normalizeComponent(
    { render: __vue_render__$1, staticRenderFns: __vue_staticRenderFns__$1 },
    __vue_inject_styles__$1,
    __vue_script__$1,
    __vue_scope_id__$1,
    __vue_is_functional_template__$1,
    __vue_module_identifier__$1,
    false,
    undefined,
    undefined,
    undefined
  );

//
//
//
//
//
//
//
//
//
var script$2 = {
  name: 'pf-launcher-item',
  props: {
    href: {
      type: String,
      default: '#'
    },
    icon: String
  }
};

/* script */
const __vue_script__$2 = script$2;

/* template */
var __vue_render__$2 = function () {var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('li',{staticClass:"applauncher-pf-item",attrs:{"role":"menuitem"}},[_c('a',_vm._g(_vm._b({staticClass:"applauncher-pf-link",attrs:{"href":_vm.href}},'a',_vm.$attrs,false),_vm.$listeners),[_c('pf-icon',{staticClass:"applauncher-pf-link-icon",attrs:{"tag":"i","aria-hidden":"true","name":_vm.icon}}),_vm._v(" "),_c('span',{staticClass:"applauncher-pf-link-title"},[_vm._t("default")],2)],1)])};
var __vue_staticRenderFns__$2 = [];

  /* style */
  const __vue_inject_styles__$2 = undefined;
  /* scoped */
  const __vue_scope_id__$2 = undefined;
  /* module identifier */
  const __vue_module_identifier__$2 = undefined;
  /* functional template */
  const __vue_is_functional_template__$2 = false;
  /* style inject */
  
  /* style inject SSR */
  
  /* style inject shadow dom */
  

  
  const __vue_component__$2 = normalizeComponent(
    { render: __vue_render__$2, staticRenderFns: __vue_staticRenderFns__$2 },
    __vue_inject_styles__$2,
    __vue_script__$2,
    __vue_scope_id__$2,
    __vue_is_functional_template__$2,
    __vue_module_identifier__$2,
    false,
    undefined,
    undefined,
    undefined
  );

//

var patternfly = require('imports-loader?window=>{patternfly:{}}!exports-loader?window.patternfly!patternfly/dist/js/patternfly-settings-colors.js');

var palette = [patternfly.pfPaletteColors.red, patternfly.pfPaletteColors.blue, patternfly.pfPaletteColors.green, patternfly.pfPaletteColors.gold, patternfly.pfPaletteColors.cyan, patternfly.pfPaletteColors.orange, patternfly.pfPaletteColors.lightGreen, patternfly.pfPaletteColors.purple, patternfly.pfPaletteColors.lightBlue, patternfly.pfPaletteColors.red700, patternfly.pfPaletteColors.blue700, patternfly.pfPaletteColors.green700, patternfly.pfPaletteColors.gold700, patternfly.pfPaletteColors.cyan700, patternfly.pfPaletteColors.orange700, patternfly.pfPaletteColors.lightGree7500, patternfly.pfPaletteColors.purple700, patternfly.pfPaletteColors.lightBlue700, patternfly.pfPaletteColors.red400, patternfly.pfPaletteColors.blue400, patternfly.pfPaletteColors.green400, patternfly.pfPaletteColors.gold400, patternfly.pfPaletteColors.cyan400, patternfly.pfPaletteColors.orange400, patternfly.pfPaletteColors.lightGree4500, patternfly.pfPaletteColors.purple400, patternfly.pfPaletteColors.lightBlue400];
var script$3 = {
  name: 'pf-c3-chart',
  props: {
    type: {
      type: String,
      default: 'bar',
      validator: function validator(type) {
        return ['line', 'spline', 'step', 'area', 'area-spline', 'area-step', 'bar', 'scatter', 'pie', 'donut', 'gauge'].indexOf(type) >= 0;
      }
    },
    title: String,
    width: Number,
    height: Number,
    paddingTop: Number,
    paddingBottom: Number,
    paddingLeft: Number,
    paddingRight: Number,
    interaction: {
      type: Boolean,
      default: true
    },
    transition: {
      type: Number,
      default: 350
    },
    data: Object,
    axis: Object,
    grid: Object,
    regions: Object,
    legend: [Boolean, Object],
    tooltip: Object,
    subchart: Object,
    zoom: Object,
    point: Object,
    line: Object,
    area: Object,
    bar: Object,
    pie: Object,
    donut: Object,
    gauge: Object
  },
  mounted: function mounted() {
    this.create();
  },
  methods: {
    create: function create() {
      var _this = this;

      if (this.chart) {
        this.destroy();
      }

      var legend = this.legend;

      if (typeof legend == 'boolean') {
        legend = {
          hide: !legend
        };
      } else {
        legend = Object.assign({}, legend);
      }

      var chartData = {
        bindto: this.$refs.chart,
        size: this.size,
        padding: this.padding,
        interaction: {
          enabled: this.interaction
        },
        transition: {
          duration: this.transition
        },
        data: Object.assign({
          onclick: function onclick(d, i) {
            return _this.$emit('click', d, i);
          },
          onmouseover: function onmouseover(d, i) {
            return _this.$emit('mouseover', d, i);
          },
          onmouseout: function onmouseout(d, i) {
            return _this.$emit('mouseout', d, i);
          },
          onselected: function onselected(d, i) {
            return _this.$emit('selected', d, i);
          },
          onunselected: function onunselected(d, i) {
            return _this.$emit('unselected', d, i);
          },
          ondragstart: function ondragstart(d, i) {
            return _this.$emit('dragstart', d, i);
          },
          ondragend: function ondragend(d, i) {
            return _this.$emit('dragend', d, i);
          }
        }, this.data),
        axis: Object.assign({}, this.axis),
        grid: Object.assign({}, this.grid),
        regions: Object.assign({}, this.regions),
        legend: legend,
        tooltip: Object.assign({}, this.tooltip),
        subchart: Object.assign({}, this.subchart),
        zoom: Object.assign({}, this.zoom),
        point: Object.assign({}, this.point),
        line: Object.assign({}, this.line),
        area: Object.assign({}, this.area),
        bar: Object.assign({}, this.bar),
        pie: Object.assign({}, this.pie),
        donut: Object.assign({}, this.donut),
        gauge: Object.assign({}, this.gauge),
        color: {
          pattern: palette
        },
        oninit: function oninit() {
          return _this.$emit('init');
        },
        onrendered: function onrendered() {
          return _this.$emit('rendered');
        },
        onmouseover: function onmouseover() {
          return _this.$emit('mouseover');
        },
        onmouseout: function onmouseout() {
          return _this.$emit('mouseout');
        },
        onresize: function onresize() {
          return _this.$emit('resize');
        },
        onresized: function onresized() {
          return _this.$emit('resized');
        }
      };
      chartData.data.type = this.type;

      if (typeof this.title != 'undefined') {
        chartData[this.type].title = this.title;
      }

      this.chart = c3.generate(chartData);
    },
    destroy: function destroy() {
      if (this.chart && this.chart.internal.selectChart) {
        this.chart.destroy();
      }

      this.chart = null;
    }
  },
  computed: {
    size: function size() {
      var size = {};

      if (this.width) {
        size.width = this.width;
      }

      if (this.height) {
        size.height = this.height;
      }

      return size;
    },
    padding: function padding() {
      var padding = {};

      if (this.paddingTop) {
        padding.top = this.paddingTop;
      }

      if (this.paddingBottom) {
        padding.bottom = this.paddingBottom;
      }

      if (this.paddingLeft) {
        padding.left = this.paddingLeft;
      }

      if (this.paddingRight) {
        padding.right = this.paddingRight;
      }

      return padding;
    },
    empty: function empty() {
      return !this.data || Object.keys(this.data).length == 0;
    }
  },
  watch: {
    size: function size() {
      this.chart.resize(this.size);
    },
    data: function data() {
      var loadData = Object.assign({}, this.data);
      loadData.unload = true;
      this.chart.load(loadData);
    },
    axis: function axis() {
      this.create();
    },
    type: function type() {
      this.chart.transform(this.type);
    }
  }
};

/* script */
const __vue_script__$3 = script$3;
/* template */
var __vue_render__$3 = function () {var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('div',[_c('div',{directives:[{name:"show",rawName:"v-show",value:(!_vm.empty),expression:"!empty"}],ref:"chart"}),_vm._v(" "),(_vm.empty)?[_c('pf-empty-chart',[_vm._t("default")],2)]:_vm._e()],2)};
var __vue_staticRenderFns__$3 = [];

  /* style */
  const __vue_inject_styles__$3 = undefined;
  /* scoped */
  const __vue_scope_id__$3 = undefined;
  /* module identifier */
  const __vue_module_identifier__$3 = undefined;
  /* functional template */
  const __vue_is_functional_template__$3 = false;
  /* style inject */
  
  /* style inject SSR */
  
  /* style inject shadow dom */
  

  
  const __vue_component__$3 = normalizeComponent(
    { render: __vue_render__$3, staticRenderFns: __vue_staticRenderFns__$3 },
    __vue_inject_styles__$3,
    __vue_script__$3,
    __vue_scope_id__$3,
    __vue_is_functional_template__$3,
    __vue_module_identifier__$3,
    false,
    undefined,
    undefined,
    undefined
  );

var _Dropdown$props = Dropdown.props,
    appendToBody = _Dropdown$props.appendToBody,
    positionElement = _Dropdown$props.positionElement,
    props = _objectWithoutProperties(_Dropdown$props, ["appendToBody", "positionElement"]);

var script$4 = {
  name: 'pf-dropdown',
  props: _objectSpread2({}, props, {
    text: {
      type: String,
      default: ''
    },
    appendTo: {
      type: HTMLElement,
      default: null
    },
    type: {
      type: String,
      default: 'default'
    },
    btnClass: {
      type: String,
      default: ''
    },
    noCaret: Boolean
  }),
  data: function data() {
    return {
      show: false
    };
  },
  computed: {
    triggerEl: function triggerEl() {
      return this.$refs.trigger;
    },
    appendToBody: function appendToBody() {
      return Boolean(this.appendTo);
    }
  },
  watch: Dropdown.watch,
  mounted: Dropdown.mounted,
  beforeDestroy: Dropdown.beforeDestroy,
  methods: _objectSpread2({}, Dropdown.methods, {
    initTrigger: function initTrigger() {
      return;
    },
    appendDropdownToBody: function appendDropdownToBody() {
      try {
        this.$refs.dropdown.style.display = 'block';
        this.$refs.dropdown.style.position = 'absolute';
        this.appendTo.appendChild(this.$refs.dropdown);
        this.setDropdownPosition();
      } catch (e) {// Silent
      }
    },
    setDropdownPosition: function setDropdownPosition() {
      var rP = this.appendTo.offsetParent.getBoundingClientRect();
      var rT = this.$refs.trigger.getBoundingClientRect();
      var rD = {};

      if (this.menuRight || this.dropup) {
        rD = this.$refs.dropdown.getBoundingClientRect();
      }

      var top = rT.top - rP.top;
      var left = rT.left - rP.left;

      if (this.menuRight) {
        left -= rD.width - rT.width;
      }

      if (this.dropup) {
        top -= rD.height;
      } else {
        top += rT.height;
      }

      this.$refs.dropdown.style.top = "".concat(top, "px");
      this.$refs.dropdown.style.bottom = 'auto';
      this.$refs.dropdown.style.left = "".concat(left, "px");
      this.$refs.dropdown.style.right = 'auto';
    }
  })
};

/* script */
const __vue_script__$4 = script$4;

/* template */
var __vue_render__$4 = function () {var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c(_vm.tag,{tag:"component",class:{
  'btn-group': _vm.tag === 'div',
  dropdown: !_vm.dropup,
  dropup: _vm.dropup,
  open: _vm.show,
}},[_c('button',{ref:"trigger",staticClass:"btn dropdown-toggle",class:[_vm.type ? ("btn-" + _vm.type) : '', _vm.btnClass],attrs:{"role":"button","aria-haspopup":"true","type":"button"}},[_vm._t("text",[_c('span',{staticClass:"dropdown-title"},[_vm._v(_vm._s(_vm.text))])]),_vm._v(" "),_c('span',{directives:[{name:"show",rawName:"v-show",value:(!_vm.noCaret),expression:"!noCaret"}],staticClass:"caret"})],2),_vm._v(" "),_c('ul',{ref:"dropdown",staticClass:"dropdown-menu",class:{'dropdown-menu-right': _vm.menuRight}},[_vm._t("default")],2)])};
var __vue_staticRenderFns__$4 = [];

  /* style */
  const __vue_inject_styles__$4 = undefined;
  /* scoped */
  const __vue_scope_id__$4 = undefined;
  /* module identifier */
  const __vue_module_identifier__$4 = undefined;
  /* functional template */
  const __vue_is_functional_template__$4 = false;
  /* style inject */
  
  /* style inject SSR */
  
  /* style inject shadow dom */
  

  
  const __vue_component__$4 = normalizeComponent(
    { render: __vue_render__$4, staticRenderFns: __vue_staticRenderFns__$4 },
    __vue_inject_styles__$4,
    __vue_script__$4,
    __vue_scope_id__$4,
    __vue_is_functional_template__$4,
    __vue_module_identifier__$4,
    false,
    undefined,
    undefined,
    undefined
  );

//
var script$5 = {
  name: 'pf-card',
  components: {
    PfDropdown: __vue_component__$4
  },
  props: {
    title: String,
    subTitle: String,
    footNote: String,
    footHref: String,
    footIcon: String,
    filter: {
      type: Object,
      default: function _default() {
        return {};
      }
    },
    accented: {
      type: Boolean,
      default: true
    },
    showTitlesSeparator: {
      type: Boolean,
      default: true
    }
  },
  methods: {
    filterClicked: function filterClicked(filter) {
      this.$emit('filter', filter);
    }
  },
  computed: {
    currentFilter: function currentFilter() {
      if (!this.filter || !this.filter.filters) {
        return null;
      }

      if (this.filter.defaultFilter) {
        return this.filter.filters[this.filter.defaultFilter];
      }

      return this.filter.filters[0];
    },
    showFilterInHeader: function showFilterInHeader() {
      return this.filter && this.filter.filters && this.filter.position && this.filter.position === 'header';
    },
    showFilterInFooter: function showFilterInFooter() {
      return this.filter && this.filter.filters && this.filter.position && this.filter.position === 'footer';
    },
    showHeader: function showHeader() {
      return this.title || this.showFilterInHeader;
    },
    showFooter: function showFooter() {
      return this.footNote || this.footIcon;
    }
  }
};

/* script */
const __vue_script__$5 = script$5;

/* template */
var __vue_render__$5 = function () {var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('div',{staticClass:"card-pf",class:{'card-pf-accented': _vm.accented}},[(_vm.showHeader)?_c('div',{class:{'card-pf-heading': _vm.showTitlesSeparator, 'card-pf-heading-no-bottom': !_vm.showTitlesSeparator}},[(_vm.showFilterInHeader)?_c('pf-dropdown',{staticClass:"card-pf-time-frame-filter",attrs:{"text":_vm.currentFilter.label,"menu-right":""}},_vm._l((_vm.filter.filters),function(item,i){return _c('li',{key:i,class:{'selected': item === _vm.currentFilter}},[_c('a',{attrs:{"href":"javascript:void(0)","role":"menuitem","tabindex":"-1"},on:{"click":function($event){return _vm.filterClicked(item)}}},[_vm._v("\n          "+_vm._s(item.label)+"\n        ")])])}),0):_vm._e(),_vm._v(" "),_c('h2',{staticClass:"card-pf-title"},[_vm._v(_vm._s(_vm.title))])],1):_vm._e(),_vm._v(" "),(_vm.subTitle)?_c('span',{staticClass:"card-pf-subtitle"},[_vm._v(_vm._s(_vm.subTitle))]):_vm._e(),_vm._v(" "),_c('div',{staticClass:"card-pf-body"},[_vm._t("default")],2),_vm._v(" "),(_vm.showFooter || _vm.showFilterInFooter)?_c('div',{staticClass:"card-pf-footer"},[(_vm.showFilterInFooter)?_c('pf-dropdown',{staticClass:"card-pf-time-frame-filter",attrs:{"text":_vm.currentFilter.label,"menu-right":""}},_vm._l((_vm.filter.filters),function(item,i){return _c('li',{key:i,class:{'selected': item === _vm.currentFilter}},[_c('a',{attrs:{"href":"javascript:void(0)","role":"menuitem","tabindex":"-1"},on:{"click":function($event){return _vm.filterClicked(item)}}},[_vm._v("\n          "+_vm._s(item.label)+"\n        ")])])}),0):_vm._e(),_vm._v(" "),(_vm.showFooter)?_c('p',[(_vm.footHref)?_c('a',{class:{'card-pf-link-with-icon': _vm.footIcon, 'card-pf-link': !_vm.footIcon},attrs:{"href":_vm.footHref}},[(_vm.footIcon)?_c('pf-icon',{staticClass:"cart-pf-footer-text",attrs:{"name":_vm.footIcon}}):_vm._e(),_vm._v(" "),(_vm.footNote)?_c('span',{staticClass:"card-pf-footer-text"},[_vm._v(_vm._s(_vm.footNote))]):_vm._e()],1):[(_vm.footIcon)?_c('pf-icon',{staticClass:"cart-pf-footer-text",attrs:{"name":_vm.footIcon}}):_vm._e(),_vm._v(" "),(_vm.footNote)?_c('span',{staticClass:"card-pf-footer-text"},[_vm._v(_vm._s(_vm.footNote))]):_vm._e()]],2):_vm._e()],1):_vm._e()])};
var __vue_staticRenderFns__$5 = [];

  /* style */
  const __vue_inject_styles__$5 = undefined;
  /* scoped */
  const __vue_scope_id__$5 = undefined;
  /* module identifier */
  const __vue_module_identifier__$5 = undefined;
  /* functional template */
  const __vue_is_functional_template__$5 = false;
  /* style inject */
  
  /* style inject SSR */
  
  /* style inject shadow dom */
  

  
  const __vue_component__$5 = normalizeComponent(
    { render: __vue_render__$5, staticRenderFns: __vue_staticRenderFns__$5 },
    __vue_inject_styles__$5,
    __vue_script__$5,
    __vue_scope_id__$5,
    __vue_is_functional_template__$5,
    __vue_module_identifier__$5,
    false,
    undefined,
    undefined,
    undefined
  );

//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
var script$6 = {
  name: 'pf-card-notification',
  props: {
    count: [String, Number],
    href: String,
    icon: String
  }
};

/* script */
const __vue_script__$6 = script$6;

/* template */
var __vue_render__$6 = function (_h,_vm) {var _c=_vm._c;return (_vm.props.icon || _vm.props.count || _vm.props.count === 0)?_c('span',_vm._g(_vm._b({staticClass:"card-pf-aggregate-status-notification",class:[_vm.data.class, _vm.data.staticClass],style:([_vm.data.style, _vm.data.staticStyle])},'span',_vm.data.attrs,false),_vm.listeners),[_c(_vm.props.href ? 'a' : 'span',{tag:"span",attrs:{"href":_vm.props.href}},[(_vm.props.icon)?_c('pf-icon',{attrs:{"name":_vm.props.icon}}):_vm._e(),_vm._v("\n    "+_vm._s(_vm.props.count)+"\n  ")],1)],1):_vm._e()};
var __vue_staticRenderFns__$6 = [];

  /* style */
  const __vue_inject_styles__$6 = undefined;
  /* scoped */
  const __vue_scope_id__$6 = undefined;
  /* module identifier */
  const __vue_module_identifier__$6 = undefined;
  /* functional template */
  const __vue_is_functional_template__$6 = true;
  /* style inject */
  
  /* style inject SSR */
  
  /* style inject shadow dom */
  

  
  const __vue_component__$6 = normalizeComponent(
    { render: __vue_render__$6, staticRenderFns: __vue_staticRenderFns__$6 },
    __vue_inject_styles__$6,
    __vue_script__$6,
    __vue_scope_id__$6,
    __vue_is_functional_template__$6,
    __vue_module_identifier__$6,
    false,
    undefined,
    undefined,
    undefined
  );

//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
var script$7 = {
  name: 'pf-empty-chart',
  props: {
    height: {
      type: Number,
      default: 40
    }
  }
};

/* script */
const __vue_script__$7 = script$7;
/* template */
var __vue_render__$7 = function (_h,_vm) {var _c=_vm._c;return _c('div',_vm._g(_vm._b({staticClass:"empty-chart-content",class:[_vm.data.class, _vm.data.staticClass],style:([_vm.data.style, _vm.data.staticStyle, {
    'height': ((_vm.props.height) + "px"),
    'padding-top': ((Math.min(Math.round((_vm.props.height - 40) / 2), 20)) + "px"),
  }])},'div',_vm.data.attrs,false),_vm.listeners),[_c('pf-icon',{attrs:{"name":"pficon-info"}}),_vm._v(" "),_vm._t("default",[_c('span',[_vm._v("No data available")])])],2)};
var __vue_staticRenderFns__$7 = [];

  /* style */
  const __vue_inject_styles__$7 = undefined;
  /* scoped */
  const __vue_scope_id__$7 = undefined;
  /* module identifier */
  const __vue_module_identifier__$7 = undefined;
  /* functional template */
  const __vue_is_functional_template__$7 = true;
  /* style inject */
  
  /* style inject SSR */
  
  /* style inject shadow dom */
  

  
  const __vue_component__$7 = normalizeComponent(
    { render: __vue_render__$7, staticRenderFns: __vue_staticRenderFns__$7 },
    __vue_inject_styles__$7,
    __vue_script__$7,
    __vue_scope_id__$7,
    __vue_is_functional_template__$7,
    __vue_module_identifier__$7,
    false,
    undefined,
    undefined,
    undefined
  );

var script$8 = {
  name: 'pf-sort',
  components: {
    PfDropdown: __vue_component__$4
  },
  props: {
    fields: {
      type: [Array, Object],
      default: function _default() {
        return [];
      }
    },
    sortBy: String,
    direction: {
      type: String,
      default: 'ascending'
    }
  },
  data: function data() {
    return {
      normFields: [],
      active: '',
      ascending: true
    };
  },
  watch: {
    fields: {
      handler: function handler(fields) {
        var normFields = [];

        if (Array.isArray(fields)) {
          var _iteratorNormalCompletion = true;
          var _didIteratorError = false;
          var _iteratorError = undefined;

          try {
            for (var _iterator = fields[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
              var f = _step.value;
              normFields.push(this.fieldDefinition(f));
            }
          } catch (err) {
            _didIteratorError = true;
            _iteratorError = err;
          } finally {
            try {
              if (!_iteratorNormalCompletion && _iterator.return != null) {
                _iterator.return();
              }
            } finally {
              if (_didIteratorError) {
                throw _iteratorError;
              }
            }
          }
        } else {
          for (var _i = 0, _Object$keys = Object.keys(fields); _i < _Object$keys.length; _i++) {
            var i = _Object$keys[_i];
            normFields.push(this.fieldDefinition(fields[i], i));
          }
        }

        this.normFields = normFields;
      },
      immediate: true
    },
    sortBy: {
      handler: function handler(sortBy) {
        this.active = sortBy;
      },
      immediate: true
    },
    direction: {
      handler: function handler() {
        this.ascending = this.direction == 'ascending';
      },
      immediate: true
    }
  },
  computed: {
    current: function current() {
      if (!this.active) {
        return {
          label: 'Sort by'
        };
      }

      var _iteratorNormalCompletion2 = true;
      var _didIteratorError2 = false;
      var _iteratorError2 = undefined;

      try {
        for (var _iterator2 = this.normFields[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
          var field = _step2.value;

          if (field.name == this.active) {
            return field;
          }
        }
      } catch (err) {
        _didIteratorError2 = true;
        _iteratorError2 = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion2 && _iterator2.return != null) {
            _iterator2.return();
          }
        } finally {
          if (_didIteratorError2) {
            throw _iteratorError2;
          }
        }
      }

      return {
        label: 'Sort by'
      };
    },
    sortIcon: function sortIcon() {
      var dir = this.ascending ? 'asc' : 'desc';
      var typ = this.current.type == 'numeric' ? 'numeric' : 'alpha';
      return "fa-sort-".concat(typ, "-").concat(dir);
    }
  },
  methods: {
    fieldDefinition: function fieldDefinition(field, name) {
      if (_typeof(field) == 'object') {
        field = Object.assign({}, field);
      } else {
        field = {
          label: field
        };
      }

      field.name = name || field.label;

      if (!field.label) {
        field.label = name;
      }

      if (!field.type) {
        field.type = 'alpha';
      }

      return field;
    },
    select: function select(field) {
      this.active = field.name;
      this.$emit('change', this.active, this.ascending ? 'ascending' : 'descending');
    },
    invert: function invert() {
      this.ascending = !this.ascending;
      this.$emit('change', this.active, this.ascending ? 'ascending' : 'descending');
    }
  }
};

/* script */
const __vue_script__$8 = script$8;
/* template */
var __vue_render__$8 = function () {var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('div',{staticClass:"sort-pf"},[_c('pf-dropdown',{attrs:{"text":_vm.current.label}},_vm._l((_vm.normFields),function(field){return _c('li',{key:field.name,class:{'selected': _vm.active == field.name}},[_c('a',{staticClass:"sort-field",attrs:{"href":"javascript:void(0);","role":"menuitem","tabindex":"-1"},on:{"click":function($event){return _vm.select(field)}}},[_vm._v("\n        "+_vm._s(field.label)+"\n      ")])])}),0),_vm._v(" "),_c('button',{staticClass:"btn btn-link",attrs:{"type":"button"},on:{"click":_vm.invert}},[_c('pf-icon',{staticClass:"sort-direction",attrs:{"name":_vm.sortIcon}})],1)],1)};
var __vue_staticRenderFns__$8 = [];

  /* style */
  const __vue_inject_styles__$8 = undefined;
  /* scoped */
  const __vue_scope_id__$8 = undefined;
  /* module identifier */
  const __vue_module_identifier__$8 = undefined;
  /* functional template */
  const __vue_is_functional_template__$8 = false;
  /* style inject */
  
  /* style inject SSR */
  
  /* style inject shadow dom */
  

  
  const __vue_component__$8 = normalizeComponent(
    { render: __vue_render__$8, staticRenderFns: __vue_staticRenderFns__$8 },
    __vue_inject_styles__$8,
    __vue_script__$8,
    __vue_scope_id__$8,
    __vue_is_functional_template__$8,
    __vue_module_identifier__$8,
    false,
    undefined,
    undefined,
    undefined
  );

var script$9 = {
  name: 'pf-column-picker',
  components: {
    Popover: Popover
  },
  props: {
    columns: {
      type: [Array, Object],
      default: function _default() {
        return [];
      }
    },
    value: {
      type: Array,
      default: function _default() {
        return [];
      }
    }
  },
  data: function data() {
    return {
      iValue: []
    };
  },
  mounted: function mounted() {
    this.iValue = this.value;
  },
  methods: {
    columnValue: function columnValue(column, i) {
      var value = Array.isArray(this.columns) ? column : i;

      if (_typeof(value) === 'object') {
        value = typeof value.name === 'undefined' ? value.label : value.name;
      }

      return value;
    },
    columnLabel: function columnLabel(column) {
      return _typeof(column) === 'object' ? column.label : column;
    },
    setValue: function setValue() {
      var sortedValue = [];
      var iter = Array.isArray(this.columns) ? this.columns.entries() : Object.entries(this.columns);
      var _iteratorNormalCompletion = true;
      var _didIteratorError = false;
      var _iteratorError = undefined;

      try {
        for (var _iterator = iter[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
          var _ref3 = _step.value;

          var _ref2 = _slicedToArray(_ref3, 2);

          var i = _ref2[0];
          var column = _ref2[1];
          var value = this.columnValue(column, i);

          if (this.iValue.indexOf(value) >= 0) {
            sortedValue.push(value);
          }
        }
      } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion && _iterator.return != null) {
            _iterator.return();
          }
        } finally {
          if (_didIteratorError) {
            throw _iteratorError;
          }
        }
      }

      this.$emit('input', sortedValue);
    }
  },
  watch: {
    value: function value(_value) {
      if (_value != this.iValue) {
        this.iValue = _value.slice(0);
      }
    }
  }
};

/* script */
const __vue_script__$9 = script$9;
/* template */
var __vue_render__$9 = function () {var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('popover',{staticClass:"column-picker",attrs:{"placement":"bottom"},scopedSlots:_vm._u([{key:"popover",fn:function(){return _vm._l((_vm.columns),function(column,i){return _c('div',{key:i,staticClass:"column-picker checkbox"},[_c('label',[_c('input',{directives:[{name:"model",rawName:"v-model",value:(_vm.iValue),expression:"iValue"}],attrs:{"type":"checkbox"},domProps:{"value":_vm.columnValue(column, i),"checked":Array.isArray(_vm.iValue)?_vm._i(_vm.iValue,_vm.columnValue(column, i))>-1:(_vm.iValue)},on:{"change":[function($event){var $$a=_vm.iValue,$$el=$event.target,$$c=$$el.checked?(true):(false);if(Array.isArray($$a)){var $$v=_vm.columnValue(column, i),$$i=_vm._i($$a,$$v);if($$el.checked){$$i<0&&(_vm.iValue=$$a.concat([$$v]));}else{$$i>-1&&(_vm.iValue=$$a.slice(0,$$i).concat($$a.slice($$i+1)));}}else{_vm.iValue=$$c;}},_vm.setValue]}}),_vm._v("\n        "+_vm._s(_vm.columnLabel(column))+"\n      ")])])})},proxy:true}])},[_c('button',{ref:"popover-trigger",staticClass:"btn btn-link",attrs:{"type":"button"}},[_c('pf-icon',{attrs:{"name":"fa-columns"}})],1)])};
var __vue_staticRenderFns__$9 = [];

  /* style */
  const __vue_inject_styles__$9 = undefined;
  /* scoped */
  const __vue_scope_id__$9 = undefined;
  /* module identifier */
  const __vue_module_identifier__$9 = undefined;
  /* functional template */
  const __vue_is_functional_template__$9 = false;
  /* style inject */
  
  /* style inject SSR */
  
  /* style inject shadow dom */
  

  
  const __vue_component__$9 = normalizeComponent(
    { render: __vue_render__$9, staticRenderFns: __vue_staticRenderFns__$9 },
    __vue_inject_styles__$9,
    __vue_script__$9,
    __vue_scope_id__$9,
    __vue_is_functional_template__$9,
    __vue_module_identifier__$9,
    false,
    undefined,
    undefined,
    undefined
  );

//
var script$a = {
  name: 'pf-toolbar',
  mixins: [SlotMonitor],
  components: {
    PfSort: __vue_component__$8,
    PfColumnPicker: __vue_component__$9
  },
  props: {
    view: String,
    views: {
      type: [Object, String],
      default: function _default() {
        return {};
      }
    },
    columns: {
      type: [Array, Object],
      default: function _default() {
        return [];
      }
    },
    pickedColumns: {
      type: Array,
      default: function _default() {
        return [];
      }
    },
    filterFields: {
      type: [Array, Object],
      default: function _default() {
        return {};
      }
    },
    filters: {
      type: Array,
      default: function _default() {
        return [];
      }
    },
    sortBy: String,
    sortDirection: String,
    sortFields: {
      type: [Array, Object],
      default: function _default() {
        return [];
      }
    },
    resultCount: Number,
    attached: Boolean
  },
  data: function data() {
    return {
      activeView: null,
      activeFilters: []
    };
  },
  mounted: function mounted() {
    this.activeView = this.view;
  },
  methods: {
    setSortBy: function setSortBy(field, direction) {
      this.$emit('sort-by', field, direction);
      this.$emit('update:sortBy', field);
      this.$emit('update:sortDirection', direction);
    },
    clearFilter: function clearFilter(i) {
      this.activeFilters.splice(i, 1);
    },
    clearAllFilters: function clearAllFilters() {
      this.activeFilters = [];
    },
    addFilter: function addFilter(filter) {
      this.activeFilters.push(filter);
    },
    setPickedColumns: function setPickedColumns(columns) {
      this.$emit('update:pickedColumns', columns);
    }
  },
  computed: {
    showSorter: function showSorter() {
      return Array.isArray(this.sortFields) ? this.sortFields.length : Object.keys(this.sortFields).length;
    },
    showFilter: function showFilter() {
      return Object.keys(this.filterFields).length;
    },
    showColumnPicker: function showColumnPicker() {
      return (this.activeView == 'table' || !Object.keys(this.viewList).length) && (Array.isArray(this.columns) ? this.columns : Object.keys(this.columns)).length;
    },
    showCount: function showCount() {
      return !this.showResultFilter && typeof this.resultCount != 'undefined';
    },
    hasFindView: function hasFindView() {
      return Object.keys(this.viewList).length;
    },
    viewList: function viewList() {
      if (typeof this.views != 'string') {
        return this.views;
      }

      var viewList = {};
      var presets = this.views.split(',').map(function (v) {
        return v.trim();
      });

      if (presets.indexOf('table') > -1) {
        viewList.table = {
          icon: 'fa-table'
        };
      }

      if (presets.indexOf('card') > -1) {
        viewList.card = {
          icon: 'fa-th'
        };
      }

      if (presets.indexOf('list') > -1) {
        viewList.list = {
          icon: 'fa-th-list'
        };
      }

      return viewList;
    },
    showResultFilter: function showResultFilter() {
      return this.activeFilters.length;
    }
  },
  watch: {
    filters: {
      handler: function handler() {
        this.activeFilters = this.filters;
      },
      immediate: true
    },
    view: function view() {
      this.activeView = this.view;
    },
    views: {
      handler: function handler() {
        if (!this.views[this.activeView]) {
          var names = Object.keys(this.views);

          if (names.length > 0) {
            this.activeView = names[0];
          }
        }
      },
      immediate: true
    },
    activeView: function activeView() {
      this.$emit('update:view', this.activeView);
    },
    activeFilters: function activeFilters() {
      this.$emit('update:filters', this.activeFilters);
    }
  }
};

/* script */
const __vue_script__$a = script$a;
/* template */
var __vue_render__$a = function () {var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('div',{staticClass:"clearfix toolbar-pf",class:{
    'table-view-pf-toolbar': _vm.attached,
  },attrs:{"_v-3RyaW5nJyk":""}},[_c('div',{staticClass:"col-sm-12"},[_c('form',{staticClass:"toolbar-pf-actions",class:{'no-filter-results': !_vm.showResultFilter},on:{"submit":function($event){return $event.preventDefault()}}},[_c('div',{staticClass:"filter-pf filter-fields form-group toolbar-pf-filter"},[_vm._t("filter",[(_vm.showFilter)?_c('pf-filter-fields',{attrs:{"fields":_vm.filterFields},on:{"filter":_vm.addFilter}}):_vm._e()])],2),_vm._v(" "),(_vm.showSorter || _vm.showColumnPicker)?_c('div',{staticClass:"form-group"},[(_vm.showSorter)?_c('pf-sort',{attrs:{"fields":_vm.sortFields,"sortBy":_vm.sortBy,"direction":_vm.sortDirection},on:{"change":_vm.setSortBy}}):_vm._e(),_vm._v(" "),(_vm.showColumnPicker)?_c('pf-column-picker',{ref:"colpicker",attrs:{"columns":_vm.columns,"value":_vm.pickedColumns},on:{"input":_vm.setPickedColumns}}):_vm._e()],1):_vm._e(),_vm._v(" "),(_vm.withSlot.default)?_c('div',{staticClass:"toolbar-actions",class:{
        'form-group': !_vm.hasFindView,
        'pull-right': !_vm.hasFindView,
        'toolbar-pf-action-right': !_vm.hasFindView,
      }},[(_vm.showCount && !_vm.hasFindView)?_c('h5',{staticClass:"form-group"},[_vm._v("\n          "+_vm._s(_vm.resultCount)+" Results\n        ")]):_vm._e(),_vm._v(" "),_c('div',{staticClass:"form-group"},[_vm._t("default")],2)]):_vm._e(),_vm._v(" "),(_vm.hasFindView)?_c('div',{staticClass:"toolbar-pf-action-right"},[(_vm.showCount && _vm.hasFindView)?_c('h5',{staticClass:"form-group"},[_vm._v("\n          "+_vm._s(_vm.resultCount)+" Results\n        ")]):_vm._e(),_vm._v(" "),_c('div',{staticClass:"form-group toolbar-pf-view-selector"},_vm._l((_vm.viewList),function(viewData,name){return _c('button',{key:name,staticClass:"btn btn-link",class:{'active': _vm.view == name, 'disabled': viewData.disabled},attrs:{"type":"button","title":viewData.title},on:{"click":function($event){_vm.activeView = name;}}},[_c('pf-icon',{staticClass:"view-selector",attrs:{"tag":"i","name":viewData.icon}})],1)}),0)]):_vm._e()]),_vm._v(" "),(_vm.showResultFilter)?_c('pf-filter-results',{attrs:{"count":_vm.resultCount,"filters":_vm.activeFilters}}):_vm._e()],1)])};
var __vue_staticRenderFns__$a = [];

  /* style */
  const __vue_inject_styles__$a = undefined;
  /* scoped */
  const __vue_scope_id__$a = undefined;
  /* module identifier */
  const __vue_module_identifier__$a = undefined;
  /* functional template */
  const __vue_is_functional_template__$a = false;
  /* style inject */
  
  /* style inject SSR */
  
  /* style inject shadow dom */
  

  
  const __vue_component__$a = normalizeComponent(
    { render: __vue_render__$a, staticRenderFns: __vue_staticRenderFns__$a },
    __vue_inject_styles__$a,
    __vue_script__$a,
    __vue_scope_id__$a,
    __vue_is_functional_template__$a,
    __vue_module_identifier__$a,
    false,
    undefined,
    undefined,
    undefined
  );

//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
var script$b = {
  name: 'pf-utilization-bar-chart',
  props: {
    value: Number,
    total: Number,
    units: String,
    title: String,
    footer: String,
    footerFormat: {
      type: String,
      default: 'actual'
    },
    inline: Boolean,
    warning: Number,
    error: Number,
    titleWidth: Number,
    footerWidth: Number
  },
  data: function data() {
    return {
      animate: true
    };
  },
  mounted: function mounted() {
    this.$nextTick(function () {
      this.animate = false;
    }.bind(this));
  },
  computed: {
    dataAvailable: function dataAvailable() {
      return typeof this.value != 'undefined' && typeof this.total != 'undefined';
    },
    percent: function percent() {
      return Math.round(100 * this.value / this.total);
    },
    isError: function isError() {
      return this.percent >= this.error;
    },
    isWarning: function isWarning() {
      return !this.isError && this.percent >= this.warning;
    },
    isOk: function isOk() {
      return !this.isError && !this.isWarning;
    },
    footerHTML: function footerHTML() {
      if (this.footer) {
        return this.footer;
      }

      switch (this.footerFormat) {
        case 'percent':
          return "<strong>".concat(this.percent, "%</strong> used");

        default:
          if (this.inline) {
            return "<strong>".concat(this.value, " ").concat(this.units, "</strong> used");
          }

          return "<strong>".concat(this.value, " of ").concat(this.total, " ").concat(this.units, "</strong> used");
      }
    },
    titleWidthPx: function titleWidthPx() {
      return this.titleWidth ? "".concat(this.titleWidth, "px") : null;
    },
    footerWidthPx: function footerWidthPx() {
      return this.footerWidth ? "".concat(this.footerWidth, "px") : null;
    }
  }
};

/* script */
const __vue_script__$b = script$b;
/* template */
var __vue_render__$b = function () {var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('div',{staticClass:"utilization-bar-chart-pf",class:{'data-unavailable-pf': !_vm.dataAvailable}},[(!_vm.inline)?[(_vm.title)?_c('div',{staticClass:"progress-description",domProps:{"innerHTML":_vm._s(_vm.title)}}):_vm._e(),_vm._v(" "),(_vm.dataAvailable)?_c('div',{staticClass:"progress progress-label-top-right"},[_c('div',{directives:[{name:"tooltip",rawName:"v-tooltip",value:(_vm.percent + '% Used'),expression:"percent + '% Used'"}],staticClass:"progress-bar",class:{
             'animate': _vm.animate,
             'progress-bar-success': _vm.isOk,
             'progress-bar-danger': _vm.isError,
             'progress-bar-warning': _vm.isWarning,
            },style:({width: _vm.percent + '%'}),attrs:{"aria-valuenow":_vm.percent,"aria-valuemin":"0","aria-valuemax":"100"}},[_c('span',{domProps:{"innerHTML":_vm._s(_vm.footerHTML)}})]),_vm._v(" "),_c('div',{directives:[{name:"tooltip",rawName:"v-tooltip",value:((100 - _vm.percent) + '% Available'),expression:"(100 - percent) + '% Available'"}],staticClass:"progress-bar progress-bar-remaining",style:({width: (100 - _vm.percent) + '%'})})]):_vm._e()]:[_c('div',{staticClass:"progress-container progress-description-left progress-label-right",style:({
           'padding-left': _vm.titleWidthPx,
           'padding-right': _vm.footerWidthPx,
          })},[(_vm.title)?_c('div',{staticClass:"progress-description",style:({'max-width': _vm.titleWidthPx}),domProps:{"innerHTML":_vm._s(_vm.title)}}):_vm._e(),_vm._v(" "),(_vm.dataAvailable)?_c('div',{staticClass:"progress"},[_c('div',{directives:[{name:"tooltip",rawName:"v-tooltip",value:(_vm.percent + '% Used'),expression:"percent + '% Used'"}],staticClass:"progress-bar",class:{
               'animate': _vm.animate,
               'progress-bar-success': _vm.isOk,
               'progress-bar-danger': _vm.isError,
               'progress-bar-warning': _vm.isWarning,
              },style:({width: _vm.percent + '%'}),attrs:{"aria-valuenow":_vm.percent,"aria-valuemin":"0","aria-valuemax":"100"}},[_c('span',{style:({'max-width': _vm.footerWidthPx}),domProps:{"innerHTML":_vm._s(_vm.footerHTML)}})]),_vm._v(" "),_c('div',{directives:[{name:"tooltip",rawName:"v-tooltip",value:((100 - _vm.percent) + '% Available'),expression:"(100 - percent) + '% Available'"}],staticClass:"progress-bar progress-bar-remaining",style:({width: (100 - _vm.percent) + '%'})})]):_vm._e()])],_vm._v(" "),(!_vm.dataAvailable)?_c('pf-empty-chart',{attrs:{"height":45}}):_vm._e()],2)};
var __vue_staticRenderFns__$b = [];

  /* style */
  const __vue_inject_styles__$b = undefined;
  /* scoped */
  const __vue_scope_id__$b = undefined;
  /* module identifier */
  const __vue_module_identifier__$b = undefined;
  /* functional template */
  const __vue_is_functional_template__$b = false;
  /* style inject */
  
  /* style inject SSR */
  
  /* style inject shadow dom */
  

  
  const __vue_component__$b = normalizeComponent(
    { render: __vue_render__$b, staticRenderFns: __vue_staticRenderFns__$b },
    __vue_inject_styles__$b,
    __vue_script__$b,
    __vue_scope_id__$b,
    __vue_is_functional_template__$b,
    __vue_module_identifier__$b,
    false,
    undefined,
    undefined,
    undefined
  );

//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
var script$c = {
  name: 'pf-select',
  props: {
    button: Boolean,
    clearButton: Boolean,
    closeOnSelect: Boolean,
    disabled: Boolean,
    minSearch: {
      type: Number,
      default: 0
    },
    name: {
      type: String,
      default: function _default() {
        return "pf-select-uid-".concat(this._uid);
      }
    },
    placeholder: String,
    readonly: Boolean,
    required: Boolean,
    search: Boolean,
    tabindex: String
  },
  data: function data() {
    return {
      filter: '',
      show: false,
      isLi: false,
      inInput: false,
      selected: ''
    };
  },
  updated: function updated() {
    this.selected = this.$children.reduce(function (labels, c) {
      if (c.checked) {
        labels.push(c.$el.innerText);
      }

      return labels;
    }, []).join(', ');
  },
  computed: {
    canSearch: function canSearch() {
      return this.minSearch ? this.$children.length >= this.minSearch : this.search;
    },
    showPlaceholder: function showPlaceholder() {
      return this.values.length ? '' : this.placeholder;
    },
    values: function values() {
      return this.$children.reduce(function (values, c) {
        if (c.checked) {
          values.push(c.value);
        }

        return values;
      }, []);
    },
    btnType: function btnType() {
      return this.button ? 'button' : 'div';
    }
  },
  watch: {
    show: function show(val) {
      if (val && this.$refs.search) {
        this.$refs.search.focus();
      } else {
        this.$refs.btn.focus();
      }
    },
    filter: function filter() {
      var _iteratorNormalCompletion = true;
      var _didIteratorError = false;
      var _iteratorError = undefined;

      try {
        for (var _iterator = this.$children[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
          var c = _step.value;
          c.filter = this.filter;
        }
      } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion && _iterator.return != null) {
            _iterator.return();
          }
        } finally {
          if (_didIteratorError) {
            throw _iteratorError;
          }
        }
      }
    }
  },
  methods: {
    close: function close() {
      this.show = false;
    },
    open: function open() {
      this.show = true;
    },
    clear: function clear() {
      if (this.disabled || this.readonly) {
        return;
      }

      this.toggle();
    },
    clearSearch: function clearSearch() {
      this.filter = '';
      this.$refs.search.focus();
    },
    toggle: function toggle() {
      this.show = !this.show;
    },
    outerClick: function outerClick(e) {
      if (!this.$el.contains(e.target)) {
        this.close();
      }
    },
    select: function select() {
      if (this.closeOnSelect) {
        this.close();
      }
    },
    focus: function focus() {
      this.$refs.btn.focus();
    }
  },
  mounted: function mounted() {
    this.isLi = this.$el.parentNode.tagName == 'LI';
    this.inInput = !this.isLi && this.$parent._input;
    document.addEventListener('click', this.outerClick);
  },
  beforeDestroy: function beforeDestroy() {
    document.removeEventListener('click', this.outerClick);
  }
};

/* script */
const __vue_script__$c = script$c;
/* template */
var __vue_render__$c = function () {var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('div',{ref:"select",staticClass:"bootstrap-select",class:{
  open: _vm.show,
  disabled: _vm.disabled,
  dropdown: _vm.isLi,
  'input-group-btn': _vm.inInput,
  'btn-group': !_vm.isLi && !_vm.inInput,
}},[_c(_vm.btnType,{ref:"btn",tag:"div",staticClass:"dropdown-toggle",class:{
    'btn btn-default': _vm.button,
    'form-control': !_vm.button,
  },attrs:{"type":_vm.button ? 'button' : null,"tabindex":_vm.tabindex,"disabled":_vm.disabled,"readonly":_vm.readonly,"role":"button","aria-expanded":_vm.show.toString()},on:{"blur":function($event){_vm.canSearch ? null : _vm.close;},"click":_vm.toggle,"keydown":[function($event){if(!$event.type.indexOf('key')&&_vm._k($event.keyCode,"esc",27,$event.key,["Esc","Escape"])){ return null; }$event.stopPropagation();$event.preventDefault();return _vm.close($event)},function($event){if(!$event.type.indexOf('key')&&_vm._k($event.keyCode,"space",32,$event.key,[" ","Spacebar"])){ return null; }$event.stopPropagation();$event.preventDefault();return _vm.toggle($event)},function($event){if(!$event.type.indexOf('key')&&_vm._k($event.keyCode,"enter",13,$event.key,"Enter")){ return null; }$event.stopPropagation();$event.preventDefault();return _vm.toggle($event)}]}},[_c('span',{class:{
      'filter-option pull-left': _vm.button,
      'btn-content': !_vm.button,
    },domProps:{"innerHTML":_vm._s(_vm.showPlaceholder || _vm.selected)}}),_vm._v(" "),(_vm.clearButton && _vm.values.length)?_c('span',{staticClass:"close",on:{"click":_vm.clear}},[_vm._v("×")]):_vm._e(),_vm._v(" "),(_vm.button)?_c('span',{staticClass:"bs-caret"},[_c('span',{staticClass:"caret"})]):_vm._e()]),_vm._v(" "),_c('ul',{staticClass:"dropdown-menu"},[[(_vm.canSearch)?_c('li',{staticClass:"bs-searchbox"},[_c('input',{directives:[{name:"model",rawName:"v-model",value:(_vm.filter),expression:"filter"}],ref:"search",staticClass:"form-control",attrs:{"type":"text","placeholder":typeof _vm.search == 'string' ? _vm.search : '',"autocomplete":"off"},domProps:{"value":(_vm.filter)},on:{"keyup":function($event){if(!$event.type.indexOf('key')&&_vm._k($event.keyCode,"esc",27,$event.key,["Esc","Escape"])){ return null; }return _vm.close($event)},"input":function($event){if($event.target.composing){ return; }_vm.filter=$event.target.value;}}}),_vm._v(" "),_c('span',{directives:[{name:"show",rawName:"v-show",value:(_vm.filter),expression:"filter"}],staticClass:"close",on:{"click":_vm.clearSearch}},[_vm._v("×")])]):_vm._e(),_vm._v(" "),(_vm.required && !_vm.clearButton)?_c('li',[_c('a',{on:{"mousedown":function($event){$event.preventDefault();_vm.clear() && _vm.close();}}},[_vm._v(_vm._s(_vm.placeholder))])]):_vm._e(),_vm._v(" "),_vm._t("default")]],2)],1)};
var __vue_staticRenderFns__$c = [];

  /* style */
  const __vue_inject_styles__$c = undefined;
  /* scoped */
  const __vue_scope_id__$c = "data-v-4444bf04";
  /* module identifier */
  const __vue_module_identifier__$c = undefined;
  /* functional template */
  const __vue_is_functional_template__$c = false;
  /* style inject */
  
  /* style inject SSR */
  
  /* style inject shadow dom */
  

  
  const __vue_component__$c = normalizeComponent(
    { render: __vue_render__$c, staticRenderFns: __vue_staticRenderFns__$c },
    __vue_inject_styles__$c,
    __vue_script__$c,
    __vue_scope_id__$c,
    __vue_is_functional_template__$c,
    __vue_module_identifier__$c,
    false,
    undefined,
    undefined,
    undefined
  );

//
//
//
//
//
//
//
//
//
//
var script$d = {
  name: 'pf-option',
  props: {
    name: {
      type: String,
      default: function _default() {
        return this.$parent.name;
      }
    },
    value: {},
    checkedValue: {}
  },
  data: function data() {
    return {
      label: '',
      filter: ''
    };
  },
  mounted: function mounted() {
    this.label = this.$el.innerText;
  },
  methods: {
    check: function check() {
      this.$emit('input', this.checkedValue);
      this.$parent.select(this);
    }
  },
  computed: {
    checked: function checked() {
      return this.checkedValue == this.value;
    },
    filtered: function filtered() {
      if (!this.label || !this.filter) {
        return false;
      }

      return this.label.toLowerCase().indexOf(this.filter) === -1;
    }
  }
};

/* script */
const __vue_script__$d = script$d;

/* template */
var __vue_render__$d = function () {var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return (!_vm.filtered)?_c('li',{class:{'selected': _vm.checked}},[_c('a',{attrs:{"href":"javascript:void(0)","role":"menuitem"},on:{"click":_vm.check}},[_c('input',{ref:"input",staticStyle:{"display":"none"},attrs:{"type":"radio","name":_vm.name},domProps:{"value":_vm.value,"checked":_vm.checked}}),_vm._v(" "),_vm._t("default"),_vm._v(" "),_c('pf-icon',{directives:[{name:"show",rawName:"v-show",value:(_vm.checked),expression:"checked"}],staticClass:"check-mark",attrs:{"name":"glyphicon-close"}})],2)]):_vm._e()};
var __vue_staticRenderFns__$d = [];

  /* style */
  const __vue_inject_styles__$d = undefined;
  /* scoped */
  const __vue_scope_id__$d = undefined;
  /* module identifier */
  const __vue_module_identifier__$d = undefined;
  /* functional template */
  const __vue_is_functional_template__$d = false;
  /* style inject */
  
  /* style inject SSR */
  
  /* style inject shadow dom */
  

  
  const __vue_component__$d = normalizeComponent(
    { render: __vue_render__$d, staticRenderFns: __vue_staticRenderFns__$d },
    __vue_inject_styles__$d,
    __vue_script__$d,
    __vue_scope_id__$d,
    __vue_is_functional_template__$d,
    __vue_module_identifier__$d,
    false,
    undefined,
    undefined,
    undefined
  );

var script$e = {
  name: 'pf-filter-fields',
  components: {
    PfDropdown: __vue_component__$4,
    PfSelect: __vue_component__$c,
    PfOption: __vue_component__$d
  },
  props: {
    value: {
      type: String,
      default: ''
    },
    fields: {
      type: [Array, Object],
      default: function _default() {
        return {};
      }
    }
  },
  data: function data() {
    return {
      normFields: [],
      selected: 0
    };
  },
  watch: {
    fields: {
      handler: function handler(fields) {
        var normFields = [];

        if (Array.isArray(fields)) {
          var _iteratorNormalCompletion = true;
          var _didIteratorError = false;
          var _iteratorError = undefined;

          try {
            for (var _iterator = fields[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
              var f = _step.value;
              normFields.push(this.fieldDefinition(f));
            }
          } catch (err) {
            _didIteratorError = true;
            _iteratorError = err;
          } finally {
            try {
              if (!_iteratorNormalCompletion && _iterator.return != null) {
                _iterator.return();
              }
            } finally {
              if (_didIteratorError) {
                throw _iteratorError;
              }
            }
          }
        } else {
          for (var _i = 0, _Object$keys = Object.keys(fields); _i < _Object$keys.length; _i++) {
            var i = _Object$keys[_i];
            normFields.push(this.fieldDefinition(fields[i], i));
          }
        }

        this.normFields = normFields;
      },
      immediate: true
    }
  },
  computed: {
    current: function current() {
      var selected = this.selected;

      if (!this.normFields[selected]) {
        if (!this.normFields.length) {
          return {};
        }

        selected = this.normFields[0];
      }

      return this.normFields[selected];
    },
    isSelect: function isSelect() {
      return typeof this.current.values !== 'undefined';
    },
    showDropdown: function showDropdown() {
      return Object.keys(this.normFields).length > 1;
    }
  },
  methods: {
    fieldDefinition: function fieldDefinition(field, name) {
      if (_typeof(field) == 'object') {
        field = Object.assign({}, field);
      } else {
        field = {
          label: field
        };
      }

      field.name = name || field.label;

      if (!field.label) {
        field.label = name;
      }

      return field;
    },
    set: function set(value) {
      if (value !== null) {
        if (_typeof(value) == 'object') {
          value = value.target.value;
        }

        var filter = Object.assign({}, this.current);
        filter.value = value;
        this.$emit('filter', filter);
      }

      if (!this.isSelect) {
        this.$refs.input.value = '';
      }
    }
  }
};

/* script */
const __vue_script__$e = script$e;
/* template */
var __vue_render__$e = function () {var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('div',{staticClass:"input-group"},[(_vm.showDropdown)?_c('pf-dropdown',{staticClass:"input-group-btn",attrs:{"text":_vm.current.label}},_vm._l((_vm.normFields),function(item,name){return _c('li',{key:name},[_c('a',{staticClass:"filter-field",attrs:{"role":"menuitem","tabindex":"-1"},on:{"click":function($event){_vm.selected = name;}}},[_vm._v("\n        "+_vm._s(item.label)+"\n      ")])])}),0):_vm._e(),_vm._v(" "),(_vm.isSelect)?_c('pf-select',{staticClass:"filter-select",attrs:{"close-on-select":"","placeholder":_vm.current.placeholder}},_vm._l((_vm.current.values),function(item,i){return _c('pf-option',{key:i,attrs:{"checked-value":item},on:{"input":_vm.set}},[_vm._v(_vm._s(item))])}),1):_c('div',[_c('input',{ref:"input",staticClass:"form-control",attrs:{"type":"text","placeholder":_vm.showDropdown || _vm.current.placeholder ? _vm.current.placeholder : _vm.current.label},domProps:{"value":_vm.value},on:{"keyup":function($event){if(!$event.type.indexOf('key')&&_vm._k($event.keyCode,"enter",13,$event.key,"Enter")){ return null; }$event.stopPropagation();return _vm.set($event)}}})])],1)};
var __vue_staticRenderFns__$e = [];

  /* style */
  const __vue_inject_styles__$e = undefined;
  /* scoped */
  const __vue_scope_id__$e = undefined;
  /* module identifier */
  const __vue_module_identifier__$e = undefined;
  /* functional template */
  const __vue_is_functional_template__$e = false;
  /* style inject */
  
  /* style inject SSR */
  
  /* style inject shadow dom */
  

  
  const __vue_component__$e = normalizeComponent(
    { render: __vue_render__$e, staticRenderFns: __vue_staticRenderFns__$e },
    __vue_inject_styles__$e,
    __vue_script__$e,
    __vue_scope_id__$e,
    __vue_is_functional_template__$e,
    __vue_module_identifier__$e,
    false,
    undefined,
    undefined,
    undefined
  );

//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
var script$f = {
  name: 'pf-filter-results',
  props: {
    count: Number,
    filters: {
      type: Array,
      default: function _default() {
        return [];
      }
    }
  }
};

/* script */
const __vue_script__$f = script$f;

/* template */
var __vue_render__$f = function () {var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('div',{staticClass:"filter-pf"},[_c('div',{staticClass:"row toolbar-pf-results"},[_c('div',{staticClass:"col-sm-12"},[_c('h5',[_vm._v(_vm._s(_vm.count)+" Results")]),_vm._v(" "),(_vm.filters.length > 0)?_c('p',[_vm._v("Active filters:")]):_vm._e(),_vm._v(" "),_c('ul',{staticClass:"list-inline"},_vm._l((_vm.filters),function(filter,i){return _c('li',{key:i},[_c('span',{staticClass:"active-filter label label-info"},[_vm._v("\n            "+_vm._s(filter.label)+": "+_vm._s(filter.value)+"\n            "),_c('a',[_c('pf-icon',{attrs:{"name":"pficon-close"},on:{"click":function($event){return _vm.$parent.clearFilter(i)}}})],1)])])}),0),_vm._v(" "),_c('p',[(_vm.filters.length > 0)?_c('a',{staticClass:"clear-filters",on:{"click":function($event){return _vm.$parent.clearAllFilters()}}},[_vm._v("Clear All Filters")]):_vm._e()])])])])};
var __vue_staticRenderFns__$f = [];

  /* style */
  const __vue_inject_styles__$f = undefined;
  /* scoped */
  const __vue_scope_id__$f = undefined;
  /* module identifier */
  const __vue_module_identifier__$f = undefined;
  /* functional template */
  const __vue_is_functional_template__$f = false;
  /* style inject */
  
  /* style inject SSR */
  
  /* style inject shadow dom */
  

  
  const __vue_component__$f = normalizeComponent(
    { render: __vue_render__$f, staticRenderFns: __vue_staticRenderFns__$f },
    __vue_inject_styles__$f,
    __vue_script__$f,
    __vue_scope_id__$f,
    __vue_is_functional_template__$f,
    __vue_module_identifier__$f,
    false,
    undefined,
    undefined,
    undefined
  );

//
var script$g = {
  name: 'pf-toast-notification',
  components: {
    PfDropdown: __vue_component__$4
  },
  props: {
    action: Object,
    actions: Array,
    delay: {
      type: Number,
      default: 8000
    },
    type: {
      type: String,
      default: 'info'
    },
    toast: {
      type: Boolean,
      default: false
    },
    persistent: {
      type: Boolean,
      default: false
    }
  },
  computed: {
    showDropdown: function showDropdown() {
      return this.toast && this.actions && this.actions.length;
    },
    alertClass: function alertClass() {
      return "alert-".concat(this.type || 'info');
    },
    buttonClass: function buttonClass() {
      if (!this.action || !this.action.button) {
        return 'btn-link';
      }

      return "btn-".concat(this.action.button);
    },
    typeIcon: function typeIcon() {
      switch (this.type) {
        case 'success':
          return 'pficon-ok';

        case 'danger':
          return 'pficon-error-circle-o';

        case 'warning':
          return 'pficon-warning-triangle-o';

        default:
          return 'pficon-info';
      }
    }
  },
  watch: {
    toast: {
      handler: function handler() {
        this.updateTimeout();
      },
      immediate: true
    },
    delay: function delay() {
      this.updateTimeout();
    },
    persistent: function persistent() {
      this.updateTimeout();
    }
  },
  methods: {
    updateTimeout: function updateTimeout() {
      if (this._timeout) {
        clearTimeout(this._timeout);
      }

      if (this.toast && !this.persistent) {
        this._timeout = setTimeout(this.dismiss, this.delay);
      }
    },
    isSeparator: function isSeparator(action) {
      return action == '-' || action.separator;
    },
    dismiss: function dismiss() {
      this.$emit('dismiss', this); // workaround race conditions in event dispatching and handling in parent component

      if (this.toast && !this.persistent && this.$parent.notifications && this.$parent.notifications.length) {
        setTimeout(this.dismiss, 250);
      }
    },
    triggered: function triggered(action) {
      if (typeof action.handler == 'function') {
        action.handler(action);
      }

      this.$emit(action.emit || 'action', action);
    }
  }
};

/* script */
const __vue_script__$g = script$g;
/* template */
var __vue_render__$g = function () {var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('div',{staticClass:"alert",class:[_vm.alertClass, {
    'alert-dismissable': _vm.persistent,
    'toast-pf': _vm.toast,
  }]},[(_vm.showDropdown)?_c('pf-dropdown',_vm._l((_vm.actions),function(action){return _c('li',{key:action.name,class:{
        divider: _vm.isSeparator(action),
        disabled: action.disabled === true,
      },attrs:{"role":_vm.isSeparator(action) ? 'separator' : 'menuitem'}},[(!_vm.isSeparator(action))?_c('a',{staticClass:"secondary-action",attrs:{"title":action.title},on:{"click":function($event){return _vm.triggered(action)}}},[_vm._v("\n        "+_vm._s(action.name)+"\n      ")]):_vm._e()])}),0):_vm._e(),_vm._v(" "),_c('button',{directives:[{name:"show",rawName:"v-show",value:(_vm.persistent),expression:"persistent"}],staticClass:"close",attrs:{"type":"button","data-dismiss":"alert","aria-hidden":"true"},on:{"click":_vm.dismiss}},[_c('pf-icon',{attrs:{"name":"pficon-close"}})],1),_vm._v(" "),(_vm.action && _vm.action.name)?_c('button',{staticClass:"pull-right btn",class:[_vm.buttonClass],attrs:{"type":"button","title":_vm.action.title},on:{"click":function($event){return _vm.triggered(_vm.action)}}},[_vm._v("\n    "+_vm._s(_vm.action.name)+"\n  ")]):_vm._e(),_vm._v(" "),_c('pf-icon',{attrs:{"name":_vm.typeIcon}}),_vm._v(" "),_vm._t("default")],2)};
var __vue_staticRenderFns__$g = [];

  /* style */
  const __vue_inject_styles__$g = undefined;
  /* scoped */
  const __vue_scope_id__$g = undefined;
  /* module identifier */
  const __vue_module_identifier__$g = undefined;
  /* functional template */
  const __vue_is_functional_template__$g = false;
  /* style inject */
  
  /* style inject SSR */
  
  /* style inject shadow dom */
  

  
  const __vue_component__$g = normalizeComponent(
    { render: __vue_render__$g, staticRenderFns: __vue_staticRenderFns__$g },
    __vue_inject_styles__$g,
    __vue_script__$g,
    __vue_scope_id__$g,
    __vue_is_functional_template__$g,
    __vue_module_identifier__$g,
    false,
    undefined,
    undefined,
    undefined
  );

var script$h = {
  name: 'pf-notifications',
  mixins: [SlotMonitor],
  components: {
    PfNotification: __vue_component__$g
  },
  props: {
    toast: {
      type: Boolean,
      default: false
    },
    persistent: {
      type: Boolean,
      default: false
    }
  },
  data: function data() {
    return {
      notifications: []
    };
  },
  methods: {
    add: function add(notification) {
      var type = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'info';
      var persistent = arguments.length > 2 ? arguments[2] : undefined;

      if (_typeof(notification) != 'object') {
        notification = {
          message: notification,
          type: type,
          persistent: typeof persistent == 'undefined' ? this.persistent : persistent
        };
      }

      this.notifications.push(notification);
    },
    dismiss: function dismiss(i) {
      if (_typeof(i) == 'object') {
        var obj = i;
        i = this.notifications.indexOf(obj);

        if (i < 0) {
          return;
        }
      }

      this.notifications.splice(i, 1);
    }
  }
};

/* script */
const __vue_script__$h = script$h;

/* template */
var __vue_render__$h = function () {var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('div',{directives:[{name:"show",rawName:"v-show",value:(_vm.withSlot.default || _vm.notifications.length),expression:"withSlot.default || notifications.length"}],class:{'toast-notifications-list-pf': _vm.toast}},[_vm._t("default"),_vm._v(" "),_vm._l((_vm.notifications),function(n,i){return _c('pf-notification',{key:i,ref:"notification",refInFor:true,attrs:{"persistent":n.persistent,"type":n.type,"toast":_vm.toast},on:{"dismiss":function($event){return _vm.dismiss(i)}}},[_c('span',{domProps:{"innerHTML":_vm._s(n.message)}})])})],2)};
var __vue_staticRenderFns__$h = [];

  /* style */
  const __vue_inject_styles__$h = undefined;
  /* scoped */
  const __vue_scope_id__$h = undefined;
  /* module identifier */
  const __vue_module_identifier__$h = undefined;
  /* functional template */
  const __vue_is_functional_template__$h = false;
  /* style inject */
  
  /* style inject SSR */
  
  /* style inject shadow dom */
  

  
  const __vue_component__$h = normalizeComponent(
    { render: __vue_render__$h, staticRenderFns: __vue_staticRenderFns__$h },
    __vue_inject_styles__$h,
    __vue_script__$h,
    __vue_scope_id__$h,
    __vue_is_functional_template__$h,
    __vue_module_identifier__$h,
    false,
    undefined,
    undefined,
    undefined
  );

//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
var script$i = {
  name: 'pf-notification-bell',
  props: {
    updates: {
      type: [String, Boolean],
      default: false
    }
  }
};

/* script */
const __vue_script__$i = script$i;

/* template */
var __vue_render__$i = function (_h,_vm) {var _c=_vm._c;return _c('li',[_c('a',_vm._g(_vm._b({staticClass:"nav-item-iconic",class:[_vm.data.class, _vm.data.staticClass],style:([_vm.data.style, _vm.data.staticStyle]),attrs:{"href":"javascript:void(0)"}},'a',_vm.data.attrs,false),_vm.listeners),[_c('pf-icon',{attrs:{"name":"fa-bell","title":"Notifications"}}),_vm._v(" "),(_vm.props.updates !== false)?_c('span',{staticClass:"badge"},[_c('span',{domProps:{"innerHTML":_vm._s(_vm.props.updates)}})]):_vm._e()],1)])};
var __vue_staticRenderFns__$i = [];

  /* style */
  const __vue_inject_styles__$i = undefined;
  /* scoped */
  const __vue_scope_id__$i = undefined;
  /* module identifier */
  const __vue_module_identifier__$i = undefined;
  /* functional template */
  const __vue_is_functional_template__$i = true;
  /* style inject */
  
  /* style inject SSR */
  
  /* style inject shadow dom */
  

  
  const __vue_component__$i = normalizeComponent(
    { render: __vue_render__$i, staticRenderFns: __vue_staticRenderFns__$i },
    __vue_inject_styles__$i,
    __vue_script__$i,
    __vue_scope_id__$i,
    __vue_is_functional_template__$i,
    __vue_module_identifier__$i,
    false,
    undefined,
    undefined,
    undefined
  );

//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
var script$j = {
  name: 'pf-drawer',
  model: {
    prop: 'hidden',
    event: 'update:hidden'
  },
  props: {
    hidden: {
      type: Boolean,
      default: true
    },
    allowExpand: Boolean,
    title: String
  },
  data: function data() {
    return {
      expanded: false
    };
  },
  methods: {
    close: function close() {
      this.$emit('update:hidden', true);
    }
  }
};

/* script */
const __vue_script__$j = script$j;
/* template */
var __vue_render__$j = function () {var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('div',{staticClass:"drawer-pf",class:{
  'hide': _vm.hidden,
  'drawer-pf-expanded': _vm.allowExpand && _vm.expanded,
}},[_vm._t("title",[(_vm.title)?_c('div',{staticClass:"drawer-pf-title"},[(_vm.allowExpand)?_c('a',{staticClass:"drawer-pf-toggle-expand",on:{"click":function($event){_vm.expanded = !_vm.expanded;}}}):_vm._e(),_vm._v(" "),_c('a',{staticClass:"drawer-pf-close",on:{"click":_vm.close}},[_c('pf-icon',{attrs:{"name":"fa-close"}})],1),_vm._v(" "),_c('h3',{staticClass:"text-center"},[_vm._v(_vm._s(_vm.title))])]):_vm._e()]),_vm._v(" "),_c('div',[_c('div',{staticClass:"panel-group"},[_vm._t("default")],2)]),_vm._v(" "),_c('div',{ref:"dropdowns",staticClass:"dropdown-kebab-pf"})],2)};
var __vue_staticRenderFns__$j = [];

  /* style */
  const __vue_inject_styles__$j = undefined;
  /* scoped */
  const __vue_scope_id__$j = undefined;
  /* module identifier */
  const __vue_module_identifier__$j = undefined;
  /* functional template */
  const __vue_is_functional_template__$j = false;
  /* style inject */
  
  /* style inject SSR */
  
  /* style inject shadow dom */
  

  
  const __vue_component__$j = normalizeComponent(
    { render: __vue_render__$j, staticRenderFns: __vue_staticRenderFns__$j },
    __vue_inject_styles__$j,
    __vue_script__$j,
    __vue_scope_id__$j,
    __vue_is_functional_template__$j,
    __vue_module_identifier__$j,
    false,
    undefined,
    undefined,
    undefined
  );

//
var script$k = {
  name: 'pf-drawer-group',
  mixins: [SlotMonitor],
  props: {
    title: String,
    counter: String,
    loading: Boolean
  },
  data: function data() {
    return {
      expanded: false,
      empty: true
    };
  },
  mounted: function mounted() {
    var _this = this;

    this.$parent.$on('groupChanged', function (group) {
      if (group !== _this) {
        _this.close();
      }
    });
  },
  updated: function updated() {
    this.empty = !this.withSlot.default;
  },
  methods: {
    open: function open() {
      this.expanded = true;
    },
    close: function close() {
      this.expanded = false;
    },
    toggle: function toggle() {
      this.expanded = !this.expanded;
    }
  },
  watch: {
    expanded: function expanded(value) {
      if (value) {
        this.$emit('opened', this);
        this.$parent.$emit('groupChanged', this);
      } else {
        this.$emit('closed', this);
      }
    }
  }
};

/* script */
const __vue_script__$k = script$k;
/* template */
var __vue_render__$k = function () {var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('div',{staticClass:"panel panel-default"},[_c('div',{staticClass:"panel-heading"},[_c('h4',{staticClass:"panel-title"},[_c('a',{class:{collapsed: !_vm.expanded},attrs:{"aria-expanded":_vm.expanded ? 'true' : 'false'},on:{"click":_vm.toggle}},[_vm._v("\n        "+_vm._s(_vm.title)+"\n      ")])]),_vm._v(" "),_c('span',{staticClass:"panel-counter"},[_vm._v(_vm._s(_vm.counter))])]),_vm._v(" "),_c('transition',{attrs:{"name":"collapse"}},[_c('div',{directives:[{name:"show",rawName:"v-show",value:(_vm.expanded),expression:"expanded"}],staticClass:"panel-collapse",attrs:{"aria-expanded":_vm.expanded ? 'true' : 'false'}},[(_vm.empty && !_vm.loading)?_c('div',{staticClass:"blank-slate-pf"},[_c('div',{staticClass:"blank-slate-pf-icon"},[_c('pf-icon',{attrs:{"name":"pficon-info"}})],1),_vm._v(" "),_c('h4',{staticClass:"h1 blank-slate-pf-title"},[_vm._v("No Notifications Available")])]):_c('div',{staticClass:"panel-body"},[_vm._t("default"),_vm._v(" "),(_vm.loading)?_c('div',{staticClass:"drawer-pf-loading text-center"},[_c('span',{staticClass:"spinner spinner-xs spinner-inline"}),_vm._v(" Loading\n        ")]):_vm._e()],2),_vm._v(" "),(_vm.withSlot.actions)?_c('div',{staticClass:"drawer-pf-action"},[_vm._t("actions")],2):_vm._e()])])],1)};
var __vue_staticRenderFns__$k = [];

  /* style */
  const __vue_inject_styles__$k = undefined;
  /* scoped */
  const __vue_scope_id__$k = undefined;
  /* module identifier */
  const __vue_module_identifier__$k = undefined;
  /* functional template */
  const __vue_is_functional_template__$k = false;
  /* style inject */
  
  /* style inject SSR */
  
  /* style inject shadow dom */
  

  
  const __vue_component__$k = normalizeComponent(
    { render: __vue_render__$k, staticRenderFns: __vue_staticRenderFns__$k },
    __vue_inject_styles__$k,
    __vue_script__$k,
    __vue_scope_id__$k,
    __vue_is_functional_template__$k,
    __vue_module_identifier__$k,
    false,
    undefined,
    undefined,
    undefined
  );

//
//
//
//
//
//
//
//
var script$l = {
  name: 'pf-drawer-group-action'
};

/* script */
const __vue_script__$l = script$l;

/* template */
var __vue_render__$l = function (_h,_vm) {var _c=_vm._c;return _c('div',{staticClass:"drawer-pf-action-link"},[_c('button',_vm._g(_vm._b({staticClass:"btn btn-link",attrs:{"type":"button"}},'button',_vm.data.attrs,false),_vm.listeners),[_vm._t("default")],2)])};
var __vue_staticRenderFns__$l = [];

  /* style */
  const __vue_inject_styles__$l = undefined;
  /* scoped */
  const __vue_scope_id__$l = undefined;
  /* module identifier */
  const __vue_module_identifier__$l = undefined;
  /* functional template */
  const __vue_is_functional_template__$l = true;
  /* style inject */
  
  /* style inject SSR */
  
  /* style inject shadow dom */
  

  
  const __vue_component__$l = normalizeComponent(
    { render: __vue_render__$l, staticRenderFns: __vue_staticRenderFns__$l },
    __vue_inject_styles__$l,
    __vue_script__$l,
    __vue_scope_id__$l,
    __vue_is_functional_template__$l,
    __vue_module_identifier__$l,
    false,
    undefined,
    undefined,
    undefined
  );

//
var script$m = {
  name: 'pf-drawer-notification',
  mixins: [SlotMonitor],
  components: {
    PfDropdown: __vue_component__$4
  },
  props: {
    action: Object,
    actions: Array,
    message: String,
    date: String,
    time: String,
    unread: Boolean,
    type: {
      type: String,
      default: 'info',
      validator: function validator(type) {
        return ['', null, 'info', 'success', 'warning', 'danger'].indexOf(type) >= 0;
      }
    }
  },
  computed: {
    showDropdown: function showDropdown() {
      return this.withSlot.dropdown || this.actions && this.actions.length;
    },
    buttonClass: function buttonClass() {
      if (!this.action || !this.action.button) {
        return 'btn-link';
      }

      return "btn-".concat(this.action.button);
    },
    typeIcon: function typeIcon() {
      switch (this.type) {
        case 'success':
          return 'pficon-ok';

        case 'danger':
          return 'pficon-error-circle-o';

        case 'warning':
          return 'pficon-warning-triangle-o';

        default:
          return 'pficon-info';
      }
    }
  },
  methods: {
    triggered: function triggered(action) {
      if (typeof action.handler == 'function') {
        action.handler(action);
      }

      this.$emit(action.emit || 'action', action);
    },
    isSeparator: function isSeparator(action) {
      return action == '-' || action.separator;
    }
  }
};

/* script */
const __vue_script__$m = script$m;
/* template */
var __vue_render__$m = function () {var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('div',{staticClass:"drawer-pf-notification",class:{unread: _vm.unread, 'expanded-notification': _vm.$parent.$parent.expanded}},[(_vm.showDropdown)?_c('pf-dropdown',{staticClass:"pull-right dropdown-kebab-pf",attrs:{"type":"link","append-to":_vm.$parent.$parent.$refs.dropdowns,"menu-right":""}},_vm._l((_vm.actions),function(action){return _c('li',{key:action.name,class:{
        divider: _vm.isSeparator(action),
        disabled: action.disabled === true,
      },attrs:{"role":_vm.isSeparator(action) ? 'separator' : 'menuitem'}},[(!_vm.isSeparator(action))?_c('a',{staticClass:"secondary-action",attrs:{"title":action.title},on:{"click":function($event){return _vm.triggered(action)}}},[_vm._v("\n        "+_vm._s(action.name)+"\n      ")]):_vm._e()])}),0):_vm._e(),_vm._v(" "),(_vm.action && _vm.action.name)?_c('button',{staticClass:"pull-right btn",class:[_vm.buttonClass],attrs:{"type":"button","title":_vm.action.title},on:{"click":function($event){return _vm.triggered(_vm.action)}}},[_vm._v("\n    "+_vm._s(_vm.action.name)+"\n  ")]):_vm._e(),_vm._v(" "),_c('pf-icon',{staticClass:"pull-left",attrs:{"name":_vm.typeIcon}}),_vm._v(" "),_c('span',{staticClass:"drawer-pf-notification-message"},[_vm._t("default",[_vm._v(_vm._s(_vm.message))])],2),_vm._v(" "),(_vm.date || _vm.time || _vm.withSlot.info)?_c('span',{staticClass:"drawer-pf-notification-info"},[_vm._t("info",[(_vm.date)?_c('span',{staticClass:"date"},[_vm._v(_vm._s(_vm.date))]):_vm._e(),_vm._v(" "),(_vm.time)?_c('span',{staticClass:"time"},[_vm._v(_vm._s(_vm.time))]):_vm._e()])],2):_vm._e()],1)};
var __vue_staticRenderFns__$m = [];

  /* style */
  const __vue_inject_styles__$m = undefined;
  /* scoped */
  const __vue_scope_id__$m = undefined;
  /* module identifier */
  const __vue_module_identifier__$m = undefined;
  /* functional template */
  const __vue_is_functional_template__$m = false;
  /* style inject */
  
  /* style inject SSR */
  
  /* style inject shadow dom */
  

  
  const __vue_component__$m = normalizeComponent(
    { render: __vue_render__$m, staticRenderFns: __vue_staticRenderFns__$m },
    __vue_inject_styles__$m,
    __vue_script__$m,
    __vue_scope_id__$m,
    __vue_is_functional_template__$m,
    __vue_module_identifier__$m,
    false,
    undefined,
    undefined,
    undefined
  );

//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
var script$n = {
  name: 'pf-expand-collapse',
  model: {
    prop: 'expanded',
    event: 'update:expanded'
  },
  props: {
    alignCenter: Boolean,
    bordered: Boolean,
    textCollapsed: {
      type: String,
      default: 'Show Advanced Options'
    },
    textExpanded: {
      type: String,
      default: 'Hide Advanced Options'
    },
    expanded: {
      type: Boolean,
      default: null
    }
  },
  data: function data() {
    return {
      autoExpanded: this.expanded
    };
  },
  computed: {
    isExpanded: function isExpanded() {
      return this.expanded === null ? this.autoExpanded : this.expanded;
    }
  },
  methods: {
    expand: function expand() {
      this.autoExpanded = true;
    },
    collapse: function collapse() {
      this.autoExpanded = false;
    },
    toggle: function toggle() {
      this.autoExpanded = !this.isExpanded;
    }
  },
  watch: {
    autoExpanded: function autoExpanded() {
      this.$emit('update:expanded', this.autoExpanded);
    }
  }
};

/* script */
const __vue_script__$n = script$n;
/* template */
var __vue_render__$n = function () {var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('div',{staticClass:"expand-collapse-pf"},[_c('div',{staticClass:"expand-collapse-pf-link-container"},[(_vm.alignCenter)?_c('span',{staticClass:"expand-collapse-pf-separator",class:{bordered: _vm.bordered}}):_vm._e(),_vm._v(" "),_c('button',{staticClass:"btn btn-link",attrs:{"type":"button"},on:{"click":_vm.toggle}},[_c('pf-icon',{attrs:{"name":_vm.isExpanded ? 'fa-angle-down' : 'fa-angle-right'}}),_vm._v(" "),(_vm.isExpanded)?[_vm._v(_vm._s(_vm.textExpanded))]:[_vm._v(_vm._s(_vm.textCollapsed))]],2),_vm._v(" "),_c('span',{staticClass:"expand-collapse-pf-separator",class:{bordered: _vm.bordered}})]),_vm._v(" "),(_vm.isExpanded)?_vm._t("default"):_vm._e()],2)};
var __vue_staticRenderFns__$n = [];

  /* style */
  const __vue_inject_styles__$n = undefined;
  /* scoped */
  const __vue_scope_id__$n = undefined;
  /* module identifier */
  const __vue_module_identifier__$n = undefined;
  /* functional template */
  const __vue_is_functional_template__$n = false;
  /* style inject */
  
  /* style inject SSR */
  
  /* style inject shadow dom */
  

  
  const __vue_component__$n = normalizeComponent(
    { render: __vue_render__$n, staticRenderFns: __vue_staticRenderFns__$n },
    __vue_inject_styles__$n,
    __vue_script__$n,
    __vue_scope_id__$n,
    __vue_is_functional_template__$n,
    __vue_module_identifier__$n,
    false,
    undefined,
    undefined,
    undefined
  );

function _typeof$1(obj) {
  if (typeof Symbol === "function" && _typeof(Symbol.iterator) === "symbol") {
    _typeof$1 = function _typeof$1(obj) {
      return _typeof(obj);
    };
  } else {
    _typeof$1 = function _typeof$1(obj) {
      return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : _typeof(obj);
    };
  }

  return _typeof$1(obj);
}

function _toConsumableArray$1(arr) {
  return _arrayWithoutHoles$1(arr) || _iterableToArray$1(arr) || _nonIterableSpread$1();
}

function _arrayWithoutHoles$1(arr) {
  if (Array.isArray(arr)) {
    for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) {
      arr2[i] = arr[i];
    }

    return arr2;
  }
}

function _iterableToArray$1(iter) {
  if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter);
}

function _nonIterableSpread$1() {
  throw new TypeError("Invalid attempt to spread non-iterable instance");
}

var inBrowser = typeof window !== 'undefined';

function freeze(item) {
  if (Array.isArray(item) || _typeof$1(item) === 'object') {
    return Object.freeze(item);
  }

  return item;
}

function combinePassengers(transports) {
  var slotProps = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  return transports.reduce(function (passengers, transport) {
    var temp = transport.passengers[0];
    var newPassengers = typeof temp === 'function' ? temp(slotProps) : transport.passengers;
    return passengers.concat(newPassengers);
  }, []);
}

function stableSort(array, compareFn) {
  return array.map(function (v, idx) {
    return [idx, v];
  }).sort(function (a, b) {
    return compareFn(a[1], b[1]) || a[0] - b[0];
  }).map(function (c) {
    return c[1];
  });
}

function pick(obj, keys) {
  return keys.reduce(function (acc, key) {
    if (obj.hasOwnProperty(key)) {
      acc[key] = obj[key];
    }

    return acc;
  }, {});
}

var transports = {};
var targets = {};
var sources = {};
var Wormhole = Vue.extend({
  data: function data() {
    return {
      transports: transports,
      targets: targets,
      sources: sources,
      trackInstances: inBrowser
    };
  },
  methods: {
    open: function open(transport) {
      if (!inBrowser) return;
      var to = transport.to,
          from = transport.from,
          passengers = transport.passengers,
          _transport$order = transport.order,
          order = _transport$order === void 0 ? Infinity : _transport$order;
      if (!to || !from || !passengers) return;
      var newTransport = {
        to: to,
        from: from,
        passengers: freeze(passengers),
        order: order
      };
      var keys = Object.keys(this.transports);

      if (keys.indexOf(to) === -1) {
        Vue.set(this.transports, to, []);
      }

      var currentIndex = this.$_getTransportIndex(newTransport); // Copying the array here so that the PortalTarget change event will actually contain two distinct arrays

      var newTransports = this.transports[to].slice(0);

      if (currentIndex === -1) {
        newTransports.push(newTransport);
      } else {
        newTransports[currentIndex] = newTransport;
      }

      this.transports[to] = stableSort(newTransports, function (a, b) {
        return a.order - b.order;
      });
    },
    close: function close(transport) {
      var force = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
      var to = transport.to,
          from = transport.from;
      if (!to || !from && force === false) return;

      if (!this.transports[to]) {
        return;
      }

      if (force) {
        this.transports[to] = [];
      } else {
        var index = this.$_getTransportIndex(transport);

        if (index >= 0) {
          // Copying the array here so that the PortalTarget change event will actually contain two distinct arrays
          var newTransports = this.transports[to].slice(0);
          newTransports.splice(index, 1);
          this.transports[to] = newTransports;
        }
      }
    },
    registerTarget: function registerTarget(target, vm, force) {
      if (!inBrowser) return;

      if (this.trackInstances && !force && this.targets[target]) {
        console.warn("[portal-vue]: Target ".concat(target, " already exists"));
      }

      this.$set(this.targets, target, Object.freeze([vm]));
    },
    unregisterTarget: function unregisterTarget(target) {
      this.$delete(this.targets, target);
    },
    registerSource: function registerSource(source, vm, force) {
      if (!inBrowser) return;

      if (this.trackInstances && !force && this.sources[source]) {
        console.warn("[portal-vue]: source ".concat(source, " already exists"));
      }

      this.$set(this.sources, source, Object.freeze([vm]));
    },
    unregisterSource: function unregisterSource(source) {
      this.$delete(this.sources, source);
    },
    hasTarget: function hasTarget(to) {
      return !!(this.targets[to] && this.targets[to][0]);
    },
    hasSource: function hasSource(to) {
      return !!(this.sources[to] && this.sources[to][0]);
    },
    hasContentFor: function hasContentFor(to) {
      return !!this.transports[to] && !!this.transports[to].length;
    },
    // Internal
    $_getTransportIndex: function $_getTransportIndex(_ref) {
      var to = _ref.to,
          from = _ref.from;

      for (var i in this.transports[to]) {
        if (this.transports[to][i].from === from) {
          return +i;
        }
      }

      return -1;
    }
  }
});
var wormhole = new Wormhole(transports);
var _id = 1;
var Portal = Vue.extend({
  name: 'portal',
  props: {
    disabled: {
      type: Boolean
    },
    name: {
      type: String,
      default: function _default() {
        return String(_id++);
      }
    },
    order: {
      type: Number,
      default: 0
    },
    slim: {
      type: Boolean
    },
    slotProps: {
      type: Object,
      default: function _default() {
        return {};
      }
    },
    tag: {
      type: String,
      default: 'DIV'
    },
    to: {
      type: String,
      default: function _default() {
        return String(Math.round(Math.random() * 10000000));
      }
    }
  },
  created: function created() {
    var _this = this;

    this.$nextTick(function () {
      wormhole.registerSource(_this.name, _this);
    });
  },
  mounted: function mounted() {
    if (!this.disabled) {
      this.sendUpdate();
    }
  },
  updated: function updated() {
    if (this.disabled) {
      this.clear();
    } else {
      this.sendUpdate();
    }
  },
  beforeDestroy: function beforeDestroy() {
    wormhole.unregisterSource(this.name);
    this.clear();
  },
  watch: {
    to: function to(newValue, oldValue) {
      oldValue && oldValue !== newValue && this.clear(oldValue);
      this.sendUpdate();
    }
  },
  methods: {
    clear: function clear(target) {
      var closer = {
        from: this.name,
        to: target || this.to
      };
      wormhole.close(closer);
    },
    normalizeSlots: function normalizeSlots() {
      return this.$scopedSlots.default ? [this.$scopedSlots.default] : this.$slots.default;
    },
    normalizeOwnChildren: function normalizeOwnChildren(children) {
      return typeof children === 'function' ? children(this.slotProps) : children;
    },
    sendUpdate: function sendUpdate() {
      var slotContent = this.normalizeSlots();

      if (slotContent) {
        var transport = {
          from: this.name,
          to: this.to,
          passengers: _toConsumableArray$1(slotContent),
          order: this.order
        };
        wormhole.open(transport);
      } else {
        this.clear();
      }
    }
  },
  render: function render(h) {
    var children = this.$slots.default || this.$scopedSlots.default || [];
    var Tag = this.tag;

    if (children && this.disabled) {
      return children.length <= 1 && this.slim ? this.normalizeOwnChildren(children)[0] : h(Tag, [this.normalizeOwnChildren(children)]);
    } else {
      return this.slim ? h() : h(Tag, {
        class: {
          'v-portal': true
        },
        style: {
          display: 'none'
        },
        key: 'v-portal-placeholder'
      });
    }
  }
});
var PortalTarget = Vue.extend({
  name: 'portalTarget',
  props: {
    multiple: {
      type: Boolean,
      default: false
    },
    name: {
      type: String,
      required: true
    },
    slim: {
      type: Boolean,
      default: false
    },
    slotProps: {
      type: Object,
      default: function _default() {
        return {};
      }
    },
    tag: {
      type: String,
      default: 'div'
    },
    transition: {
      type: [String, Object, Function]
    }
  },
  data: function data() {
    return {
      transports: wormhole.transports,
      firstRender: true
    };
  },
  created: function created() {
    var _this = this;

    this.$nextTick(function () {
      wormhole.registerTarget(_this.name, _this);
    });
  },
  watch: {
    ownTransports: function ownTransports() {
      this.$emit('change', this.children().length > 0);
    },
    name: function name(newVal, oldVal) {
      /**
       * TODO
       * This should warn as well ...
       */
      wormhole.unregisterTarget(oldVal);
      wormhole.registerTarget(newVal, this);
    }
  },
  mounted: function mounted() {
    var _this2 = this;

    if (this.transition) {
      this.$nextTick(function () {
        // only when we have a transition, because it causes a re-render
        _this2.firstRender = false;
      });
    }
  },
  beforeDestroy: function beforeDestroy() {
    wormhole.unregisterTarget(this.name);
  },
  computed: {
    ownTransports: function ownTransports() {
      var transports = this.transports[this.name] || [];

      if (this.multiple) {
        return transports;
      }

      return transports.length === 0 ? [] : [transports[transports.length - 1]];
    },
    passengers: function passengers() {
      return combinePassengers(this.ownTransports, this.slotProps);
    }
  },
  methods: {
    // can't be a computed prop because it has to "react" to $slot changes.
    children: function children() {
      return this.passengers.length !== 0 ? this.passengers : this.$scopedSlots.default ? this.$scopedSlots.default(this.slotProps) : this.$slots.default || [];
    },
    // can't be a computed prop because it has to "react" to this.children().
    noWrapper: function noWrapper() {
      var noWrapper = this.slim && !this.transition;

      if (noWrapper && this.children().length > 1) {
        console.warn('[portal-vue]: PortalTarget with `slim` option received more than one child element.');
      }

      return noWrapper;
    }
  },
  render: function render(h) {
    var noWrapper = this.noWrapper();
    var children = this.children();
    var Tag = this.transition || this.tag;
    return noWrapper ? children[0] : this.slim && !Tag ? h() : h(Tag, {
      props: {
        // if we have a transition component, pass the tag if it exists
        tag: this.transition && this.tag ? this.tag : undefined
      },
      class: {
        'vue-portal-target': true
      }
    }, children);
  }
});
var _id$1 = 0;
var portalProps = ['disabled', 'name', 'order', 'slim', 'slotProps', 'tag', 'to'];
var targetProps = ['multiple', 'transition'];
var MountingPortal = Vue.extend({
  name: 'MountingPortal',
  inheritAttrs: false,
  props: {
    append: {
      type: [Boolean, String]
    },
    bail: {
      type: Boolean
    },
    mountTo: {
      type: String,
      required: true
    },
    // Portal
    disabled: {
      type: Boolean
    },
    // name for the portal
    name: {
      type: String,
      default: function _default() {
        return 'mounted_' + String(_id$1++);
      }
    },
    order: {
      type: Number,
      default: 0
    },
    slim: {
      type: Boolean
    },
    slotProps: {
      type: Object,
      default: function _default() {
        return {};
      }
    },
    tag: {
      type: String,
      default: 'DIV'
    },
    // name for the target
    to: {
      type: String,
      default: function _default() {
        return String(Math.round(Math.random() * 10000000));
      }
    },
    // Target
    multiple: {
      type: Boolean,
      default: false
    },
    targetSlim: {
      type: Boolean
    },
    targetSlotProps: {
      type: Object,
      default: function _default() {
        return {};
      }
    },
    targetTag: {
      type: String,
      default: 'div'
    },
    transition: {
      type: [String, Object, Function]
    }
  },
  created: function created() {
    if (typeof document === 'undefined') return;
    var el = document.querySelector(this.mountTo);

    if (!el) {
      console.error("[portal-vue]: Mount Point '".concat(this.mountTo, "' not found in document"));
      return;
    }

    var props = this.$props; // Target already exists

    if (wormhole.targets[props.name]) {
      if (props.bail) {
        console.warn("[portal-vue]: Target ".concat(props.name, " is already mounted.\n        Aborting because 'bail: true' is set"));
      } else {
        this.portalTarget = wormhole.targets[props.name];
      }

      return;
    }

    var append = props.append;

    if (append) {
      var type = typeof append === 'string' ? append : 'DIV';
      var mountEl = document.createElement(type);
      el.appendChild(mountEl);
      el = mountEl;
    } // get props for target from $props
    // we have to rename a few of them


    var _props = pick(this.$props, targetProps);

    _props.slim = this.targetSlim;
    _props.tag = this.targetTag;
    _props.slotProps = this.targetSlotProps;
    _props.name = this.to;
    this.portalTarget = new PortalTarget({
      el: el,
      parent: this.$parent || this,
      propsData: _props
    });
  },
  beforeDestroy: function beforeDestroy() {
    var target = this.portalTarget;

    if (this.append) {
      var el = target.$el;
      el.parentNode.removeChild(el);
    }

    target.$destroy();
  },
  render: function render(h) {
    if (!this.portalTarget) {
      console.warn("[portal-vue] Target wasn't mounted");
      return h();
    } // if there's no "manual" scoped slot, so we create a <Portal> ourselves


    if (!this.$scopedSlots.manual) {
      var props = pick(this.$props, portalProps);
      return h(Portal, {
        props: props,
        attrs: this.$attrs,
        on: this.$listeners,
        scopedSlots: this.$scopedSlots
      }, this.$slots.default);
    } // else, we render the scoped slot


    var content = this.$scopedSlots.manual({
      to: this.to
    }); // if user used <template> for the scoped slot
    // content will be an array

    if (Array.isArray(content)) {
      content = content[0];
    }

    if (!content) return h();
    return content;
  }
});

//
Vue.component('pf-drop-fade', {
  functional: true,
  render: function render(createElement, context) {
    var data = {
      props: {
        name: 'pf-drop-fade',
        mode: 'out-in'
      }
    };
    return createElement('transition-group', data, context.children);
  }
});
var script$o = {
  name: 'pf-modal-target',
  components: {
    PortalTarget: PortalTarget
  }
};

/* script */
const __vue_script__$o = script$o;
/* template */
var __vue_render__$o = function (_h,_vm) {var _c=_vm._c;return _c('portal-target',{attrs:{"name":"modals-target","transition":"pf-drop-fade","multiple":""}})};
var __vue_staticRenderFns__$o = [];

  /* style */
  const __vue_inject_styles__$o = undefined;
  /* scoped */
  const __vue_scope_id__$o = undefined;
  /* module identifier */
  const __vue_module_identifier__$o = undefined;
  /* functional template */
  const __vue_is_functional_template__$o = true;
  /* style inject */
  
  /* style inject SSR */
  
  /* style inject shadow dom */
  

  
  const __vue_component__$o = normalizeComponent(
    { render: __vue_render__$o, staticRenderFns: __vue_staticRenderFns__$o },
    __vue_inject_styles__$o,
    __vue_script__$o,
    __vue_scope_id__$o,
    __vue_is_functional_template__$o,
    __vue_module_identifier__$o,
    false,
    undefined,
    undefined,
    undefined
  );

//
var script$p = {
  name: 'pf-layout',
  components: {
    ModalsTarget: __vue_component__$o,

    /* eslint-disable-next-line vue/no-unused-components */
    PortalTarget: PortalTarget
  },
  props: {
    display: {
      type: String,
      default: 'block',
      validator: function validator(display) {
        return ['block', 'flex', 'grid'].indexOf(display) >= 0;
      }
    },
    icons: Boolean,
    horizontal: Boolean,
    collapsable: Boolean,
    disabled: Boolean,
    nomargin: Boolean,
    horizontalSecondary: Boolean
  },
  data: function data() {
    return {
      collapsed: false,
      secondaryMenus: 0,
      tertiaryMenus: 0,
      width: 1200
    };
  },
  mounted: function mounted() {
    window.addEventListener('resize', this.resize);
    this.resize();
  },
  destroyed: function destroyed() {
    window.removeEventListener('resize', this.resize);
  },
  computed: {
    desktop: function desktop() {
      return this.width >= 1200;
    },
    tablet: function tablet() {
      return this.width < 1200 && this.width >= 768;
    },
    mobile: function mobile() {
      return this.width < 768;
    }
  },
  methods: {
    resize: function resize() {
      var html = document.documentElement;
      this.width = html.offsetWidth;
    },
    updateHtmlClasses: function updateHtmlClasses() {
      var html = document.documentElement;
      html.classList.add('transitions');

      if (this.disabled) {
        html.classList.remove('layout-pf');
        html.classList.remove('layout-pf-fixed');
        html.classList.remove('layout-pf-fixed-grid');
      } else {
        html.classList.add('layout-pf');

        if (this.horizontal) {
          html.classList.remove('layout-pf-fixed');
          html.classList.remove('layout-pf-fixed-grid');
        } else {
          html.classList.add('layout-pf-fixed');

          if (this.display == 'grid') {
            html.classList.add('layout-pf-fixed-grid');
          } else {
            html.classList.remove('layout-pf-fixed-grid');
          }
        }
      }
    }
  },
  watch: {
    horizontal: {
      handler: function handler() {
        this.updateHtmlClasses();
      },
      immediate: true
    },
    disabled: function disabled() {
      this.updateHtmlClasses();
    },
    display: function display() {
      this.updateHtmlClasses();
    },
    desktop: function desktop() {
      if (!this.desktop) {
        this.collapsed = true;
      }
    },
    mobile: function mobile() {
      if (this.mobile) {
        this.collapsed = true;
      }
    },
    collapsed: function collapsed() {
      this.$emit('update:collapsed', this.collapsed);
    }
  }
};

/* script */
const __vue_script__$p = script$p;
/* template */
var __vue_render__$p = function () {var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('div',{class:{
  'pf-layout-flex': _vm.display == 'flex',
  'pf-layout-grid': _vm.display == 'grid',
}},[(!_vm.disabled)?_c('nav',{staticClass:"navbar",class:{
      'navbar-pf': _vm.horizontal,
      'navbar-pf-vertical': !_vm.horizontal,
    },attrs:{"role":"navigation"}},[_c('div',{staticClass:"navbar-header"},[(_vm.collapsable)?_c('button',{staticClass:"navbar-toggle",attrs:{"type":"button"},on:{"click":function($event){_vm.collapsed = !_vm.collapsed;}}},[_c('span',{staticClass:"sr-only"},[_vm._v("Toggle navigation")]),_vm._v(" "),_c('span',{staticClass:"icon-bar"}),_vm._v(" "),_c('span',{staticClass:"icon-bar"}),_vm._v(" "),_c('span',{staticClass:"icon-bar"})]):_vm._e(),_vm._v(" "),_vm._t("brand")],2),_vm._v(" "),_c('div',{staticClass:"collapse navbar-collapse navbar-collapse-1"},[(_vm.horizontal)?_c('ul',{staticClass:"nav navbar-nav navbar-primary",class:{'persistent-secondary': _vm.horizontalSecondary}},[_vm._t("horizontal-menu")],2):_vm._e(),_vm._v(" "),_c('ul',{staticClass:"nav navbar-nav",class:{
        'navbar-utility': _vm.horizontal,
        'navbar-right': !_vm.horizontal,
        'navbar-iconic': !_vm.horizontal,
      }},[_vm._t("utility-menu")],2)])]):_vm._e(),_vm._v(" "),(!_vm.disabled && !_vm.horizontal)?_c('div',{staticClass:"nav-pf-vertical nav-pf-vertical-with-sub-menus",class:{
      collapsed: _vm.collapsed,
      hidden: _vm.mobile,
      'hidden-icons-pf': !_vm.icons,
      'show-mobile-nav': _vm.mobile && !_vm.collapsed,
      'secondary-visible-pf': _vm.secondaryMenus && !_vm.tertiaryMenus && !_vm.tablet,
      'show-mobile-secondary': _vm.secondaryMenus && !_vm.tertiaryMenus && _vm.mobile,
      'hover-secondary-nav-pf': _vm.secondaryMenus || _vm.tertiaryMenus,
      'tertiary-visible-pf': _vm.tertiaryMenus && !_vm.tablet,
      'show-mobile-tertiary': _vm.tertiaryMenus && _vm.mobile,
      'hover-tertiary-nav-pf': _vm.tertiaryMenus,
    }},[_c('ul',{staticClass:"list-group"},[_vm._t("vertical-menu")],2)]):_vm._e(),_vm._v(" "),_c('div',{staticClass:"pf-layout-container",class:{
      'hidden-nav': _vm.mobile,
      'container-flex': !_vm.disabled && _vm.display == 'flex',
      'container-fluid': !_vm.disabled && !_vm.nomargin,
      'collapsed-nav': !_vm.disabled && _vm.collapsed,
      'container-pf-nav-pf-vertical': !_vm.disabled && !_vm.horizontal,
      'hidden-icons-pf': !_vm.disabled && !_vm.icons,
    }},[_vm._t("default"),_vm._v(" "),_c('modals-target')],2)])};
var __vue_staticRenderFns__$p = [];

  /* style */
  const __vue_inject_styles__$p = undefined;
  /* scoped */
  const __vue_scope_id__$p = undefined;
  /* module identifier */
  const __vue_module_identifier__$p = undefined;
  /* functional template */
  const __vue_is_functional_template__$p = false;
  /* style inject */
  
  /* style inject SSR */
  
  /* style inject shadow dom */
  

  
  const __vue_component__$p = normalizeComponent(
    { render: __vue_render__$p, staticRenderFns: __vue_staticRenderFns__$p },
    __vue_inject_styles__$p,
    __vue_script__$p,
    __vue_scope_id__$p,
    __vue_is_functional_template__$p,
    __vue_module_identifier__$p,
    false,
    undefined,
    undefined,
    undefined
  );

/**
 * A collection of shims that provide minimal functionality of the ES6 collections.
 *
 * These implementations are not meant to be used outside of the ResizeObserver
 * modules as they cover only a limited range of use cases.
 */

/* eslint-disable require-jsdoc, valid-jsdoc */
var MapShim = function () {
  if (typeof Map !== 'undefined') {
    return Map;
  }
  /**
   * Returns index in provided array that matches the specified key.
   *
   * @param {Array<Array>} arr
   * @param {*} key
   * @returns {number}
   */


  function getIndex(arr, key) {
    var result = -1;
    arr.some(function (entry, index) {
      if (entry[0] === key) {
        result = index;
        return true;
      }

      return false;
    });
    return result;
  }

  return (
    /** @class */
    function () {
      function class_1() {
        this.__entries__ = [];
      }

      Object.defineProperty(class_1.prototype, "size", {
        /**
         * @returns {boolean}
         */
        get: function get() {
          return this.__entries__.length;
        },
        enumerable: true,
        configurable: true
      });
      /**
       * @param {*} key
       * @returns {*}
       */

      class_1.prototype.get = function (key) {
        var index = getIndex(this.__entries__, key);
        var entry = this.__entries__[index];
        return entry && entry[1];
      };
      /**
       * @param {*} key
       * @param {*} value
       * @returns {void}
       */


      class_1.prototype.set = function (key, value) {
        var index = getIndex(this.__entries__, key);

        if (~index) {
          this.__entries__[index][1] = value;
        } else {
          this.__entries__.push([key, value]);
        }
      };
      /**
       * @param {*} key
       * @returns {void}
       */


      class_1.prototype.delete = function (key) {
        var entries = this.__entries__;
        var index = getIndex(entries, key);

        if (~index) {
          entries.splice(index, 1);
        }
      };
      /**
       * @param {*} key
       * @returns {void}
       */


      class_1.prototype.has = function (key) {
        return !!~getIndex(this.__entries__, key);
      };
      /**
       * @returns {void}
       */


      class_1.prototype.clear = function () {
        this.__entries__.splice(0);
      };
      /**
       * @param {Function} callback
       * @param {*} [ctx=null]
       * @returns {void}
       */


      class_1.prototype.forEach = function (callback, ctx) {
        if (ctx === void 0) {
          ctx = null;
        }

        for (var _i = 0, _a = this.__entries__; _i < _a.length; _i++) {
          var entry = _a[_i];
          callback.call(ctx, entry[1], entry[0]);
        }
      };

      return class_1;
    }()
  );
}();
/**
 * Detects whether window and document objects are available in current environment.
 */


var isBrowser = typeof window !== 'undefined' && typeof document !== 'undefined' && window.document === document; // Returns global object of a current environment.

var global$1 = function () {
  if (typeof global !== 'undefined' && global.Math === Math) {
    return global;
  }

  if (typeof self !== 'undefined' && self.Math === Math) {
    return self;
  }

  if (typeof window !== 'undefined' && window.Math === Math) {
    return window;
  } // eslint-disable-next-line no-new-func


  return Function('return this')();
}();
/**
 * A shim for the requestAnimationFrame which falls back to the setTimeout if
 * first one is not supported.
 *
 * @returns {number} Requests' identifier.
 */


var requestAnimationFrame$1 = function () {
  if (typeof requestAnimationFrame === 'function') {
    // It's required to use a bounded function because IE sometimes throws
    // an "Invalid calling object" error if rAF is invoked without the global
    // object on the left hand side.
    return requestAnimationFrame.bind(global$1);
  }

  return function (callback) {
    return setTimeout(function () {
      return callback(Date.now());
    }, 1000 / 60);
  };
}(); // Defines minimum timeout before adding a trailing call.


var trailingTimeout = 2;
/**
 * Creates a wrapper function which ensures that provided callback will be
 * invoked only once during the specified delay period.
 *
 * @param {Function} callback - Function to be invoked after the delay period.
 * @param {number} delay - Delay after which to invoke callback.
 * @returns {Function}
 */

function throttle(callback, delay) {
  var leadingCall = false,
      trailingCall = false,
      lastCallTime = 0;
  /**
   * Invokes the original callback function and schedules new invocation if
   * the "proxy" was called during current request.
   *
   * @returns {void}
   */

  function resolvePending() {
    if (leadingCall) {
      leadingCall = false;
      callback();
    }

    if (trailingCall) {
      proxy();
    }
  }
  /**
   * Callback invoked after the specified delay. It will further postpone
   * invocation of the original function delegating it to the
   * requestAnimationFrame.
   *
   * @returns {void}
   */


  function timeoutCallback() {
    requestAnimationFrame$1(resolvePending);
  }
  /**
   * Schedules invocation of the original function.
   *
   * @returns {void}
   */


  function proxy() {
    var timeStamp = Date.now();

    if (leadingCall) {
      // Reject immediately following calls.
      if (timeStamp - lastCallTime < trailingTimeout) {
        return;
      } // Schedule new call to be in invoked when the pending one is resolved.
      // This is important for "transitions" which never actually start
      // immediately so there is a chance that we might miss one if change
      // happens amids the pending invocation.


      trailingCall = true;
    } else {
      leadingCall = true;
      trailingCall = false;
      setTimeout(timeoutCallback, delay);
    }

    lastCallTime = timeStamp;
  }

  return proxy;
} // Minimum delay before invoking the update of observers.


var REFRESH_DELAY = 20; // A list of substrings of CSS properties used to find transition events that
// might affect dimensions of observed elements.

var transitionKeys = ['top', 'right', 'bottom', 'left', 'width', 'height', 'size', 'weight']; // Check if MutationObserver is available.

var mutationObserverSupported = typeof MutationObserver !== 'undefined';
/**
 * Singleton controller class which handles updates of ResizeObserver instances.
 */

var ResizeObserverController =
/** @class */
function () {
  /**
   * Creates a new instance of ResizeObserverController.
   *
   * @private
   */
  function ResizeObserverController() {
    /**
     * Indicates whether DOM listeners have been added.
     *
     * @private {boolean}
     */
    this.connected_ = false;
    /**
     * Tells that controller has subscribed for Mutation Events.
     *
     * @private {boolean}
     */

    this.mutationEventsAdded_ = false;
    /**
     * Keeps reference to the instance of MutationObserver.
     *
     * @private {MutationObserver}
     */

    this.mutationsObserver_ = null;
    /**
     * A list of connected observers.
     *
     * @private {Array<ResizeObserverSPI>}
     */

    this.observers_ = [];
    this.onTransitionEnd_ = this.onTransitionEnd_.bind(this);
    this.refresh = throttle(this.refresh.bind(this), REFRESH_DELAY);
  }
  /**
   * Adds observer to observers list.
   *
   * @param {ResizeObserverSPI} observer - Observer to be added.
   * @returns {void}
   */


  ResizeObserverController.prototype.addObserver = function (observer) {
    if (!~this.observers_.indexOf(observer)) {
      this.observers_.push(observer);
    } // Add listeners if they haven't been added yet.


    if (!this.connected_) {
      this.connect_();
    }
  };
  /**
   * Removes observer from observers list.
   *
   * @param {ResizeObserverSPI} observer - Observer to be removed.
   * @returns {void}
   */


  ResizeObserverController.prototype.removeObserver = function (observer) {
    var observers = this.observers_;
    var index = observers.indexOf(observer); // Remove observer if it's present in registry.

    if (~index) {
      observers.splice(index, 1);
    } // Remove listeners if controller has no connected observers.


    if (!observers.length && this.connected_) {
      this.disconnect_();
    }
  };
  /**
   * Invokes the update of observers. It will continue running updates insofar
   * it detects changes.
   *
   * @returns {void}
   */


  ResizeObserverController.prototype.refresh = function () {
    var changesDetected = this.updateObservers_(); // Continue running updates if changes have been detected as there might
    // be future ones caused by CSS transitions.

    if (changesDetected) {
      this.refresh();
    }
  };
  /**
   * Updates every observer from observers list and notifies them of queued
   * entries.
   *
   * @private
   * @returns {boolean} Returns "true" if any observer has detected changes in
   *      dimensions of it's elements.
   */


  ResizeObserverController.prototype.updateObservers_ = function () {
    // Collect observers that have active observations.
    var activeObservers = this.observers_.filter(function (observer) {
      return observer.gatherActive(), observer.hasActive();
    }); // Deliver notifications in a separate cycle in order to avoid any
    // collisions between observers, e.g. when multiple instances of
    // ResizeObserver are tracking the same element and the callback of one
    // of them changes content dimensions of the observed target. Sometimes
    // this may result in notifications being blocked for the rest of observers.

    activeObservers.forEach(function (observer) {
      return observer.broadcastActive();
    });
    return activeObservers.length > 0;
  };
  /**
   * Initializes DOM listeners.
   *
   * @private
   * @returns {void}
   */


  ResizeObserverController.prototype.connect_ = function () {
    // Do nothing if running in a non-browser environment or if listeners
    // have been already added.
    if (!isBrowser || this.connected_) {
      return;
    } // Subscription to the "Transitionend" event is used as a workaround for
    // delayed transitions. This way it's possible to capture at least the
    // final state of an element.


    document.addEventListener('transitionend', this.onTransitionEnd_);
    window.addEventListener('resize', this.refresh);

    if (mutationObserverSupported) {
      this.mutationsObserver_ = new MutationObserver(this.refresh);
      this.mutationsObserver_.observe(document, {
        attributes: true,
        childList: true,
        characterData: true,
        subtree: true
      });
    } else {
      document.addEventListener('DOMSubtreeModified', this.refresh);
      this.mutationEventsAdded_ = true;
    }

    this.connected_ = true;
  };
  /**
   * Removes DOM listeners.
   *
   * @private
   * @returns {void}
   */


  ResizeObserverController.prototype.disconnect_ = function () {
    // Do nothing if running in a non-browser environment or if listeners
    // have been already removed.
    if (!isBrowser || !this.connected_) {
      return;
    }

    document.removeEventListener('transitionend', this.onTransitionEnd_);
    window.removeEventListener('resize', this.refresh);

    if (this.mutationsObserver_) {
      this.mutationsObserver_.disconnect();
    }

    if (this.mutationEventsAdded_) {
      document.removeEventListener('DOMSubtreeModified', this.refresh);
    }

    this.mutationsObserver_ = null;
    this.mutationEventsAdded_ = false;
    this.connected_ = false;
  };
  /**
   * "Transitionend" event handler.
   *
   * @private
   * @param {TransitionEvent} event
   * @returns {void}
   */


  ResizeObserverController.prototype.onTransitionEnd_ = function (_a) {
    var _b = _a.propertyName,
        propertyName = _b === void 0 ? '' : _b; // Detect whether transition may affect dimensions of an element.

    var isReflowProperty = transitionKeys.some(function (key) {
      return !!~propertyName.indexOf(key);
    });

    if (isReflowProperty) {
      this.refresh();
    }
  };
  /**
   * Returns instance of the ResizeObserverController.
   *
   * @returns {ResizeObserverController}
   */


  ResizeObserverController.getInstance = function () {
    if (!this.instance_) {
      this.instance_ = new ResizeObserverController();
    }

    return this.instance_;
  };
  /**
   * Holds reference to the controller's instance.
   *
   * @private {ResizeObserverController}
   */


  ResizeObserverController.instance_ = null;
  return ResizeObserverController;
}();
/**
 * Defines non-writable/enumerable properties of the provided target object.
 *
 * @param {Object} target - Object for which to define properties.
 * @param {Object} props - Properties to be defined.
 * @returns {Object} Target object.
 */


var defineConfigurable = function defineConfigurable(target, props) {
  for (var _i = 0, _a = Object.keys(props); _i < _a.length; _i++) {
    var key = _a[_i];
    Object.defineProperty(target, key, {
      value: props[key],
      enumerable: false,
      writable: false,
      configurable: true
    });
  }

  return target;
};
/**
 * Returns the global object associated with provided element.
 *
 * @param {Object} target
 * @returns {Object}
 */


var getWindowOf = function getWindowOf(target) {
  // Assume that the element is an instance of Node, which means that it
  // has the "ownerDocument" property from which we can retrieve a
  // corresponding global object.
  var ownerGlobal = target && target.ownerDocument && target.ownerDocument.defaultView; // Return the local global object if it's not possible extract one from
  // provided element.

  return ownerGlobal || global$1;
}; // Placeholder of an empty content rectangle.


var emptyRect = createRectInit(0, 0, 0, 0);
/**
 * Converts provided string to a number.
 *
 * @param {number|string} value
 * @returns {number}
 */

function toFloat(value) {
  return parseFloat(value) || 0;
}
/**
 * Extracts borders size from provided styles.
 *
 * @param {CSSStyleDeclaration} styles
 * @param {...string} positions - Borders positions (top, right, ...)
 * @returns {number}
 */


function getBordersSize(styles) {
  var positions = [];

  for (var _i = 1; _i < arguments.length; _i++) {
    positions[_i - 1] = arguments[_i];
  }

  return positions.reduce(function (size, position) {
    var value = styles['border-' + position + '-width'];
    return size + toFloat(value);
  }, 0);
}
/**
 * Extracts paddings sizes from provided styles.
 *
 * @param {CSSStyleDeclaration} styles
 * @returns {Object} Paddings box.
 */


function getPaddings(styles) {
  var positions = ['top', 'right', 'bottom', 'left'];
  var paddings = {};

  for (var _i = 0, positions_1 = positions; _i < positions_1.length; _i++) {
    var position = positions_1[_i];
    var value = styles['padding-' + position];
    paddings[position] = toFloat(value);
  }

  return paddings;
}
/**
 * Calculates content rectangle of provided SVG element.
 *
 * @param {SVGGraphicsElement} target - Element content rectangle of which needs
 *      to be calculated.
 * @returns {DOMRectInit}
 */


function getSVGContentRect(target) {
  var bbox = target.getBBox();
  return createRectInit(0, 0, bbox.width, bbox.height);
}
/**
 * Calculates content rectangle of provided HTMLElement.
 *
 * @param {HTMLElement} target - Element for which to calculate the content rectangle.
 * @returns {DOMRectInit}
 */


function getHTMLElementContentRect(target) {
  // Client width & height properties can't be
  // used exclusively as they provide rounded values.
  var clientWidth = target.clientWidth,
      clientHeight = target.clientHeight; // By this condition we can catch all non-replaced inline, hidden and
  // detached elements. Though elements with width & height properties less
  // than 0.5 will be discarded as well.
  //
  // Without it we would need to implement separate methods for each of
  // those cases and it's not possible to perform a precise and performance
  // effective test for hidden elements. E.g. even jQuery's ':visible' filter
  // gives wrong results for elements with width & height less than 0.5.

  if (!clientWidth && !clientHeight) {
    return emptyRect;
  }

  var styles = getWindowOf(target).getComputedStyle(target);
  var paddings = getPaddings(styles);
  var horizPad = paddings.left + paddings.right;
  var vertPad = paddings.top + paddings.bottom; // Computed styles of width & height are being used because they are the
  // only dimensions available to JS that contain non-rounded values. It could
  // be possible to utilize the getBoundingClientRect if only it's data wasn't
  // affected by CSS transformations let alone paddings, borders and scroll bars.

  var width = toFloat(styles.width),
      height = toFloat(styles.height); // Width & height include paddings and borders when the 'border-box' box
  // model is applied (except for IE).

  if (styles.boxSizing === 'border-box') {
    // Following conditions are required to handle Internet Explorer which
    // doesn't include paddings and borders to computed CSS dimensions.
    //
    // We can say that if CSS dimensions + paddings are equal to the "client"
    // properties then it's either IE, and thus we don't need to subtract
    // anything, or an element merely doesn't have paddings/borders styles.
    if (Math.round(width + horizPad) !== clientWidth) {
      width -= getBordersSize(styles, 'left', 'right') + horizPad;
    }

    if (Math.round(height + vertPad) !== clientHeight) {
      height -= getBordersSize(styles, 'top', 'bottom') + vertPad;
    }
  } // Following steps can't be applied to the document's root element as its
  // client[Width/Height] properties represent viewport area of the window.
  // Besides, it's as well not necessary as the <html> itself neither has
  // rendered scroll bars nor it can be clipped.


  if (!isDocumentElement(target)) {
    // In some browsers (only in Firefox, actually) CSS width & height
    // include scroll bars size which can be removed at this step as scroll
    // bars are the only difference between rounded dimensions + paddings
    // and "client" properties, though that is not always true in Chrome.
    var vertScrollbar = Math.round(width + horizPad) - clientWidth;
    var horizScrollbar = Math.round(height + vertPad) - clientHeight; // Chrome has a rather weird rounding of "client" properties.
    // E.g. for an element with content width of 314.2px it sometimes gives
    // the client width of 315px and for the width of 314.7px it may give
    // 314px. And it doesn't happen all the time. So just ignore this delta
    // as a non-relevant.

    if (Math.abs(vertScrollbar) !== 1) {
      width -= vertScrollbar;
    }

    if (Math.abs(horizScrollbar) !== 1) {
      height -= horizScrollbar;
    }
  }

  return createRectInit(paddings.left, paddings.top, width, height);
}
/**
 * Checks whether provided element is an instance of the SVGGraphicsElement.
 *
 * @param {Element} target - Element to be checked.
 * @returns {boolean}
 */


var isSVGGraphicsElement = function () {
  // Some browsers, namely IE and Edge, don't have the SVGGraphicsElement
  // interface.
  if (typeof SVGGraphicsElement !== 'undefined') {
    return function (target) {
      return target instanceof getWindowOf(target).SVGGraphicsElement;
    };
  } // If it's so, then check that element is at least an instance of the
  // SVGElement and that it has the "getBBox" method.
  // eslint-disable-next-line no-extra-parens


  return function (target) {
    return target instanceof getWindowOf(target).SVGElement && typeof target.getBBox === 'function';
  };
}();
/**
 * Checks whether provided element is a document element (<html>).
 *
 * @param {Element} target - Element to be checked.
 * @returns {boolean}
 */


function isDocumentElement(target) {
  return target === getWindowOf(target).document.documentElement;
}
/**
 * Calculates an appropriate content rectangle for provided html or svg element.
 *
 * @param {Element} target - Element content rectangle of which needs to be calculated.
 * @returns {DOMRectInit}
 */


function getContentRect(target) {
  if (!isBrowser) {
    return emptyRect;
  }

  if (isSVGGraphicsElement(target)) {
    return getSVGContentRect(target);
  }

  return getHTMLElementContentRect(target);
}
/**
 * Creates rectangle with an interface of the DOMRectReadOnly.
 * Spec: https://drafts.fxtf.org/geometry/#domrectreadonly
 *
 * @param {DOMRectInit} rectInit - Object with rectangle's x/y coordinates and dimensions.
 * @returns {DOMRectReadOnly}
 */


function createReadOnlyRect(_a) {
  var x = _a.x,
      y = _a.y,
      width = _a.width,
      height = _a.height; // If DOMRectReadOnly is available use it as a prototype for the rectangle.

  var Constr = typeof DOMRectReadOnly !== 'undefined' ? DOMRectReadOnly : Object;
  var rect = Object.create(Constr.prototype); // Rectangle's properties are not writable and non-enumerable.

  defineConfigurable(rect, {
    x: x,
    y: y,
    width: width,
    height: height,
    top: y,
    right: x + width,
    bottom: height + y,
    left: x
  });
  return rect;
}
/**
 * Creates DOMRectInit object based on the provided dimensions and the x/y coordinates.
 * Spec: https://drafts.fxtf.org/geometry/#dictdef-domrectinit
 *
 * @param {number} x - X coordinate.
 * @param {number} y - Y coordinate.
 * @param {number} width - Rectangle's width.
 * @param {number} height - Rectangle's height.
 * @returns {DOMRectInit}
 */


function createRectInit(x, y, width, height) {
  return {
    x: x,
    y: y,
    width: width,
    height: height
  };
}
/**
 * Class that is responsible for computations of the content rectangle of
 * provided DOM element and for keeping track of it's changes.
 */


var ResizeObservation =
/** @class */
function () {
  /**
   * Creates an instance of ResizeObservation.
   *
   * @param {Element} target - Element to be observed.
   */
  function ResizeObservation(target) {
    /**
     * Broadcasted width of content rectangle.
     *
     * @type {number}
     */
    this.broadcastWidth = 0;
    /**
     * Broadcasted height of content rectangle.
     *
     * @type {number}
     */

    this.broadcastHeight = 0;
    /**
     * Reference to the last observed content rectangle.
     *
     * @private {DOMRectInit}
     */

    this.contentRect_ = createRectInit(0, 0, 0, 0);
    this.target = target;
  }
  /**
   * Updates content rectangle and tells whether it's width or height properties
   * have changed since the last broadcast.
   *
   * @returns {boolean}
   */


  ResizeObservation.prototype.isActive = function () {
    var rect = getContentRect(this.target);
    this.contentRect_ = rect;
    return rect.width !== this.broadcastWidth || rect.height !== this.broadcastHeight;
  };
  /**
   * Updates 'broadcastWidth' and 'broadcastHeight' properties with a data
   * from the corresponding properties of the last observed content rectangle.
   *
   * @returns {DOMRectInit} Last observed content rectangle.
   */


  ResizeObservation.prototype.broadcastRect = function () {
    var rect = this.contentRect_;
    this.broadcastWidth = rect.width;
    this.broadcastHeight = rect.height;
    return rect;
  };

  return ResizeObservation;
}();

var ResizeObserverEntry =
/** @class */
function () {
  /**
   * Creates an instance of ResizeObserverEntry.
   *
   * @param {Element} target - Element that is being observed.
   * @param {DOMRectInit} rectInit - Data of the element's content rectangle.
   */
  function ResizeObserverEntry(target, rectInit) {
    var contentRect = createReadOnlyRect(rectInit); // According to the specification following properties are not writable
    // and are also not enumerable in the native implementation.
    //
    // Property accessors are not being used as they'd require to define a
    // private WeakMap storage which may cause memory leaks in browsers that
    // don't support this type of collections.

    defineConfigurable(this, {
      target: target,
      contentRect: contentRect
    });
  }

  return ResizeObserverEntry;
}();

var ResizeObserverSPI =
/** @class */
function () {
  /**
   * Creates a new instance of ResizeObserver.
   *
   * @param {ResizeObserverCallback} callback - Callback function that is invoked
   *      when one of the observed elements changes it's content dimensions.
   * @param {ResizeObserverController} controller - Controller instance which
   *      is responsible for the updates of observer.
   * @param {ResizeObserver} callbackCtx - Reference to the public
   *      ResizeObserver instance which will be passed to callback function.
   */
  function ResizeObserverSPI(callback, controller, callbackCtx) {
    /**
     * Collection of resize observations that have detected changes in dimensions
     * of elements.
     *
     * @private {Array<ResizeObservation>}
     */
    this.activeObservations_ = [];
    /**
     * Registry of the ResizeObservation instances.
     *
     * @private {Map<Element, ResizeObservation>}
     */

    this.observations_ = new MapShim();

    if (typeof callback !== 'function') {
      throw new TypeError('The callback provided as parameter 1 is not a function.');
    }

    this.callback_ = callback;
    this.controller_ = controller;
    this.callbackCtx_ = callbackCtx;
  }
  /**
   * Starts observing provided element.
   *
   * @param {Element} target - Element to be observed.
   * @returns {void}
   */


  ResizeObserverSPI.prototype.observe = function (target) {
    if (!arguments.length) {
      throw new TypeError('1 argument required, but only 0 present.');
    } // Do nothing if current environment doesn't have the Element interface.


    if (typeof Element === 'undefined' || !(Element instanceof Object)) {
      return;
    }

    if (!(target instanceof getWindowOf(target).Element)) {
      throw new TypeError('parameter 1 is not of type "Element".');
    }

    var observations = this.observations_; // Do nothing if element is already being observed.

    if (observations.has(target)) {
      return;
    }

    observations.set(target, new ResizeObservation(target));
    this.controller_.addObserver(this); // Force the update of observations.

    this.controller_.refresh();
  };
  /**
   * Stops observing provided element.
   *
   * @param {Element} target - Element to stop observing.
   * @returns {void}
   */


  ResizeObserverSPI.prototype.unobserve = function (target) {
    if (!arguments.length) {
      throw new TypeError('1 argument required, but only 0 present.');
    } // Do nothing if current environment doesn't have the Element interface.


    if (typeof Element === 'undefined' || !(Element instanceof Object)) {
      return;
    }

    if (!(target instanceof getWindowOf(target).Element)) {
      throw new TypeError('parameter 1 is not of type "Element".');
    }

    var observations = this.observations_; // Do nothing if element is not being observed.

    if (!observations.has(target)) {
      return;
    }

    observations.delete(target);

    if (!observations.size) {
      this.controller_.removeObserver(this);
    }
  };
  /**
   * Stops observing all elements.
   *
   * @returns {void}
   */


  ResizeObserverSPI.prototype.disconnect = function () {
    this.clearActive();
    this.observations_.clear();
    this.controller_.removeObserver(this);
  };
  /**
   * Collects observation instances the associated element of which has changed
   * it's content rectangle.
   *
   * @returns {void}
   */


  ResizeObserverSPI.prototype.gatherActive = function () {
    var _this = this;

    this.clearActive();
    this.observations_.forEach(function (observation) {
      if (observation.isActive()) {
        _this.activeObservations_.push(observation);
      }
    });
  };
  /**
   * Invokes initial callback function with a list of ResizeObserverEntry
   * instances collected from active resize observations.
   *
   * @returns {void}
   */


  ResizeObserverSPI.prototype.broadcastActive = function () {
    // Do nothing if observer doesn't have active observations.
    if (!this.hasActive()) {
      return;
    }

    var ctx = this.callbackCtx_; // Create ResizeObserverEntry instance for every active observation.

    var entries = this.activeObservations_.map(function (observation) {
      return new ResizeObserverEntry(observation.target, observation.broadcastRect());
    });
    this.callback_.call(ctx, entries, ctx);
    this.clearActive();
  };
  /**
   * Clears the collection of active observations.
   *
   * @returns {void}
   */


  ResizeObserverSPI.prototype.clearActive = function () {
    this.activeObservations_.splice(0);
  };
  /**
   * Tells whether observer has active observations.
   *
   * @returns {boolean}
   */


  ResizeObserverSPI.prototype.hasActive = function () {
    return this.activeObservations_.length > 0;
  };

  return ResizeObserverSPI;
}(); // Registry of internal observers. If WeakMap is not available use current shim
// for the Map collection as it has all required methods and because WeakMap
// can't be fully polyfilled anyway.


var observers = typeof WeakMap !== 'undefined' ? new WeakMap() : new MapShim();
/**
 * ResizeObserver API. Encapsulates the ResizeObserver SPI implementation
 * exposing only those methods and properties that are defined in the spec.
 */

var ResizeObserver =
/** @class */
function () {
  /**
   * Creates a new instance of ResizeObserver.
   *
   * @param {ResizeObserverCallback} callback - Callback that is invoked when
   *      dimensions of the observed elements change.
   */
  function ResizeObserver(callback) {
    if (!(this instanceof ResizeObserver)) {
      throw new TypeError('Cannot call a class as a function.');
    }

    if (!arguments.length) {
      throw new TypeError('1 argument required, but only 0 present.');
    }

    var controller = ResizeObserverController.getInstance();
    var observer = new ResizeObserverSPI(callback, controller, this);
    observers.set(this, observer);
  }

  return ResizeObserver;
}(); // Expose public methods of ResizeObserver.


['observe', 'unobserve', 'disconnect'].forEach(function (method) {
  ResizeObserver.prototype[method] = function () {
    var _a;

    return (_a = observers.get(this))[method].apply(_a, arguments);
  };
});

var index = function () {
  // Export existing implementation if available.
  if (typeof global$1.ResizeObserver !== 'undefined') {
    return global$1.ResizeObserver;
  }

  return ResizeObserver;
}();

//
var script$q = {
  name: 'pf-table-row',
  mixins: [SlotMonitor],
  components: {
    PfDropdown: __vue_component__$4
  },
  props: {
    num: Number,
    selectable: Boolean
  },
  data: function data() {
    return {
      selected: false
    };
  },
  watch: {
    selected: function selected() {
      this.$emit('select', this.selected);
    }
  }
};

/* script */
const __vue_script__$q = script$q;

/* template */
var __vue_render__$q = function () {var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('tr',{class:{selected: _vm.selectable && _vm.selected},attrs:{"role":"row"}},[(_vm.selectable)?_c('td',{staticClass:"table-view-pf-select"},[_c('label',[_c('span',{staticClass:"sr-only"},[_vm._v("Select row "+_vm._s(_vm.num))]),_vm._v(" "),_c('input',{directives:[{name:"model",rawName:"v-model",value:(_vm.selected),expression:"selected"}],attrs:{"type":"checkbox"},domProps:{"checked":Array.isArray(_vm.selected)?_vm._i(_vm.selected,null)>-1:(_vm.selected)},on:{"change":function($event){var $$a=_vm.selected,$$el=$event.target,$$c=$$el.checked?(true):(false);if(Array.isArray($$a)){var $$v=null,$$i=_vm._i($$a,$$v);if($$el.checked){$$i<0&&(_vm.selected=$$a.concat([$$v]));}else{$$i>-1&&(_vm.selected=$$a.slice(0,$$i).concat($$a.slice($$i+1)));}}else{_vm.selected=$$c;}}}})])]):_vm._e(),_vm._v(" "),_vm._t("default"),_vm._v(" "),(_vm.withSlot.action)?_c('td',{staticClass:"table-view-pf-actions"},[_c('div',{staticClass:"table-view-pf-btn"},[_vm._t("action")],2)]):_vm._e(),_vm._v(" "),(_vm.withSlot.dropdown)?_c('td',{staticClass:"table-view-pf-actions"},[_c('pf-dropdown',{attrs:{"menu-right":""}},[_vm._t("dropdown")],2)],1):_vm._e()],2)};
var __vue_staticRenderFns__$q = [];

  /* style */
  const __vue_inject_styles__$q = undefined;
  /* scoped */
  const __vue_scope_id__$q = undefined;
  /* module identifier */
  const __vue_module_identifier__$q = undefined;
  /* functional template */
  const __vue_is_functional_template__$q = false;
  /* style inject */
  
  /* style inject SSR */
  
  /* style inject shadow dom */
  

  
  const __vue_component__$q = normalizeComponent(
    { render: __vue_render__$q, staticRenderFns: __vue_staticRenderFns__$q },
    __vue_inject_styles__$q,
    __vue_script__$q,
    __vue_scope_id__$q,
    __vue_is_functional_template__$q,
    __vue_module_identifier__$q,
    false,
    undefined,
    undefined,
    undefined
  );

/**
 * Checks if `value` is the
 * [language type](http://www.ecma-international.org/ecma-262/7.0/#sec-ecmascript-language-types)
 * of `Object`. (e.g. arrays, functions, objects, regexes, `new Number(0)`, and `new String('')`)
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is an object, else `false`.
 * @example
 *
 * _.isObject({});
 * // => true
 *
 * _.isObject([1, 2, 3]);
 * // => true
 *
 * _.isObject(_.noop);
 * // => true
 *
 * _.isObject(null);
 * // => false
 */
function isObject(value) {
  var type = _typeof(value);

  return value != null && (type == 'object' || type == 'function');
}

/** Detect free variable `global` from Node.js. */
var freeGlobal = (typeof global === "undefined" ? "undefined" : _typeof(global)) == 'object' && global && global.Object === Object && global;

/** Detect free variable `self`. */

var freeSelf = (typeof self === "undefined" ? "undefined" : _typeof(self)) == 'object' && self && self.Object === Object && self;
/** Used as a reference to the global object. */

var root = freeGlobal || freeSelf || Function('return this')();

/**
 * Gets the timestamp of the number of milliseconds that have elapsed since
 * the Unix epoch (1 January 1970 00:00:00 UTC).
 *
 * @static
 * @memberOf _
 * @since 2.4.0
 * @category Date
 * @returns {number} Returns the timestamp.
 * @example
 *
 * _.defer(function(stamp) {
 *   console.log(_.now() - stamp);
 * }, _.now());
 * // => Logs the number of milliseconds it took for the deferred invocation.
 */

var now = function now() {
  return root.Date.now();
};

/** Built-in value references. */

var _Symbol = root.Symbol;

/** Used for built-in method references. */

var objectProto = Object.prototype;
/** Used to check objects for own properties. */

var hasOwnProperty = objectProto.hasOwnProperty;
/**
 * Used to resolve the
 * [`toStringTag`](http://ecma-international.org/ecma-262/7.0/#sec-object.prototype.tostring)
 * of values.
 */

var nativeObjectToString = objectProto.toString;
/** Built-in value references. */

var symToStringTag = _Symbol ? _Symbol.toStringTag : undefined;
/**
 * A specialized version of `baseGetTag` which ignores `Symbol.toStringTag` values.
 *
 * @private
 * @param {*} value The value to query.
 * @returns {string} Returns the raw `toStringTag`.
 */

function getRawTag(value) {
  var isOwn = hasOwnProperty.call(value, symToStringTag),
      tag = value[symToStringTag];

  try {
    value[symToStringTag] = undefined;
    var unmasked = true;
  } catch (e) {}

  var result = nativeObjectToString.call(value);

  if (unmasked) {
    if (isOwn) {
      value[symToStringTag] = tag;
    } else {
      delete value[symToStringTag];
    }
  }

  return result;
}

/** Used for built-in method references. */
var objectProto$1 = Object.prototype;
/**
 * Used to resolve the
 * [`toStringTag`](http://ecma-international.org/ecma-262/7.0/#sec-object.prototype.tostring)
 * of values.
 */

var nativeObjectToString$1 = objectProto$1.toString;
/**
 * Converts `value` to a string using `Object.prototype.toString`.
 *
 * @private
 * @param {*} value The value to convert.
 * @returns {string} Returns the converted string.
 */

function objectToString(value) {
  return nativeObjectToString$1.call(value);
}

/** `Object#toString` result references. */

var nullTag = '[object Null]',
    undefinedTag = '[object Undefined]';
/** Built-in value references. */

var symToStringTag$1 = _Symbol ? _Symbol.toStringTag : undefined;
/**
 * The base implementation of `getTag` without fallbacks for buggy environments.
 *
 * @private
 * @param {*} value The value to query.
 * @returns {string} Returns the `toStringTag`.
 */

function baseGetTag(value) {
  if (value == null) {
    return value === undefined ? undefinedTag : nullTag;
  }

  return symToStringTag$1 && symToStringTag$1 in Object(value) ? getRawTag(value) : objectToString(value);
}

/**
 * Checks if `value` is object-like. A value is object-like if it's not `null`
 * and has a `typeof` result of "object".
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is object-like, else `false`.
 * @example
 *
 * _.isObjectLike({});
 * // => true
 *
 * _.isObjectLike([1, 2, 3]);
 * // => true
 *
 * _.isObjectLike(_.noop);
 * // => false
 *
 * _.isObjectLike(null);
 * // => false
 */
function isObjectLike(value) {
  return value != null && _typeof(value) == 'object';
}

/** `Object#toString` result references. */

var symbolTag = '[object Symbol]';
/**
 * Checks if `value` is classified as a `Symbol` primitive or object.
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a symbol, else `false`.
 * @example
 *
 * _.isSymbol(Symbol.iterator);
 * // => true
 *
 * _.isSymbol('abc');
 * // => false
 */

function isSymbol(value) {
  return _typeof(value) == 'symbol' || isObjectLike(value) && baseGetTag(value) == symbolTag;
}

/** Used as references for various `Number` constants. */

var NAN = 0 / 0;
/** Used to match leading and trailing whitespace. */

var reTrim = /^\s+|\s+$/g;
/** Used to detect bad signed hexadecimal string values. */

var reIsBadHex = /^[-+]0x[0-9a-f]+$/i;
/** Used to detect binary string values. */

var reIsBinary = /^0b[01]+$/i;
/** Used to detect octal string values. */

var reIsOctal = /^0o[0-7]+$/i;
/** Built-in method references without a dependency on `root`. */

var freeParseInt = parseInt;
/**
 * Converts `value` to a number.
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to process.
 * @returns {number} Returns the number.
 * @example
 *
 * _.toNumber(3.2);
 * // => 3.2
 *
 * _.toNumber(Number.MIN_VALUE);
 * // => 5e-324
 *
 * _.toNumber(Infinity);
 * // => Infinity
 *
 * _.toNumber('3.2');
 * // => 3.2
 */

function toNumber(value) {
  if (typeof value == 'number') {
    return value;
  }

  if (isSymbol(value)) {
    return NAN;
  }

  if (isObject(value)) {
    var other = typeof value.valueOf == 'function' ? value.valueOf() : value;
    value = isObject(other) ? other + '' : other;
  }

  if (typeof value != 'string') {
    return value === 0 ? value : +value;
  }

  value = value.replace(reTrim, '');
  var isBinary = reIsBinary.test(value);
  return isBinary || reIsOctal.test(value) ? freeParseInt(value.slice(2), isBinary ? 2 : 8) : reIsBadHex.test(value) ? NAN : +value;
}

/** Error message constants. */

var FUNC_ERROR_TEXT = 'Expected a function';
/* Built-in method references for those with the same name as other `lodash` methods. */

var nativeMax = Math.max,
    nativeMin = Math.min;
/**
 * Creates a debounced function that delays invoking `func` until after `wait`
 * milliseconds have elapsed since the last time the debounced function was
 * invoked. The debounced function comes with a `cancel` method to cancel
 * delayed `func` invocations and a `flush` method to immediately invoke them.
 * Provide `options` to indicate whether `func` should be invoked on the
 * leading and/or trailing edge of the `wait` timeout. The `func` is invoked
 * with the last arguments provided to the debounced function. Subsequent
 * calls to the debounced function return the result of the last `func`
 * invocation.
 *
 * **Note:** If `leading` and `trailing` options are `true`, `func` is
 * invoked on the trailing edge of the timeout only if the debounced function
 * is invoked more than once during the `wait` timeout.
 *
 * If `wait` is `0` and `leading` is `false`, `func` invocation is deferred
 * until to the next tick, similar to `setTimeout` with a timeout of `0`.
 *
 * See [David Corbacho's article](https://css-tricks.com/debouncing-throttling-explained-examples/)
 * for details over the differences between `_.debounce` and `_.throttle`.
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Function
 * @param {Function} func The function to debounce.
 * @param {number} [wait=0] The number of milliseconds to delay.
 * @param {Object} [options={}] The options object.
 * @param {boolean} [options.leading=false]
 *  Specify invoking on the leading edge of the timeout.
 * @param {number} [options.maxWait]
 *  The maximum time `func` is allowed to be delayed before it's invoked.
 * @param {boolean} [options.trailing=true]
 *  Specify invoking on the trailing edge of the timeout.
 * @returns {Function} Returns the new debounced function.
 * @example
 *
 * // Avoid costly calculations while the window size is in flux.
 * jQuery(window).on('resize', _.debounce(calculateLayout, 150));
 *
 * // Invoke `sendMail` when clicked, debouncing subsequent calls.
 * jQuery(element).on('click', _.debounce(sendMail, 300, {
 *   'leading': true,
 *   'trailing': false
 * }));
 *
 * // Ensure `batchLog` is invoked once after 1 second of debounced calls.
 * var debounced = _.debounce(batchLog, 250, { 'maxWait': 1000 });
 * var source = new EventSource('/stream');
 * jQuery(source).on('message', debounced);
 *
 * // Cancel the trailing debounced invocation.
 * jQuery(window).on('popstate', debounced.cancel);
 */

function debounce(func, wait, options) {
  var lastArgs,
      lastThis,
      maxWait,
      result,
      timerId,
      lastCallTime,
      lastInvokeTime = 0,
      leading = false,
      maxing = false,
      trailing = true;

  if (typeof func != 'function') {
    throw new TypeError(FUNC_ERROR_TEXT);
  }

  wait = toNumber(wait) || 0;

  if (isObject(options)) {
    leading = !!options.leading;
    maxing = 'maxWait' in options;
    maxWait = maxing ? nativeMax(toNumber(options.maxWait) || 0, wait) : maxWait;
    trailing = 'trailing' in options ? !!options.trailing : trailing;
  }

  function invokeFunc(time) {
    var args = lastArgs,
        thisArg = lastThis;
    lastArgs = lastThis = undefined;
    lastInvokeTime = time;
    result = func.apply(thisArg, args);
    return result;
  }

  function leadingEdge(time) {
    // Reset any `maxWait` timer.
    lastInvokeTime = time; // Start the timer for the trailing edge.

    timerId = setTimeout(timerExpired, wait); // Invoke the leading edge.

    return leading ? invokeFunc(time) : result;
  }

  function remainingWait(time) {
    var timeSinceLastCall = time - lastCallTime,
        timeSinceLastInvoke = time - lastInvokeTime,
        timeWaiting = wait - timeSinceLastCall;
    return maxing ? nativeMin(timeWaiting, maxWait - timeSinceLastInvoke) : timeWaiting;
  }

  function shouldInvoke(time) {
    var timeSinceLastCall = time - lastCallTime,
        timeSinceLastInvoke = time - lastInvokeTime; // Either this is the first call, activity has stopped and we're at the
    // trailing edge, the system time has gone backwards and we're treating
    // it as the trailing edge, or we've hit the `maxWait` limit.

    return lastCallTime === undefined || timeSinceLastCall >= wait || timeSinceLastCall < 0 || maxing && timeSinceLastInvoke >= maxWait;
  }

  function timerExpired() {
    var time = now();

    if (shouldInvoke(time)) {
      return trailingEdge(time);
    } // Restart the timer.


    timerId = setTimeout(timerExpired, remainingWait(time));
  }

  function trailingEdge(time) {
    timerId = undefined; // Only invoke if we have `lastArgs` which means `func` has been
    // debounced at least once.

    if (trailing && lastArgs) {
      return invokeFunc(time);
    }

    lastArgs = lastThis = undefined;
    return result;
  }

  function cancel() {
    if (timerId !== undefined) {
      clearTimeout(timerId);
    }

    lastInvokeTime = 0;
    lastArgs = lastCallTime = lastThis = timerId = undefined;
  }

  function flush() {
    return timerId === undefined ? result : trailingEdge(now());
  }

  function debounced() {
    var time = now(),
        isInvoking = shouldInvoke(time);
    lastArgs = arguments;
    lastThis = this;
    lastCallTime = time;

    if (isInvoking) {
      if (timerId === undefined) {
        return leadingEdge(lastCallTime);
      }

      if (maxing) {
        // Handle invocations in a tight loop.
        clearTimeout(timerId);
        timerId = setTimeout(timerExpired, wait);
        return invokeFunc(lastCallTime);
      }
    }

    if (timerId === undefined) {
      timerId = setTimeout(timerExpired, wait);
    }

    return result;
  }

  debounced.cancel = cancel;
  debounced.flush = flush;
  return debounced;
}

//
var script$r = {
  name: 'pf-table',
  mixins: [SlotMonitor],
  components: {
    PfTableRow: __vue_component__$q
  },
  props: {
    page: Number,
    totalItems: {
      type: Number,
      default: 0
    },
    itemsPerPage: {
      type: Number,
      default: 25
    },
    itemsPerPageOptions: {
      type: Array,
      default: function _default() {
        return [10, 25, 50, 100, 500];
      }
    },
    columns: {
      type: Array,
      default: function _default() {
        return [];
      }
    },
    rows: {
      type: Array,
      default: function _default() {
        return [];
      }
    },
    keyName: String,
    striped: Boolean,
    bordered: Boolean,
    hover: Boolean,
    selectable: Boolean,
    scrollable: Boolean,
    sortable: Boolean,
    sortBy: String,
    sortDirection: String
  },
  data: function data() {
    return {
      headHeight: 27,
      paginationHeight: 38,
      showClones: false
    };
  },
  mounted: function mounted() {
    var _this = this;

    this.syncHeaders = debounce(this.syncHeaders, 50);
    this.headObserver = new index(function (entries) {
      if (!_this.scrollable) {
        return;
      }

      var theadClone = _this.$refs['thead-clone'];

      if (!theadClone) {
        return;
      }

      var _iteratorNormalCompletion = true;
      var _didIteratorError = false;
      var _iteratorError = undefined;

      try {
        for (var _iterator = entries[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
          var entry = _step.value;

          if (!entry.target.parentElement) {
            continue;
          }

          if (entry.target.tagName == 'THEAD') {
            _this.headHeight = theadClone.clientHeight;
          } else {
            _this.syncHeaders();
          }
        }
      } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion && _iterator.return != null) {
            _iterator.return();
          }
        } finally {
          if (_didIteratorError) {
            throw _iteratorError;
          }
        }
      }
    });
    this.paginationObserver = new index(function (entries) {
      if (!_this.scrollable) {
        return;
      }

      var _iteratorNormalCompletion2 = true;
      var _didIteratorError2 = false;
      var _iteratorError2 = undefined;

      try {
        for (var _iterator2 = entries[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
          var entry = _step2.value;

          if (entry.target == _this.$refs.pagination) {
            _this.paginationHeight = _this.$refs.pagination.clientHeight;
            break;
          }
        }
      } catch (err) {
        _didIteratorError2 = true;
        _iteratorError2 = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion2 && _iterator2.return != null) {
            _iterator2.return();
          }
        } finally {
          if (_didIteratorError2) {
            throw _iteratorError2;
          }
        }
      }
    });
    this.scrollableUnwatch = this.$watch('scrollable', function () {
      if (_this.scrollable) {
        _this.showClones = false;

        _this.headObserver.observe(_this.$refs.thead);

        _this.paginationObserver.observe(_this.$refs.pagination.$el);

        _this.observeThead();
      } else {
        _this.headObserver.disconnect();

        _this.paginationObserver.disconnect();
      }
    }, {
      immediate: true
    });
  },
  destroyed: function destroyed() {
    this.headObserver.disconnect();
    this.paginationObserver.disconnect();
    this.scrollableUnwatch();
  },
  computed: {
    actionSpan: function actionSpan() {
      var colspan = 0;

      if (this.withSlot.action) {
        colspan++;
      }

      if (this.withSlot.dropdown) {
        colspan++;
      }

      return colspan;
    }
  },
  methods: {
    setSortBy: function setSortBy(field, direction) {
      this.$emit('sort-by', field, direction);
      this.$emit('update:sortBy', field);
      this.$emit('update:sortDirection', direction);
    },
    changeSelectAll: function changeSelectAll(e) {
      this.setAllSelected(e.target.checked);
    },
    setAllSelected: function setAllSelected() {
      var selected = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : true;
      var _iteratorNormalCompletion3 = true;
      var _didIteratorError3 = false;
      var _iteratorError3 = undefined;

      try {
        for (var _iterator3 = this.$refs.row[Symbol.iterator](), _step3; !(_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done); _iteratorNormalCompletion3 = true) {
          var row = _step3.value;
          row.selected = selected;
        }
      } catch (err) {
        _didIteratorError3 = true;
        _iteratorError3 = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion3 && _iterator3.return != null) {
            _iterator3.return();
          }
        } finally {
          if (_didIteratorError3) {
            throw _iteratorError3;
          }
        }
      }
    },
    getSelected: function getSelected() {
      var selected = [];
      var _iteratorNormalCompletion4 = true;
      var _didIteratorError4 = false;
      var _iteratorError4 = undefined;

      try {
        for (var _iterator4 = this.$refs.row[Symbol.iterator](), _step4; !(_iteratorNormalCompletion4 = (_step4 = _iterator4.next()).done); _iteratorNormalCompletion4 = true) {
          var row = _step4.value;
          var id = row.num;

          if (typeof id != 'undefined' && row.selected && this.rows[id]) {
            selected.push(this.rows[id]);
          }
        }
      } catch (err) {
        _didIteratorError4 = true;
        _iteratorError4 = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion4 && _iterator4.return != null) {
            _iterator4.return();
          }
        } finally {
          if (_didIteratorError4) {
            throw _iteratorError4;
          }
        }
      }

      return selected;
    },
    observeThead: function observeThead() {
      var row = this.$refs.thead.firstChild;

      for (var i = 0; i < row.children.length; i++) {
        if (i == 0 && this.selectable) {
          continue;
        }

        this.headObserver.observe(row.children[i]);
      }
    },
    syncHeaders: function syncHeaders() {
      if (!this.$refs['thead-clone'] || !this.$refs.thead) {
        return;
      }

      var ths = this.$refs.thead.firstChild.children;
      var thsC = this.$refs['thead-clone'].firstChild.children;
      var i = 0;
      var _iteratorNormalCompletion5 = true;
      var _didIteratorError5 = false;
      var _iteratorError5 = undefined;

      try {
        for (var _iterator5 = ths[Symbol.iterator](), _step5; !(_iteratorNormalCompletion5 = (_step5 = _iterator5.next()).done); _iteratorNormalCompletion5 = true) {
          var th = _step5.value;

          if (i == 0 && this.selectable) {
            i++;
            continue;
          }

          var thC = thsC[i];

          if (i == thsC.length - 1) {
            thC.style.width = 'auto';
          } else {
            thC.style.width = "".concat(th.clientWidth + 1, "px");
          }

          i++;
        }
      } catch (err) {
        _didIteratorError5 = true;
        _iteratorError5 = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion5 && _iterator5.return != null) {
            _iterator5.return();
          }
        } finally {
          if (_didIteratorError5) {
            throw _iteratorError5;
          }
        }
      }

      this.showClones = true;
    }
  },
  watch: {
    columns: {
      handler: function handler() {
        this.$nextTick(this.observeThead);
      },
      deep: true
    }
  }
};

/* script */
const __vue_script__$r = script$r;
/* template */
var __vue_render__$r = function () {var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('div',{staticClass:"table-wrapper"},[(_vm.scrollable)?_c('table',{staticClass:"table dataTable table-head-clone",class:{
      'table-striped': _vm.striped,
      'table-bordered': _vm.bordered,
      'table-hover': _vm.hover,
    },style:({
      opacity: _vm.showClones ? 1 : 0,
    })},[_c('thead',{ref:"thead-clone"},[_c('tr',[(_vm.selectable)?_c('th',{staticClass:"table-view-pf-select",attrs:{"aria-label":"Select all rows"}},[_c('label',[_c('span',{staticClass:"sr-only"},[_vm._v("Select all rows")]),_vm._v(" "),_c('input',{attrs:{"type":"checkbox"},on:{"change":_vm.changeSelectAll}})])]):_vm._e(),_vm._v(" "),_vm._l((_vm.columns),function(column,i){return _c('th',{key:i,class:{
            sorting: _vm.sortable && column != _vm.sortBy,
            sorting_asc: _vm.sortable && column == _vm.sortBy && _vm.sortDirection == 'asc',
            sorting_desc: _vm.sortable && column == _vm.sortBy && _vm.sortDirection == 'desc',
          },on:{"click":function($event){return _vm.setSortBy(column, column != _vm.sortBy || _vm.sortDirection == 'desc' ? 'asc' : 'desc')}}},[_vm._v(_vm._s(column))])}),_vm._v(" "),(_vm.actionSpan)?_c('th',{attrs:{"colspan":_vm.actionSpan}},[_vm._v("Actions")]):_vm._e()],2)])]):_vm._e(),_vm._v(" "),_c('div',{staticClass:"table-overflow-container"},[_c('table',{staticClass:"table dataTable",class:{
      'table-striped': _vm.striped,
      'table-bordered': _vm.bordered,
      'table-hover': _vm.hover,
    },style:({
      'margin-top': _vm.scrollable ? ("-" + (_vm.headHeight + 1) + "px") : 0,
    }),attrs:{"role":"grid"}},[_c('thead',{ref:"thead"},[_c('tr',{attrs:{"role":"row"}},[(_vm.selectable)?_c('th',{staticClass:"table-view-pf-select",attrs:{"aria-label":"Select all rows"}},[_c('label',[_c('span',{staticClass:"sr-only"},[_vm._v("Select all rows")]),_vm._v(" "),_c('input',{attrs:{"type":"checkbox"},on:{"change":_vm.changeSelectAll}})])]):_vm._e(),_vm._v(" "),_vm._l((_vm.columns),function(column,i){return _c('th',{key:i,class:{
              sorting: _vm.sortable && column != _vm.sortBy,
              sorting_asc: _vm.sortable && column == _vm.sortBy && _vm.sortDirection == 'asc',
              sorting_desc: _vm.sortable && column == _vm.sortBy && _vm.sortDirection == 'desc',
            },on:{"click":function($event){return _vm.setSortBy(column, column != _vm.sortBy || _vm.sortDirection == 'desc' ? 'asc' : 'desc')}}},[_vm._v(_vm._s(column))])}),_vm._v(" "),(_vm.actionSpan)?_c('th',{attrs:{"colspan":_vm.actionSpan}},[_vm._v("Actions")]):_vm._e()],2)]),_vm._v(" "),_c('tbody',_vm._l((_vm.rows),function(row,i){return _c('pf-table-row',{key:_vm.keyName ? row[_vm.keyName] : i,ref:"row",refInFor:true,attrs:{"num":i,"selectable":_vm.selectable},scopedSlots:_vm._u([(_vm.withSlot.action)?{key:"action",fn:function(){return [_vm._t("action",null,{"row":row})]},proxy:true}:null,(_vm.withSlot.dropdown)?{key:"dropdown",fn:function(){return [_vm._t("dropdown",null,{"row":row})]},proxy:true}:null],null,true)},[_vm._t("default",null,{"row":row})],2)}),1)])]),_vm._v(" "),(_vm.itemsPerPage > 0)?_c('pf-paginate-control',{ref:"pagination",attrs:{"type":"table","page":_vm.page,"total-items":_vm.totalItems,"items-per-page":_vm.itemsPerPage,"items-per-page-options":_vm.itemsPerPageOptions},on:{"update:itemsPerPage":function($event){return _vm.$emit('update:itemsPerPage', $event)},"change":function($event){return _vm.$emit('update:page', arguments[0])}}},[_vm._t("footer")],2):_vm._e()],1)};
var __vue_staticRenderFns__$r = [];

  /* style */
  const __vue_inject_styles__$r = undefined;
  /* scoped */
  const __vue_scope_id__$r = undefined;
  /* module identifier */
  const __vue_module_identifier__$r = undefined;
  /* functional template */
  const __vue_is_functional_template__$r = false;
  /* style inject */
  
  /* style inject SSR */
  
  /* style inject shadow dom */
  

  
  const __vue_component__$r = normalizeComponent(
    { render: __vue_render__$r, staticRenderFns: __vue_staticRenderFns__$r },
    __vue_inject_styles__$r,
    __vue_script__$r,
    __vue_scope_id__$r,
    __vue_is_functional_template__$r,
    __vue_module_identifier__$r,
    false,
    undefined,
    undefined,
    undefined
  );

//
var script$s = {
  name: 'pf-paginate-control',
  mixins: [SlotMonitor],
  components: {
    PfSelect: __vue_component__$c,
    PfOption: __vue_component__$d
  },
  model: {
    prop: 'page',
    event: 'change'
  },
  props: {
    page: Number,
    type: {
      type: String,
      default: 'list',
      validator: function validator(type) {
        return ['list', 'card', 'table'].indexOf(type) >= 0;
      }
    },
    totalItems: {
      type: Number,
      default: 0
    },
    itemsPerPage: {
      type: Number,
      default: 25
    },
    itemsPerPageOptions: {
      type: Array,
      default: function _default() {
        return [10, 25, 50, 100, 500];
      }
    },
    labelFirstPage: {
      type: String,
      default: 'First Page'
    },
    labelLastPage: {
      type: String,
      default: 'Last Page'
    },
    labelPreviousPage: {
      type: String,
      default: 'Previous Page'
    },
    labelNextPage: {
      type: String,
      default: 'Next Page'
    },
    labelCurrentPage: {
      type: String,
      default: 'Current Page'
    },
    labelOf: {
      type: String,
      default: 'of'
    },
    labelPerPage: {
      type: String,
      default: 'per page'
    }
  },
  computed: {
    pages: function pages() {
      return Math.ceil(this.totalItems / this.itemsPerPage);
    },
    firstItem: function firstItem() {
      return (this.page - 1) * this.itemsPerPage + 1;
    },
    lastItem: function lastItem() {
      return Math.min(this.page * this.itemsPerPage, this.totalItems);
    }
  },
  methods: {
    setPage: function setPage(page) {
      page = Math.max(Math.min(page, this.pages), 1);

      if (!isNaN(page) && page !== this.page) {
        this.$emit('change', page);
      }
    },
    openPerPageSelect: function openPerPageSelect() {
      this.$refs.perpage.focus();
      this.$refs.perpage.open();
    }
  }
};

/* script */
const __vue_script__$s = script$s;
/* template */
var __vue_render__$s = function () {var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('form',{staticClass:"content-view-pf-pagination clearfix",class:[(_vm.type + "-view-pf-pagination")],attrs:{"aria-label":"Search results pages"}},[(_vm.itemsPerPageOptions && _vm.itemsPerPageOptions.length)?_c('div',{staticClass:"form-group"},[_c('pf-select',{ref:"perpage",staticClass:"pagination-pf-pagesize",attrs:{"button":"","close-on-select":""}},_vm._l((_vm.itemsPerPageOptions),function(item,i){return _c('pf-option',{key:i,attrs:{"value":_vm.itemsPerPage,"checked-value":item},on:{"input":function($event){return _vm.$emit('update:itemsPerPage', $event)}}},[_vm._v(_vm._s(item))])}),1),_vm._v(" "),_c('span',{on:{"click":function($event){$event.stopPropagation();return _vm.openPerPageSelect($event)}}},[_vm._v(_vm._s(_vm.labelPerPage))])],1):_vm._e(),_vm._v(" "),(_vm.withSlot.default)?_c('div',{staticClass:"form-group"},[_vm._t("default")],2):_vm._e(),_vm._v(" "),_c('div',{staticClass:"form-group"},[_vm._v("\n    "+_vm._s(_vm.firstItem)+"-"+_vm._s(_vm.lastItem)+" "+_vm._s(_vm.labelOf)+" "+_vm._s(_vm.totalItems)+"\n    "),_c('ul',{staticClass:"pagination pagination-pf-back"},[_c('li',{class:{disabled: _vm.page == 1}},[_c('a',{attrs:{"href":"javascript:void(0)","title":_vm.labelFirstPage},on:{"click":function($event){return _vm.setPage(1)}}},[_c('pf-icon',{staticClass:"i",attrs:{"name":"fa-angle-double-left"}})],1)]),_vm._v(" "),_c('li',{class:{disabled: _vm.page <= 1}},[_c('a',{attrs:{"href":"javascript:void(0)","title":_vm.labelPreviousPage},on:{"click":function($event){return _vm.setPage(_vm.page - 1)}}},[_c('pf-icon',{staticClass:"i",attrs:{"name":"fa-angle-left"}})],1)])]),_vm._v(" "),_c('label',{staticClass:"sr-only",attrs:{"for":"`pf-paginate-control-input-${_uid}`"}},[_vm._v(_vm._s(_vm.labelCurrentPage))]),_vm._v(" "),_c('input',{staticClass:"pagination-pf-page",style:({
        width: (_vm.pages.toString().length * .8 + 1.5) + 'em'
      }),attrs:{"id":("pf-paginate-control-input-" + _vm._uid),"type":"text"},domProps:{"value":_vm.page},on:{"change":function($event){return _vm.setPage($event.target.value)}}}),_vm._v("\n    "+_vm._s(_vm.labelOf)+" "+_vm._s(_vm.pages)+"\n\n    "),_c('ul',{staticClass:"pagination pagination-pf-forward"},[_c('li',{class:{disabled: _vm.page >= _vm.pages}},[_c('a',{attrs:{"href":"javascript:void(0)","title":_vm.labelNextPage},on:{"click":function($event){return _vm.setPage(_vm.page + 1)}}},[_c('pf-icon',{staticClass:"i",attrs:{"name":"fa-angle-right"}})],1)]),_vm._v(" "),_c('li',{class:{disabled: _vm.page >= _vm.pages}},[_c('a',{attrs:{"href":"javascript:void(0)","title":_vm.labelLastPage},on:{"click":function($event){return _vm.setPage(_vm.pages)}}},[_c('pf-icon',{staticClass:"i",attrs:{"name":"fa-angle-double-right"}})],1)])])])])};
var __vue_staticRenderFns__$s = [];

  /* style */
  const __vue_inject_styles__$s = undefined;
  /* scoped */
  const __vue_scope_id__$s = undefined;
  /* module identifier */
  const __vue_module_identifier__$s = undefined;
  /* functional template */
  const __vue_is_functional_template__$s = false;
  /* style inject */
  
  /* style inject SSR */
  
  /* style inject shadow dom */
  

  
  const __vue_component__$s = normalizeComponent(
    { render: __vue_render__$s, staticRenderFns: __vue_staticRenderFns__$s },
    __vue_inject_styles__$s,
    __vue_script__$s,
    __vue_scope_id__$s,
    __vue_is_functional_template__$s,
    __vue_module_identifier__$s,
    false,
    undefined,
    undefined,
    undefined
  );

function isExist(obj) {
  return typeof obj !== 'undefined' && obj !== null;
}
function isFunction(obj) {
  return typeof obj === 'function';
}
function isString(obj) {
  return typeof obj === 'string';
}

var EVENTS = {
  MOUSE_ENTER: 'mouseenter',
  MOUSE_LEAVE: 'mouseleave',
  FOCUS: 'focus',
  BLUR: 'blur',
  CLICK: 'click',
  INPUT: 'input',
  KEY_DOWN: 'keydown',
  KEY_UP: 'keyup',
  KEY_PRESS: 'keypress',
  RESIZE: 'resize',
  SCROLL: 'scroll',
  TOUCH_START: 'touchstart',
  TOUCH_END: 'touchend'
};
var TRIGGERS = {
  CLICK: 'click',
  HOVER: 'hover',
  FOCUS: 'focus',
  HOVER_FOCUS: 'hover-focus',
  OUTSIDE_CLICK: 'outside-click',
  MANUAL: 'manual'
};
var PLACEMENTS = {
  TOP: 'top',
  RIGHT: 'right',
  BOTTOM: 'bottom',
  LEFT: 'left'
};
function getViewportSize() {
  var width = Math.max(document.documentElement.clientWidth, window.innerWidth || 0);
  var height = Math.max(document.documentElement.clientHeight, window.innerHeight || 0);
  return {
    width: width,
    height: height
  };
}
function on(element, event, handler) {
  element.addEventListener(event, handler);
}
function off(element, event, handler) {
  element.removeEventListener(event, handler);
}
function isElement(el) {
  return el && el.nodeType === Node.ELEMENT_NODE;
}
function removeFromDom(el) {
  isElement(el) && isElement(el.parentNode) && el.parentNode.removeChild(el);
}
function ensureElementMatchesFunction() {
  if (!Element.prototype.matches) {
    Element.prototype.matches = Element.prototype.matchesSelector || Element.prototype.mozMatchesSelector || Element.prototype.msMatchesSelector || Element.prototype.oMatchesSelector || Element.prototype.webkitMatchesSelector || function (s) {
      var matches = (this.document || this.ownerDocument).querySelectorAll(s);
      var i = matches.length;

      while (--i >= 0 && matches.item(i) !== this) {}

      return i > -1;
    };
  }
}
function addClass(el, className) {
  if (!isElement(el)) {
    return;
  }

  if (el.className) {
    var classes = el.className.split(' ');

    if (classes.indexOf(className) < 0) {
      classes.push(className);
      el.className = classes.join(' ');
    }
  } else {
    el.className = className;
  }
}
function removeClass(el, className) {
  if (!isElement(el)) {
    return;
  }

  if (el.className) {
    var classes = el.className.split(' ');
    var newClasses = [];

    for (var i = 0, l = classes.length; i < l; i++) {
      if (classes[i] !== className) {
        newClasses.push(classes[i]);
      }
    }

    el.className = newClasses.join(' ');
  }
}
function hasClass(el, className) {
  if (!isElement(el)) {
    return false;
  }

  var classes = el.className.split(' ');

  for (var i = 0, l = classes.length; i < l; i++) {
    if (classes[i] === className) {
      return true;
    }
  }

  return false;
}
function isAvailableAtPosition(trigger, popup, placement) {
  var triggerRect = trigger.getBoundingClientRect();
  var popupRect = popup.getBoundingClientRect();
  var viewPortSize = getViewportSize();
  var top = true;
  var right = true;
  var bottom = true;
  var left = true;

  switch (placement) {
    case PLACEMENTS.TOP:
      top = triggerRect.top >= popupRect.height;
      left = triggerRect.left + triggerRect.width / 2 >= popupRect.width / 2;
      right = triggerRect.right - triggerRect.width / 2 + popupRect.width / 2 <= viewPortSize.width;
      break;

    case PLACEMENTS.BOTTOM:
      bottom = triggerRect.bottom + popupRect.height <= viewPortSize.height;
      left = triggerRect.left + triggerRect.width / 2 >= popupRect.width / 2;
      right = triggerRect.right - triggerRect.width / 2 + popupRect.width / 2 <= viewPortSize.width;
      break;

    case PLACEMENTS.RIGHT:
      right = triggerRect.right + popupRect.width <= viewPortSize.width;
      top = triggerRect.top + triggerRect.height / 2 >= popupRect.height / 2;
      bottom = triggerRect.bottom - triggerRect.height / 2 + popupRect.height / 2 <= viewPortSize.height;
      break;

    case PLACEMENTS.LEFT:
      left = triggerRect.left >= popupRect.width;
      top = triggerRect.top + triggerRect.height / 2 >= popupRect.height / 2;
      bottom = triggerRect.bottom - triggerRect.height / 2 + popupRect.height / 2 <= viewPortSize.height;
      break;
  }

  return top && right && bottom && left;
}
function setTooltipPosition(tooltip, trigger, placement, auto, appendToSelector, viewport) {
  var isPopover = tooltip && tooltip.className && tooltip.className.indexOf('popover') >= 0;
  var containerScrollTop;
  var containerScrollLeft;

  if (!isExist(appendToSelector) || appendToSelector === 'body') {
    var doc = document.documentElement;
    containerScrollLeft = (window.pageXOffset || doc.scrollLeft) - (doc.clientLeft || 0);
    containerScrollTop = (window.pageYOffset || doc.scrollTop) - (doc.clientTop || 0);
  } else {
    var container = document.querySelector(appendToSelector);
    containerScrollLeft = container.scrollLeft;
    containerScrollTop = container.scrollTop;
  } // auto adjust placement


  if (auto) {
    // Try: right -> bottom -> left -> top
    // Cause the default placement is top
    var placements = [PLACEMENTS.RIGHT, PLACEMENTS.BOTTOM, PLACEMENTS.LEFT, PLACEMENTS.TOP]; // The class switch helper function

    var changePlacementClass = function changePlacementClass(placement) {
      // console.log(placement)
      placements.forEach(function (placement) {
        removeClass(tooltip, placement);
      });
      addClass(tooltip, placement);
    }; // No need to adjust if the default placement fits


    if (!isAvailableAtPosition(trigger, tooltip, placement)) {
      for (var i = 0, l = placements.length; i < l; i++) {
        // Re-assign placement class
        changePlacementClass(placements[i]); // Break if new placement fits

        if (isAvailableAtPosition(trigger, tooltip, placements[i])) {
          placement = placements[i];
          break;
        }
      }

      changePlacementClass(placement);
    }
  } // fix left and top for tooltip


  var rect = trigger.getBoundingClientRect();
  var tooltipRect = tooltip.getBoundingClientRect();
  var top;
  var left;

  if (placement === PLACEMENTS.BOTTOM) {
    top = containerScrollTop + rect.top + rect.height;
    left = containerScrollLeft + rect.left + rect.width / 2 - tooltipRect.width / 2;
  } else if (placement === PLACEMENTS.LEFT) {
    top = containerScrollTop + rect.top + rect.height / 2 - tooltipRect.height / 2;
    left = containerScrollLeft + rect.left - tooltipRect.width;
  } else if (placement === PLACEMENTS.RIGHT) {
    top = containerScrollTop + rect.top + rect.height / 2 - tooltipRect.height / 2; // https://github.com/wxsms/uiv/issues/272
    // add 1px to fix above issue

    left = containerScrollLeft + rect.left + rect.width + 1;
  } else {
    top = containerScrollTop + rect.top - tooltipRect.height;
    left = containerScrollLeft + rect.left + rect.width / 2 - tooltipRect.width / 2;
  }

  var viewportEl; // viewport option

  if (isString(viewport)) {
    viewportEl = document.querySelector(viewport);
  } else if (isFunction(viewport)) {
    viewportEl = viewport(trigger);
  }

  if (isElement(viewportEl)) {
    var popoverFix = isPopover ? 11 : 0;
    var viewportReact = viewportEl.getBoundingClientRect();
    var viewportTop = containerScrollTop + viewportReact.top;
    var viewportLeft = containerScrollLeft + viewportReact.left;
    var viewportBottom = viewportTop + viewportReact.height;
    var viewportRight = viewportLeft + viewportReact.width; // fix top

    if (top < viewportTop) {
      top = viewportTop;
    } else if (top + tooltipRect.height > viewportBottom) {
      top = viewportBottom - tooltipRect.height;
    } // fix left


    if (left < viewportLeft) {
      left = viewportLeft;
    } else if (left + tooltipRect.width > viewportRight) {
      left = viewportRight - tooltipRect.width;
    } // fix for popover pointer


    if (placement === PLACEMENTS.BOTTOM) {
      top -= popoverFix;
    } else if (placement === PLACEMENTS.LEFT) {
      left += popoverFix;
    } else if (placement === PLACEMENTS.RIGHT) {
      left -= popoverFix;
    } else {
      top += popoverFix;
    }
  } // set position finally


  tooltip.style.top = "".concat(top, "px");
  tooltip.style.left = "".concat(left, "px");
}

var SHOW_CLASS = 'in';
var popupMixin = {
  props: {
    value: {
      type: Boolean,
      default: false
    },
    tag: {
      type: String,
      default: 'span'
    },
    placement: {
      type: String,
      default: PLACEMENTS.TOP
    },
    autoPlacement: {
      type: Boolean,
      default: true
    },
    appendTo: {
      type: String,
      default: 'body'
    },
    transitionDuration: {
      type: Number,
      default: 150
    },
    hideDelay: {
      type: Number,
      default: 0
    },
    showDelay: {
      type: Number,
      default: 0
    },
    enable: {
      type: Boolean,
      default: true
    },
    enterable: {
      type: Boolean,
      default: true
    },
    target: null,
    viewport: null,
    customClass: String
  },
  data: function data() {
    return {
      triggerEl: null,
      hideTimeoutId: 0,
      showTimeoutId: 0,
      transitionTimeoutId: 0
    };
  },
  watch: {
    value: function value(v) {
      v ? this.show() : this.hide();
    },
    trigger: function trigger() {
      this.clearListeners();
      this.initListeners();
    },
    target: function target(value) {
      this.clearListeners();
      this.initTriggerElByTarget(value);
      this.initListeners();
    },
    allContent: function allContent(value) {
      var _this = this;

      // can not use value because it can not detect slot changes
      if (this.isNotEmpty()) {
        // reset position while content changed & is shown
        // nextTick is required
        this.$nextTick(function () {
          if (_this.isShown()) {
            _this.resetPosition();
          }
        });
      } else {
        this.hide();
      }
    },
    enable: function enable(value) {
      // hide if enable changed to false
      if (!value) {
        this.hide();
      }
    }
  },
  mounted: function mounted() {
    var _this2 = this;

    ensureElementMatchesFunction();
    removeFromDom(this.$refs.popup);
    this.$nextTick(function () {
      _this2.initTriggerElByTarget(_this2.target);

      _this2.initListeners();

      if (_this2.value) {
        _this2.show();
      }
    });
  },
  beforeDestroy: function beforeDestroy() {
    this.clearListeners();
    removeFromDom(this.$refs.popup);
  },
  methods: {
    initTriggerElByTarget: function initTriggerElByTarget(target) {
      if (target) {
        // target exist
        if (isString(target)) {
          // is selector
          this.triggerEl = document.querySelector(target);
        } else if (isElement(target)) {
          // is element
          this.triggerEl = target;
        } else if (isElement(target.$el)) {
          // is component
          this.triggerEl = target.$el;
        }
      } else {
        // find special element
        var trigger = this.$el.querySelector('[data-role="trigger"]');

        if (trigger) {
          this.triggerEl = trigger;
        } else {
          // use the first child
          var firstChild = this.$el.firstChild;
          this.triggerEl = firstChild === this.$refs.popup ? null : firstChild;
        }
      }
    },
    initListeners: function initListeners() {
      if (this.triggerEl) {
        if (this.trigger === TRIGGERS.HOVER) {
          on(this.triggerEl, EVENTS.MOUSE_ENTER, this.show);
          on(this.triggerEl, EVENTS.MOUSE_LEAVE, this.hide);
        } else if (this.trigger === TRIGGERS.FOCUS) {
          on(this.triggerEl, EVENTS.FOCUS, this.show);
          on(this.triggerEl, EVENTS.BLUR, this.hide);
        } else if (this.trigger === TRIGGERS.HOVER_FOCUS) {
          on(this.triggerEl, EVENTS.MOUSE_ENTER, this.handleAuto);
          on(this.triggerEl, EVENTS.MOUSE_LEAVE, this.handleAuto);
          on(this.triggerEl, EVENTS.FOCUS, this.handleAuto);
          on(this.triggerEl, EVENTS.BLUR, this.handleAuto);
        } else if (this.trigger === TRIGGERS.CLICK || this.trigger === TRIGGERS.OUTSIDE_CLICK) {
          on(this.triggerEl, EVENTS.CLICK, this.toggle);
        }
      }

      on(window, EVENTS.CLICK, this.windowClicked);
    },
    clearListeners: function clearListeners() {
      if (this.triggerEl) {
        off(this.triggerEl, EVENTS.FOCUS, this.show);
        off(this.triggerEl, EVENTS.BLUR, this.hide);
        off(this.triggerEl, EVENTS.MOUSE_ENTER, this.show);
        off(this.triggerEl, EVENTS.MOUSE_LEAVE, this.hide);
        off(this.triggerEl, EVENTS.CLICK, this.toggle);
        off(this.triggerEl, EVENTS.MOUSE_ENTER, this.handleAuto);
        off(this.triggerEl, EVENTS.MOUSE_LEAVE, this.handleAuto);
        off(this.triggerEl, EVENTS.FOCUS, this.handleAuto);
        off(this.triggerEl, EVENTS.BLUR, this.handleAuto);
      }

      off(window, EVENTS.CLICK, this.windowClicked);
    },
    resetPosition: function resetPosition() {
      var popup = this.$refs.popup;
      setTooltipPosition(popup, this.triggerEl, this.placement, this.autoPlacement, this.appendTo, this.viewport);
      popup.offsetHeight;
    },
    hideOnLeave: function hideOnLeave() {
      if (this.trigger === TRIGGERS.HOVER || this.trigger === TRIGGERS.HOVER_FOCUS && !this.triggerEl.matches(':focus')) {
        this.$hide();
      }
    },
    toggle: function toggle() {
      if (this.isShown()) {
        this.hide();
      } else {
        this.show();
      }
    },
    show: function show() {
      var _this3 = this;

      if (this.enable && this.triggerEl && this.isNotEmpty() && !this.isShown()) {
        var popup = this.$refs.popup;
        var popUpAppendedContainer = this.hideTimeoutId > 0; // weird condition

        if (popUpAppendedContainer) {
          clearTimeout(this.hideTimeoutId);
          this.hideTimeoutId = 0;
        }

        if (this.transitionTimeoutId > 0) {
          clearTimeout(this.transitionTimeoutId);
          this.transitionTimeoutId = 0;
        }

        this.showTimeoutId = setTimeout(function () {
          // add to dom
          if (!popUpAppendedContainer) {
            popup.className = "".concat(_this3.name, " ").concat(_this3.placement, " ").concat(_this3.customClass ? _this3.customClass : '', " fade");
            var container = document.querySelector(_this3.appendTo);
            container.appendChild(popup);

            _this3.resetPosition();
          }

          addClass(popup, SHOW_CLASS);

          _this3.$emit('input', true);

          _this3.$emit('show');
        }, this.showDelay);
      }
    },
    hide: function hide() {
      var _this4 = this;

      if (this.showTimeoutId > 0) {
        clearTimeout(this.showTimeoutId);
        this.showTimeoutId = 0;
      }

      if (!this.isShown()) {
        return;
      }

      if (this.enterable && (this.trigger === TRIGGERS.HOVER || this.trigger === TRIGGERS.HOVER_FOCUS)) {
        setTimeout(function () {
          if (!_this4.$refs.popup.matches(':hover')) {
            _this4.$hide();
          }
        }, 100);
      } else {
        this.$hide();
      }
    },
    $hide: function $hide() {
      var _this5 = this;

      if (this.isShown()) {
        clearTimeout(this.hideTimeoutId);
        this.hideTimeoutId = setTimeout(function () {
          _this5.hideTimeoutId = 0;
          removeClass(_this5.$refs.popup, SHOW_CLASS); // gives fade out time

          _this5.transitionTimeoutId = setTimeout(function () {
            _this5.transitionTimeoutId = 0;
            removeFromDom(_this5.$refs.popup);

            _this5.$emit('input', false);

            _this5.$emit('hide');
          }, _this5.transitionDuration);
        }, this.hideDelay);
      }
    },
    isShown: function isShown() {
      return hasClass(this.$refs.popup, SHOW_CLASS);
    },
    windowClicked: function windowClicked(event) {
      if (this.triggerEl && isFunction(this.triggerEl.contains) && !this.triggerEl.contains(event.target) && this.trigger === TRIGGERS.OUTSIDE_CLICK && !this.$refs.popup.contains(event.target) && this.isShown()) {
        this.hide();
      }
    },
    handleAuto: function handleAuto() {
      var _this6 = this;

      setTimeout(function () {
        if (_this6.triggerEl.matches(':hover, :focus')) {
          _this6.show();
        } else {
          _this6.hide();
        }
      }, 20); // 20ms make firefox happy
    }
  }
};

var script$t = {
  mixins: [popupMixin],
  data: function data() {
    return {
      name: 'tooltip'
    };
  },
  render: function render(h) {
    return h(this.tag, [this.$slots.default, h('div', {
      ref: 'popup',
      attrs: {
        role: 'tooltip'
      },
      on: {
        mouseleave: this.hideOnLeave
      }
    }, [h('div', {
      'class': 'tooltip-arrow'
    }), h('div', {
      'class': 'tooltip-inner',
      domProps: {
        innerHTML: this.text
      }
    })])]);
  },
  props: {
    text: {
      type: String,
      default: ''
    },
    trigger: {
      type: String,
      default: TRIGGERS.HOVER_FOCUS
    }
  },
  computed: {
    allContent: function allContent() {
      return this.text;
    }
  },
  methods: {
    isNotEmpty: function isNotEmpty() {
      return this.text;
    }
  }
};

/* script */
const __vue_script__$t = script$t;

/* template */

  /* style */
  const __vue_inject_styles__$t = undefined;
  /* scoped */
  const __vue_scope_id__$t = undefined;
  /* module identifier */
  const __vue_module_identifier__$t = undefined;
  /* functional template */
  const __vue_is_functional_template__$t = undefined;
  /* style inject */
  
  /* style inject SSR */
  
  /* style inject shadow dom */
  

  
  const __vue_component__$t = normalizeComponent(
    {},
    __vue_inject_styles__$t,
    __vue_script__$t,
    __vue_scope_id__$t,
    __vue_is_functional_template__$t,
    __vue_module_identifier__$t,
    false,
    undefined,
    undefined,
    undefined
  );

var INSTANCE = '_uiv_tooltip_instance';

var bind = function bind(el, binding) {
  // console.log('bind')
  unbind(el);
  var Constructor = Vue.extend(__vue_component__$t);
  var vm = new Constructor({
    propsData: {
      target: el,
      appendTo: binding.arg && '#' + binding.arg,
      text: typeof binding.value === 'string' ? binding.value && binding.value.toString() : binding.value && binding.value.text && binding.value.text.toString(),
      viewport: binding.value && binding.value.viewport && binding.value.viewport.toString(),
      customClass: binding.value && binding.value.customClass && binding.value.customClass.toString()
    }
  });
  var options = [];

  for (var key in binding.modifiers) {
    if (binding.modifiers.hasOwnProperty(key) && binding.modifiers[key]) {
      options.push(key);
    }
  }

  options.forEach(function (option) {
    if (/(top)|(left)|(right)|(bottom)/.test(option)) {
      vm.placement = option;
    } else if (/(hover)|(focus)|(click)/.test(option)) {
      vm.trigger = option;
    } else if (/unenterable/.test(option)) {
      vm.enterable = false;
    }
  });
  vm.$mount();
  el[INSTANCE] = vm;
};

var unbind = function unbind(el) {
  // console.log('unbind')
  var vm = el[INSTANCE];

  if (vm) {
    vm.$destroy();
  }

  delete el[INSTANCE];
};

var update = function update(el, binding) {
  // console.log('update')
  if (binding.value !== binding.oldValue) {
    bind(el, binding);
  }
};

var Tooltip = {
  bind: bind,
  unbind: unbind,
  update: update
};

//
var script$u = {
  name: 'pf-vertical-nav-divider',
  directives: {
    Tooltip: Tooltip
  },
  props: {
    title: String
  },
  data: function data() {
    return {
      collapsed: false
    };
  },
  computed: {
    tooltip: function tooltip() {
      return this.collapsed ? this.title : null;
    }
  },
  mounted: function mounted() {
    var _this = this;

    var layout = this.layout();

    if (layout) {
      layout.$on('update:collapsed', function (collapsed) {
        _this.collapsed = collapsed;
      });
      this.collapsed = layout.collapsed;
    }
  },
  methods: {
    layout: function layout() {
      var parent = this.$parent;

      while (parent) {
        if (typeof parent.secondaryMenus != 'undefined') {
          return parent;
        }

        parent = parent.$parent;
      }

      return null;
    }
  }
};

/* script */
const __vue_script__$u = script$u;
/* template */
var __vue_render__$t = function () {var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('li',{directives:[{name:"tooltip",rawName:"v-tooltip.right",value:(_vm.tooltip),expression:"tooltip",modifiers:{"right":true}}],staticClass:"list-group-item vertical-header-pf"},[_c('span',{staticClass:"list-group-item-value"},[_vm._t("default",[_vm._v(_vm._s(_vm.title))])],2)])};
var __vue_staticRenderFns__$t = [];

  /* style */
  const __vue_inject_styles__$u = undefined;
  /* scoped */
  const __vue_scope_id__$u = undefined;
  /* module identifier */
  const __vue_module_identifier__$u = undefined;
  /* functional template */
  const __vue_is_functional_template__$u = false;
  /* style inject */
  
  /* style inject SSR */
  
  /* style inject shadow dom */
  

  
  const __vue_component__$u = normalizeComponent(
    { render: __vue_render__$t, staticRenderFns: __vue_staticRenderFns__$t },
    __vue_inject_styles__$u,
    __vue_script__$u,
    __vue_scope_id__$u,
    __vue_is_functional_template__$u,
    __vue_module_identifier__$u,
    false,
    undefined,
    undefined,
    undefined
  );

//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
var script$v = {
  name: 'pf-vertical-submenu',
  props: {
    title: {
      type: String,
      required: true
    },
    icon: String
  },
  data: function data() {
    return {
      active: false,
      tertiary: false
    };
  },
  mounted: function mounted() {
    this.tertiary = this.$parent.$el.classList.contains('secondary-nav-item-pf');
  },
  methods: {
    delayOpen: function delayOpen() {
      var _this = this;

      if (this.closeTimeout) {
        clearTimeout(this.closeTimeout);
        this.closeTimeout = false;
      }

      if (!this.active && !this.openTimeout) {
        this.openTimeout = setTimeout(function () {
          _this.openTimeout = false;
          _this.active = true;
        }, 500);
      }
    },
    delayClose: function delayClose() {
      var _this2 = this;

      if (this.openTimeout) {
        clearTimeout(this.openTimeout);
        this.openTimeout = false;
      }

      if (this.active && !this.closeTimeout) {
        this.closeTimeout = setTimeout(function () {
          _this2.closeTimeout = false;
          _this2.active = false;
        }, 1000);
      }
    },
    layout: function layout() {
      var parent = this.$parent;

      while (parent) {
        if (typeof parent.secondaryMenus != 'undefined') {
          return parent;
        }

        parent = parent.$parent;
      }

      return null;
    }
  },
  watch: {
    active: function active() {
      var layout = this.layout();

      if (!layout) {
        return;
      }

      layout[this.tertiary ? 'tertiaryMenus' : 'secondaryMenus'] += this.active ? +1 : -1;
    }
  }
};

/* script */
const __vue_script__$v = script$v;

/* template */
var __vue_render__$u = function () {var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('pf-menu-item',{class:{
    'secondary-nav-item-pf': !_vm.tertiary,
    'tertiary-nav-item-pf': _vm.tertiary,
    'is-hover': _vm.active,
    'mobile-nav-item-pf': _vm.active,
  },attrs:{"vertical":"","title":_vm.title,"icon":_vm.icon},on:{"click":function($event){_vm.active = !_vm.active;},"mouseenter":_vm.delayOpen,"mouseleave":_vm.delayClose}},[_c('div',{class:{
      'nav-pf-secondary-nav': !_vm.tertiary,
      'nav-pf-tertiary-nav': _vm.tertiary,
    }},[_c('div',{staticClass:"nav-item-pf-header"},[_c('a',{class:{
          'secondary-collapse-toggle-pf': !_vm.tertiary,
          'tertiary-collapse-toggle-pf': _vm.tertiary,
        },on:{"click":function($event){_vm.active = false;}}}),_vm._v(" "),_c('span',{domProps:{"innerHTML":_vm._s(_vm.title)}})]),_vm._v(" "),_c('ul',{staticClass:"list-group"},[_vm._t("default")],2)])])};
var __vue_staticRenderFns__$u = [];

  /* style */
  const __vue_inject_styles__$v = undefined;
  /* scoped */
  const __vue_scope_id__$v = undefined;
  /* module identifier */
  const __vue_module_identifier__$v = undefined;
  /* functional template */
  const __vue_is_functional_template__$v = false;
  /* style inject */
  
  /* style inject SSR */
  
  /* style inject shadow dom */
  

  
  const __vue_component__$v = normalizeComponent(
    { render: __vue_render__$u, staticRenderFns: __vue_staticRenderFns__$u },
    __vue_inject_styles__$v,
    __vue_script__$v,
    __vue_scope_id__$v,
    __vue_is_functional_template__$v,
    __vue_module_identifier__$v,
    false,
    undefined,
    undefined,
    undefined
  );

//
//
//
//
//
//
//
//
//
//
//
//
//
//
var script$w = {
  name: 'pf-radio-button',
  props: {
    activeClass: {
      type: String,
      default: 'active'
    },
    inactiveClass: String,
    value: {
      type: [Boolean, Number, String, Array]
    },
    name: String,
    checkedValue: {
      type: [Boolean, Number, String],
      default: true
    },
    input: {
      type: String,
      default: 'radio',
      validator: function validator(type) {
        return ['radio', 'checkbox'].includes(type);
      }
    },
    disabled: Boolean,
    loose: Boolean
  },
  computed: {
    checked: function checked() {
      return this.test(this.checkedValue);
    },
    stateClass: function stateClass() {
      if (this.checked && this.activeClass) {
        return this.activeClass;
      }

      if (!this.checked && this.inactiveClass) {
        return this.inactiveClass;
      }

      return '';
    },
    values: function values() {
      return Array.isArray(this.value) ? this.value : [this.value];
    }
  },
  watch: {
    input: function input() {
      if (this.input === 'checkbox' && !Array.isArray(this.value)) {
        this.$emit('input', this.values);
      } else if (this.input === 'radio' && Array.isArray(this.value)) {
        this.$emit('input', this.value.length ? this.value[0] : null);
      }
    }
  },
  methods: {
    test: function test(value) {
      if (this.input === 'radio') {
        if (this.loose) {
          return this.value == value;
        }

        return this.value === value;
      }

      if (this.loose) {
        return typeof this.values.find(function (v) {
          return v == value;
        }) !== 'undefined';
      }

      return this.values.includes(value);
    },
    change: function change() {
      var _this = this;

      if (this.disabled) {
        return;
      }

      if (this.input === 'checkbox') {
        if (this.checked) {
          this.$emit('input', this.values.filter(function (v) {
            if (_this.loose) {
              return v != _this.checkedValue;
            }

            return v !== _this.checkedValue;
          }));
        } else {
          this.$emit('input', this.test(this.checked) ? this.values : [].concat(_toConsumableArray(this.values), [this.checkedValue]));
        }

        return;
      }

      if (!this.checked) {
        this.$emit('input', this.checkedValue);
      }
    }
  }
};

/* script */
const __vue_script__$w = script$w;

/* template */
var __vue_render__$v = function () {var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('label',{staticClass:"btn",class:[_vm.stateClass, {
    'btn-default': _vm.activeClass == 'active' && _vm.inactiveClass != 'btn-default',
  }],attrs:{"type":"button","disabled":_vm.disabled}},[_c('input',{staticStyle:{"display":"none"},attrs:{"type":_vm.input,"name":_vm.name,"disabled":_vm.disabled},domProps:{"checked":_vm.checked,"value":_vm.checkedValue},on:{"change":_vm.change}}),_vm._v(" "),_vm._t("default")],2)};
var __vue_staticRenderFns__$v = [];

  /* style */
  const __vue_inject_styles__$w = undefined;
  /* scoped */
  const __vue_scope_id__$w = undefined;
  /* module identifier */
  const __vue_module_identifier__$w = undefined;
  /* functional template */
  const __vue_is_functional_template__$w = false;
  /* style inject */
  
  /* style inject SSR */
  
  /* style inject shadow dom */
  

  
  const __vue_component__$w = normalizeComponent(
    { render: __vue_render__$v, staticRenderFns: __vue_staticRenderFns__$v },
    __vue_inject_styles__$w,
    __vue_script__$w,
    __vue_scope_id__$w,
    __vue_is_functional_template__$w,
    __vue_module_identifier__$w,
    false,
    undefined,
    undefined,
    undefined
  );

//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
var script$x = {
  name: 'pf-spinner',
  props: {
    loading: Boolean,
    size: {
      type: String,
      default: 'md',
      validator: function validator(val) {
        return ['lg', 'md', 'sm', 'xs'].indexOf(val) >= 0;
      }
    },
    inline: Boolean,
    inverse: Boolean,
    tag: {
      type: String,
      default: 'div'
    }
  }
};

/* script */
const __vue_script__$x = script$x;

/* template */
var __vue_render__$w = function (_h,_vm) {var _c=_vm._c;return (_vm.props.loading)?_c('div',_vm._g(_vm._b({staticClass:"spinner",class:[_vm.data.class, _vm.data.staticClass, ("spinner-" + (_vm.props.size)), {
    'spinner-inline': _vm.props.inline,
    'spinner-inverse': _vm.props.inverse,
  }],style:([_vm.data.style, _vm.data.staticStyle])},'div',_vm.data.attrs,false),_vm.listeners)):_c(_vm.props.tag,{tag:"div"},[_vm._t("default")],2)};
var __vue_staticRenderFns__$w = [];

  /* style */
  const __vue_inject_styles__$x = undefined;
  /* scoped */
  const __vue_scope_id__$x = undefined;
  /* module identifier */
  const __vue_module_identifier__$x = undefined;
  /* functional template */
  const __vue_is_functional_template__$x = true;
  /* style inject */
  
  /* style inject SSR */
  
  /* style inject shadow dom */
  

  
  const __vue_component__$x = normalizeComponent(
    { render: __vue_render__$w, staticRenderFns: __vue_staticRenderFns__$w },
    __vue_inject_styles__$x,
    __vue_script__$x,
    __vue_scope_id__$x,
    __vue_is_functional_template__$x,
    __vue_module_identifier__$x,
    false,
    undefined,
    undefined,
    undefined
  );

var script$y = {
  name: 'pf-toggle',
  components: {
    PfRadioButton: __vue_component__$w,
    PfSpinner: __vue_component__$x
  },
  model: {
    event: 'change'
  },
  props: {
    name: {
      type: String,
      default: null
    },
    value: {
      type: [Boolean, String, Number, Array],
      required: true
    },
    disabled: Boolean,
    loading: Boolean,
    loose: Boolean,
    onText: {
      type: String,
      default: 'ON'
    },
    onValue: {
      type: [Boolean, String, Number],
      default: true
    },
    onClass: {
      type: String,
      default: 'btn-success'
    },
    offText: {
      type: String,
      default: 'OFF'
    },
    offValue: {
      type: [Boolean, String, Number],
      default: false
    },
    noOff: Boolean,
    offClass: {
      type: String,
      default: 'btn-danger'
    },
    size: {
      type: String,
      default: 'sm',
      validator: function validator(val) {
        return ['lg', 'md', 'sm', 'xs'].includes(val);
      }
    }
  },
  computed: {
    on: function on() {
      return this.test(this.onValue);
    },
    radioValue: function radioValue() {
      if (Array.isArray(this.value)) {
        return this.on ? this.onValue : this.offValue;
      }

      return this.value;
    },
    values: function values() {
      return Array.isArray(this.value) ? this.value : [this.value];
    }
  },
  watch: {
    noOff: function noOff() {
      if (!this.test(this.onValue) && !this.test(this.offValue)) {
        this.setOff();
      } else if (this.noOff && !Array.isArray(this.value)) {
        this.$emit('change', this.values);
      }
    }
  },
  methods: {
    test: function test(value) {
      if (!this.noOff) {
        if (this.loose) {
          return this.value == value;
        }

        return this.value === value;
      }

      if (this.loose) {
        return typeof this.values.find(function (v) {
          return v == value;
        }) !== 'undefined';
      }

      return this.values.includes(value);
    },
    setOff: function setOff() {
      var _this = this;

      if (this.disabled) {
        return;
      }

      if (this.noOff) {
        this.$emit('change', this.values.filter(function (v) {
          if (_this.loose) {
            return v != _this.onValue;
          }

          return v !== _this.onValue;
        }));
        return;
      }

      this.set(this.offValue);
    },
    set: function set(value) {
      if (this.disabled) {
        return;
      }

      if (this.noOff && !Array.isArray(value)) {
        this.$emit('change', this.test(value) ? this.values : [].concat(_toConsumableArray(this.values), [value]));
        return;
      }

      this.$emit('change', value);
    },
    toggle: function toggle() {
      if (this.disabled) {
        return;
      }

      if (this.on) {
        if (this.noOff) {
          this.setOff();
          return;
        }

        this.set(this.offValue);
        return;
      }

      this.set(this.onValue);
    }
  }
};

/* script */
const __vue_script__$y = script$y;
/* template */
var __vue_render__$x = function () {var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('div',{staticClass:"btn-group btn-group-flip",class:{disabled: _vm.disabled},attrs:{"tabindex":"0"},on:{"keyup":[function($event){if(!$event.type.indexOf('key')&&_vm._k($event.keyCode,"space",32,$event.key,[" ","Spacebar"])){ return null; }return _vm.toggle($event)},function($event){if(!$event.type.indexOf('key')&&_vm._k($event.keyCode,"enter",13,$event.key,"Enter")){ return null; }return _vm.toggle($event)},function($event){if(!$event.type.indexOf('key')&&_vm._k($event.keyCode,"left",37,$event.key,["Left","ArrowLeft"])){ return null; }if('button' in $event && $event.button !== 0){ return null; }return _vm.set(_vm.onValue)},function($event){if(!$event.type.indexOf('key')&&_vm._k($event.keyCode,"right",39,$event.key,["Right","ArrowRight"])){ return null; }if('button' in $event && $event.button !== 2){ return null; }return _vm.setOff($event)}]}},[(_vm.noOff)?[_c('pf-radio-button',{class:[("btn-" + _vm.size)],attrs:{"name":_vm.name,"input":"checkbox","value":_vm.value,"active-class":_vm.onClass,"inactive-class":"btn-default","checked-value":_vm.onValue,"loose":_vm.loose,"disabled":_vm.disabled},on:{"input":function($event){return _vm.set(_vm.onValue)}}},[_vm._v("\n      "+_vm._s(_vm.onText)+"\n    ")]),_vm._v(" "),_c('label',{staticClass:"btn",class:[_vm.on ? 'btn-default' : _vm.offClass, ("btn-" + _vm.size)],on:{"click":_vm.setOff}},[_vm._v("\n      "+_vm._s(_vm.offText)+"\n    ")])]:[_c('pf-radio-button',{class:[("btn-" + _vm.size)],attrs:{"name":_vm.name,"value":_vm.radioValue,"active-class":_vm.onClass,"inactive-class":"btn-default","checked-value":_vm.onValue,"loose":_vm.loose,"disabled":_vm.disabled},on:{"input":function($event){return _vm.set($event)}}},[_vm._v("\n      "+_vm._s(_vm.onText)+"\n    ")]),_vm._v(" "),_c('pf-radio-button',{class:[("btn-" + _vm.size)],attrs:{"name":_vm.name,"value":_vm.radioValue,"active-class":_vm.offClass,"inactive-class":"btn-default","checked-value":_vm.offValue,"loose":_vm.loose,"disabled":_vm.disabled},on:{"input":function($event){return _vm.set($event)}}},[_vm._v("\n      "+_vm._s(_vm.offText)+"\n    ")])],_vm._v(" "),(_vm.loading)?_c('pf-spinner',{attrs:{"size":_vm.size,"inline":"","loading":""}}):_vm._e(),_vm._v("\n   \n  "),_vm._t("default")],2)};
var __vue_staticRenderFns__$x = [];

  /* style */
  const __vue_inject_styles__$y = undefined;
  /* scoped */
  const __vue_scope_id__$y = undefined;
  /* module identifier */
  const __vue_module_identifier__$y = undefined;
  /* functional template */
  const __vue_is_functional_template__$y = false;
  /* style inject */
  
  /* style inject SSR */
  
  /* style inject shadow dom */
  

  
  const __vue_component__$y = normalizeComponent(
    { render: __vue_render__$x, staticRenderFns: __vue_staticRenderFns__$x },
    __vue_inject_styles__$y,
    __vue_script__$y,
    __vue_scope_id__$y,
    __vue_is_functional_template__$y,
    __vue_module_identifier__$y,
    false,
    undefined,
    undefined,
    undefined
  );

//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
var script$z = {
  name: 'pf-combobox',
  model: {
    event: 'update'
  },
  props: {
    name: {
      type: String,
      default: null
    },
    value: {
      type: [String, Number],
      default: null
    },
    placeholder: {
      type: String,
      default: null
    },
    disabled: Boolean,
    required: Boolean,
    tabindex: {
      type: String,
      default: null
    },
    options: {
      type: Array,
      default: function _default() {
        return [];
      }
    },
    labelField: {
      type: String,
      default: 'label'
    },
    valueField: {
      type: String,
      default: 'id'
    },
    match: {
      type: Function,
      default: function _default(o, q) {
        return o.label.toString().toLowerCase().includes(q.toLowerCase());
      }
    },
    highlight: {
      type: Function,
      default: function _default(o, q) {
        return o.label.replace(new RegExp(q.replace(/[-[\]{}()*+?.,\\^$|#\s]/g, '\\$&'), 'ig'), '<strong>$&</strong>');
      }
    },
    withCheckbox: {
      type: [Boolean, String],
      default: false
    }
  },
  data: function data() {
    return {
      showOptions: false,
      filter: '',
      active: null,
      hasError: false,
      checked: false
    };
  },
  computed: {
    hasValue: function hasValue() {
      return this.value !== null;
    },
    label: function label() {
      if (!this.hasValue || typeof this.optionsMap[this.value] === 'undefined') {
        return '';
      }

      return this.optionsMap[this.value].label;
    },
    optionsMap: function optionsMap() {
      var map = {};
      var _iteratorNormalCompletion = true;
      var _didIteratorError = false;
      var _iteratorError = undefined;

      try {
        for (var _iterator = this.options[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
          var o = _step.value;
          var isObj = _typeof(o) === 'object';
          var value = isObj ? o[this.valueField] : o;
          var label = isObj ? o[this.labelField] : o;
          map[value] = {
            option: o,
            label: label,
            value: value
          };
        }
      } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion && _iterator.return != null) {
            _iterator.return();
          }
        } finally {
          if (_didIteratorError) {
            throw _iteratorError;
          }
        }
      }

      return map;
    },
    filteredOptions: function filteredOptions() {
      var _this = this;

      if (this.filter === null) {
        return [];
      }

      return Object.values(this.optionsMap).reduce(function (options, o) {
        if (_this.match(o, _this.filter)) {
          options.push(_objectSpread2({}, o, {
            highlighted: _this.highlight(o, _this.filter)
          }));
        }

        return options;
      }, []);
    },
    text: {
      get: function get() {
        return this.hasValue ? this.label : this.filter;
      },
      set: function set(text) {
        this.filter = text;
        this.$emit('update', null);
      }
    },
    dropdownOpen: function dropdownOpen() {
      return this.showOptions && this.filteredOptions.length;
    },
    effectiveDisabled: function effectiveDisabled() {
      return this.disabled || this.withCheckbox && !this.checked;
    }
  },
  watch: {
    dropdownOpen: function dropdownOpen() {
      if (this.dropdownOpen) {
        clearTimeout(this.blurTimeout);
      }
    },
    filteredOptions: function filteredOptions() {
      if (this.filteredOptions.length) {
        this.active = this.filteredOptions[0].value;
        this.showOptions = this.filter !== null;
      } else {
        this.active = null;
      }
    }
  },
  methods: {
    setValue: function setValue(value) {
      this.showOptions = false;

      if (value === null) {
        this.filter = null;
      }

      if (value !== this.value) {
        this.$emit('update', value);
        this.hasError = false;
      }

      this.$refs.text.focus();
    },
    toggleOptions: function toggleOptions() {
      this.showOptions = !this.dropdownOpen;

      if (this.showOptions) {
        if (this.filter === null) {
          this.filter = '';
        }

        this.$refs.text.focus();
      }
    },
    blur: function blur() {
      var _this2 = this;

      clearTimeout(this.blurTimeout);
      this.blurTimeout = setTimeout(function () {
        if (_this2.filter) {
          _this2.filter = null;
        }

        _this2.showOptions = false;
      }, 200);
    },
    prev: function prev() {
      var _this3 = this;

      if (!this.filteredOptions.length) {
        this.active = null;
        return;
      }

      var activeIdx = this.filteredOptions.findIndex(function (o) {
        return o.value === _this3.active;
      });

      if (activeIdx < 0 || activeIdx === 0) {
        activeIdx = this.filteredOptions.length - 1;
      } else {
        activeIdx--;
      }

      this.active = this.filteredOptions[activeIdx].value;
    },
    next: function next() {
      var _this4 = this;

      if (!this.dropdownOpen) {
        this.toggleOptions();
        this.active = null;
      }

      if (!this.filteredOptions.length) {
        this.active = null;
        return;
      }

      var activeIdx = this.filteredOptions.findIndex(function (o) {
        return o.value === _this4.active;
      });

      if (activeIdx < 0 || activeIdx >= this.filteredOptions.length - 1) {
        activeIdx = 0;
      } else {
        activeIdx++;
      }

      this.active = this.filteredOptions[activeIdx].value;
    },
    apply: function apply(e) {
      var _this5 = this;

      if (!this.dropdownOpen) {
        return;
      }

      e.preventDefault();

      if (this.active === null) {
        this.setValue(null);
        return;
      }

      var activeIdx = this.filteredOptions.findIndex(function (o) {
        return o.value === _this5.active;
      });

      if (activeIdx < 0) {
        this.setValue(null);
        return;
      }

      this.setValue(this.filteredOptions[activeIdx].value);
    },
    dropdownClick: function dropdownClick(e) {
      if (this.effectiveDisabled) {
        e.preventDefault();
        return;
      }

      if (this.hasValue) {
        this.setValue(null);
        return;
      }

      this.toggleOptions();
    }
  }
};

/* script */
const __vue_script__$z = script$z;

/* template */
var __vue_render__$y = function () {var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('div',{staticClass:"combobox-container",class:{
    'combobox-disabled': _vm.effectiveDisabled,
    'combobox-selected': _vm.hasValue,
    'has-error': _vm.hasError,
  }},[(_vm.name)?_c('input',{attrs:{"type":"hidden","name":_vm.name,"disabled":_vm.effectiveDisabled,"required":_vm.required},domProps:{"value":_vm.value}}):_vm._e(),_vm._v(" "),_c('div',{staticClass:"input-group"},[(_vm.withCheckbox)?_c('label',{staticClass:"input-group-addon"},[_c('input',{directives:[{name:"model",rawName:"v-model",value:(_vm.checked),expression:"checked"}],attrs:{"type":"checkbox","name":_vm.withCheckbox,"value":"1"},domProps:{"checked":Array.isArray(_vm.checked)?_vm._i(_vm.checked,"1")>-1:(_vm.checked)},on:{"change":function($event){var $$a=_vm.checked,$$el=$event.target,$$c=$$el.checked?(true):(false);if(Array.isArray($$a)){var $$v="1",$$i=_vm._i($$a,$$v);if($$el.checked){$$i<0&&(_vm.checked=$$a.concat([$$v]));}else{$$i>-1&&(_vm.checked=$$a.slice(0,$$i).concat($$a.slice($$i+1)));}}else{_vm.checked=$$c;}}}})]):_vm._e(),_vm._v(" "),_c('input',{directives:[{name:"model",rawName:"v-model",value:(_vm.text),expression:"text"}],ref:"text",staticClass:"combobox form-control",attrs:{"type":"text","autocomplete":"off","autocorrect":"off","autocapitalize":"off","spellcheck":"false","placeholder":_vm.placeholder,"disabled":_vm.effectiveDisabled,"required":_vm.required,"tabindex":_vm.tabindex},domProps:{"value":(_vm.text)},on:{"focus":function($event){return _vm.$refs.text.select()},"blur":_vm.blur,"keydown":[function($event){if(!$event.type.indexOf('key')&&_vm._k($event.keyCode,"esc",27,$event.key,["Esc","Escape"])){ return null; }_vm.showOptions = false;},function($event){if(!$event.type.indexOf('key')&&_vm._k($event.keyCode,"up",38,$event.key,["Up","ArrowUp"])){ return null; }$event.preventDefault();return _vm.prev($event)},function($event){if(!$event.type.indexOf('key')&&_vm._k($event.keyCode,"down",40,$event.key,["Down","ArrowDown"])){ return null; }$event.preventDefault();return _vm.next($event)},function($event){if(!$event.type.indexOf('key')&&_vm._k($event.keyCode,"enter",13,$event.key,"Enter")){ return null; }return _vm.apply($event)},function($event){if(!$event.type.indexOf('key')&&_vm._k($event.keyCode,"tab",9,$event.key,"Tab")){ return null; }return _vm.apply($event)}],"invalid":function($event){_vm.hasError = true;},"input":function($event){if($event.target.composing){ return; }_vm.text=$event.target.value;}}}),_vm._v(" "),_c('ul',{staticClass:"typeahead typeahead-long dropdown-menu",staticStyle:{"top":"26px","left":"0px","max-height":"300px"},style:({display: _vm.dropdownOpen ? 'block' : 'none'}),attrs:{"role":"listbox"}},_vm._l((_vm.filteredOptions),function(o){return _c('li',{key:o.value,class:{active: o.value === _vm.active},attrs:{"data-value":o.value,"role":"option","aria-selected":o.value === _vm.active},on:{"click":function($event){$event.stopPropagation();$event.preventDefault();return _vm.setValue(o.value)}}},[_c('a',{attrs:{"href":"javascript:void(0)","role":"presentation"}},[_vm._t("default",[_c('span',{domProps:{"innerHTML":_vm._s(o.highlighted)}})],{"option":o})],2)])}),0),_vm._v(" "),_c('a',{staticClass:"input-group-addon dropdown-toggle",class:{disabled: _vm.effectiveDisabled},attrs:{"href":"javascript:void(0)","role":"button","data-dropdown":"dropdown","disabled":_vm.effectiveDisabled},on:{"click":_vm.dropdownClick}},[_c('span',{staticClass:"caret"}),_vm._v(" "),_c('pf-icon',{attrs:{"name":"glyphicon-remove"}})],1)])])};
var __vue_staticRenderFns__$y = [];

  /* style */
  const __vue_inject_styles__$z = undefined;
  /* scoped */
  const __vue_scope_id__$z = undefined;
  /* module identifier */
  const __vue_module_identifier__$z = undefined;
  /* functional template */
  const __vue_is_functional_template__$z = false;
  /* style inject */
  
  /* style inject SSR */
  
  /* style inject shadow dom */
  

  
  const __vue_component__$z = normalizeComponent(
    { render: __vue_render__$y, staticRenderFns: __vue_staticRenderFns__$y },
    __vue_inject_styles__$z,
    __vue_script__$z,
    __vue_scope_id__$z,
    __vue_is_functional_template__$z,
    __vue_module_identifier__$z,
    false,
    undefined,
    undefined,
    undefined
  );

//
var script$A = {
  name: 'pf-list-group-item',
  extends: __vue_component__$q,
  mixins: [SlotMonitor],
  components: {
    PortalTarget: PortalTarget,
    PfDropdown: __vue_component__$4
  },
  model: {
    prop: 'expanded',
    event: 'expanded'
  },
  props: {
    expanded: Boolean,
    expandable: Boolean,
    stacked: Boolean,
    index: {
      type: [String, Number]
    }
  },
  data: function data() {
    return {
      autoExpanded: false,
      expandedAdditional: null
    };
  },
  computed: {
    isExpanded: {
      get: function get() {
        return typeof this.expanded === 'boolean' ? this.expanded : this.autoExpanded;
      },
      set: function set(value) {
        if (typeof this.expanded !== 'boolean') {
          this.autoExpanded = value;
        }

        this.$emit('expanded', value);
      }
    },
    portal: function portal() {
      return "pf-list-group-item-portal-".concat(this._uid);
    },
    stateClass: function stateClass() {
      if (this.showExpansion) {
        return 'list-view-pf-expand-active';
      }

      if (this.selectable && this.selected) {
        return 'active';
      }

      return '';
    },
    showExpansion: function showExpansion() {
      return this.expandable && this.isExpanded || this.expandedAdditional;
    }
  },
  methods: {
    collapse: function collapse() {
      this.isExpanded = false;
      this.expandedAdditional = null;
    },
    toggle: function toggle(e) {
      if (!this.expandable) {
        return;
      }

      if (e) {
        var target = e.target;

        while (target && target !== this.$el) {
          if (['A', 'BUTTON', 'INPUT', 'SELECT'].indexOf(target.tagName) >= 0) {
            return;
          }

          target = target.parentElement;
        }
      }

      if (this.isExpanded) {
        this.isExpanded = false;
      } else {
        this.isExpanded = true;
        this.expandedAdditional = null;
      }
    }
  }
};

/* script */
const __vue_script__$A = script$A;

/* template */
var __vue_render__$z = function () {var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('div',{staticClass:"list-group-item",class:[_vm.stateClass, {'list-view-pf-stacked': _vm.stacked}],style:({cursor: _vm.expandable ? 'pointer' : 'inherit'}),on:{"click":_vm.toggle}},[(_vm.expandable && _vm.withSlot.expansion)?_c('div',{staticClass:"list-view-pf-expand",class:{active: _vm.isExpanded}},[_c('pf-icon',{class:{'fa-angle-down': _vm.isExpanded},attrs:{"name":"fa-angle-right"}})],1):_vm._e(),_vm._v(" "),(_vm.selectable)?_c('div',{staticClass:"list-view-pf-checkbox"},[_c('label',[_c('span',{staticClass:"sr-only"},[_vm._v("Select row "+_vm._s(_vm.index))]),_vm._v(" "),_c('input',{directives:[{name:"model",rawName:"v-model",value:(_vm.selected),expression:"selected"}],attrs:{"type":"checkbox"},domProps:{"checked":Array.isArray(_vm.selected)?_vm._i(_vm.selected,null)>-1:(_vm.selected)},on:{"change":function($event){var $$a=_vm.selected,$$el=$event.target,$$c=$$el.checked?(true):(false);if(Array.isArray($$a)){var $$v=null,$$i=_vm._i($$a,$$v);if($$el.checked){$$i<0&&(_vm.selected=$$a.concat([$$v]));}else{$$i>-1&&(_vm.selected=$$a.slice(0,$$i).concat($$a.slice($$i+1)));}}else{_vm.selected=$$c;}}}})])]):_vm._e(),_vm._v(" "),_c('div',{staticClass:"list-view-pf-actions"},[_vm._t("action"),_vm._v(" "),(_vm.withSlot.dropdown)?_c('pf-dropdown',{staticClass:"dropdown dropdown-kebab-pf",attrs:{"type":"link","menu-right":""}},[_vm._t("dropdown")],2):_vm._e()],2),_vm._v(" "),_vm._t("default"),_vm._v(" "),_c('div',{directives:[{name:"show",rawName:"v-show",value:(_vm.showExpansion),expression:"showExpansion"}],staticClass:"list-group-item-container container-fluid",staticStyle:{"cursor":"initial"},on:{"click":function($event){$event.stopPropagation();}}},[_c('div',{staticClass:"close"},[_c('pf-icon',{attrs:{"name":"pficon-close"},on:{"click":_vm.collapse}})],1),_vm._v(" "),(_vm.isExpanded)?_vm._t("expansion"):_vm._e(),_vm._v(" "),(_vm.expandedAdditional)?_c('portal-target',{attrs:{"name":_vm.portal}}):_vm._e()],2)],2)};
var __vue_staticRenderFns__$z = [];

  /* style */
  const __vue_inject_styles__$A = undefined;
  /* scoped */
  const __vue_scope_id__$A = undefined;
  /* module identifier */
  const __vue_module_identifier__$A = undefined;
  /* functional template */
  const __vue_is_functional_template__$A = false;
  /* style inject */
  
  /* style inject SSR */
  
  /* style inject shadow dom */
  

  
  const __vue_component__$A = normalizeComponent(
    { render: __vue_render__$z, staticRenderFns: __vue_staticRenderFns__$z },
    __vue_inject_styles__$A,
    __vue_script__$A,
    __vue_scope_id__$A,
    __vue_is_functional_template__$A,
    __vue_module_identifier__$A,
    false,
    undefined,
    undefined,
    undefined
  );

//
var script$B = {
  name: 'pf-list-view',
  mixins: [SlotMonitor],
  components: {
    PfListGroupItem: __vue_component__$A
  },
  props: {
    page: Number,
    totalItems: {
      type: Number,
      default: 0
    },
    itemsPerPage: {
      type: Number,
      default: 10
    },
    itemsPerPageOptions: {
      type: Array,
      default: function _default() {
        return [10, 25, 50, 100, 500];
      }
    },
    expandable: Boolean,
    selectable: Boolean,
    stacked: Boolean,
    rows: {
      type: Array,
      default: function _default() {
        return [];
      }
    },
    keyName: String
  },
  methods: {
    setAllSelected: function setAllSelected() {
      var selected = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : true;
      var _iteratorNormalCompletion = true;
      var _didIteratorError = false;
      var _iteratorError = undefined;

      try {
        for (var _iterator = this.$refs.row[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
          var row = _step.value;
          row.selected = selected;
        }
      } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion && _iterator.return != null) {
            _iterator.return();
          }
        } finally {
          if (_didIteratorError) {
            throw _iteratorError;
          }
        }
      }
    },
    getSelected: function getSelected() {
      var selected = [];
      var _iteratorNormalCompletion2 = true;
      var _didIteratorError2 = false;
      var _iteratorError2 = undefined;

      try {
        for (var _iterator2 = this.$refs.row[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
          var row = _step2.value;
          var id = row.num;

          if (typeof id !== 'undefined' && row.selected && this.rows[id]) {
            selected.push(this.rows[id]);
          }
        }
      } catch (err) {
        _didIteratorError2 = true;
        _iteratorError2 = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion2 && _iterator2.return != null) {
            _iterator2.return();
          }
        } finally {
          if (_didIteratorError2) {
            throw _iteratorError2;
          }
        }
      }

      return selected;
    }
  }
};

/* script */
const __vue_script__$B = script$B;

/* template */
var __vue_render__$A = function () {var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('div',[_c('div',{staticClass:"list-group list-view-pf list-view-pf-view"},_vm._l((_vm.rows),function(row,i){return _c('pf-list-group-item',{key:_vm.keyName ? row[_vm.keyName] : i,ref:"row",refInFor:true,attrs:{"index":i,"selectable":_vm.selectable,"expandable":_vm.expandable,"stacked":_vm.stacked},scopedSlots:_vm._u([(_vm.withSlot.action)?{key:"action",fn:function(){return [_vm._t("action",null,{"row":row,"index":i})]},proxy:true}:null,(_vm.withSlot.dropdown)?{key:"dropdown",fn:function(){return [_vm._t("dropdown",null,{"row":row,"index":i})]},proxy:true}:null,(_vm.withSlot.expansion)?{key:"expansion",fn:function(){return [_vm._t("expansion",null,{"row":row,"index":i})]},proxy:true}:null],null,true)},[_vm._t("default",null,{"row":row,"index":i})],2)}),1),_vm._v(" "),(_vm.itemsPerPage > 0)?_c('pf-paginate-control',{ref:"pagination",attrs:{"type":"list","page":_vm.page,"total-items":_vm.totalItems,"items-per-page":_vm.itemsPerPage,"items-per-page-options":_vm.itemsPerPageOptions},on:{"update:itemsPerPage":function($event){return _vm.$emit('update:itemsPerPage', $event)},"change":function($event){return _vm.$emit('update:page', arguments[0])}}}):_vm._e()],1)};
var __vue_staticRenderFns__$A = [];

  /* style */
  const __vue_inject_styles__$B = undefined;
  /* scoped */
  const __vue_scope_id__$B = undefined;
  /* module identifier */
  const __vue_module_identifier__$B = undefined;
  /* functional template */
  const __vue_is_functional_template__$B = false;
  /* style inject */
  
  /* style inject SSR */
  
  /* style inject shadow dom */
  

  
  const __vue_component__$B = normalizeComponent(
    { render: __vue_render__$A, staticRenderFns: __vue_staticRenderFns__$A },
    __vue_inject_styles__$B,
    __vue_script__$B,
    __vue_scope_id__$B,
    __vue_is_functional_template__$B,
    __vue_module_identifier__$B,
    false,
    undefined,
    undefined,
    undefined
  );

//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
var script$C = {
  name: 'pf-list-item',
  props: {
    icon: String,
    iconSrc: String,
    iconSize: {
      type: String,
      default: 'md',
      validator: function validator(size) {
        return ['sm', 'md', 'lg'].indexOf(size) >= 0;
      }
    },
    iconVariant: {
      type: String,
      validator: function validator(variant) {
        return ['', null, 'info', 'success', 'warning', 'danger'].indexOf(variant) >= 0;
      }
    }
  }
};

/* script */
const __vue_script__$C = script$C;

/* template */
var __vue_render__$B = function (_h,_vm) {
var _obj;
var _c=_vm._c;return _c('div',_vm._g(_vm._b({staticClass:"list-view-pf-main-info",class:[_vm.data.class, _vm.data.staticClass],style:([_vm.data.style, _vm.data.staticStyle])},'div',_vm.data.attrs,false),_vm.listeners),[_vm._t("default",[(_vm.props.icon || _vm.props.iconSrc || _vm.$slots.left || _vm.$scopedSlots.left)?_c('div',{staticClass:"list-view-pf-left"},[_vm._t("left",[_c('pf-icon',{class:[
          ("list-view-pf-icon-" + (_vm.props.iconSize)),
          ( _obj = {}, _obj[("list-view-pf-icon-" + (_vm.props.iconVariant))] = _vm.props.iconVariant, _obj ) ],attrs:{"name":_vm.props.icon,"src":_vm.props.iconSrc}})])],2):_vm._e(),_vm._v(" "),_c('div',{staticClass:"list-view-pf-body"},[(_vm.$slots.heading || _vm.$scopedSlots.heading || _vm.$slots.description || _vm.$scopedSlots.description)?_c('div',{staticClass:"list-view-pf-description"},[(_vm.$slots.heading || _vm.$scopedSlots.heading)?_c('div',{staticClass:"list-group-item-heading"},[_vm._t("heading")],2):_vm._e(),_vm._v(" "),(_vm.$slots.description || _vm.$scopedSlots.description)?_c('div',{staticClass:"list-group-item-text"},[_vm._t("description")],2):_vm._e()]):_vm._e(),_vm._v(" "),(_vm.$slots['additional-info'] || _vm.$scopedSlots['additional-info'])?_c('div',{staticClass:"list-view-pf-additional-info"},[_vm._t("additional-info")],2):_vm._e()])])],2)};
var __vue_staticRenderFns__$B = [];

  /* style */
  const __vue_inject_styles__$C = undefined;
  /* scoped */
  const __vue_scope_id__$C = undefined;
  /* module identifier */
  const __vue_module_identifier__$C = undefined;
  /* functional template */
  const __vue_is_functional_template__$C = true;
  /* style inject */
  
  /* style inject SSR */
  
  /* style inject shadow dom */
  

  
  const __vue_component__$C = normalizeComponent(
    { render: __vue_render__$B, staticRenderFns: __vue_staticRenderFns__$B },
    __vue_inject_styles__$C,
    __vue_script__$C,
    __vue_scope_id__$C,
    __vue_is_functional_template__$C,
    __vue_module_identifier__$C,
    false,
    undefined,
    undefined,
    undefined
  );

//
var script$D = {
  name: 'pf-list-item-additional-info',
  mixins: [SlotMonitor],
  components: {
    Portal: Portal
  },
  props: {
    stacked: Boolean,
    expandable: Boolean
  },
  computed: {
    groupItem: function groupItem() {
      var parent = this.$parent;

      while (parent && parent !== this.$root) {
        if (parent.$vnode.componentOptions.tag == 'pf-list-group-item') {
          return parent;
        }

        parent = parent.$parent;
      }

      return null;
    },
    portal: function portal() {
      return this.expanded ? this.groupItem.portal : '';
    },
    expanded: function expanded() {
      return this.groupItem && this.groupItem.expandedAdditional == this._uid;
    }
  },
  methods: {
    toggle: function toggle(e) {
      if (this.expandable && this.groupItem) {
        if (e) {
          e.stopPropagation();
        }

        this.groupItem.expanded = false;
        this.groupItem.expandedAdditional = this.expanded ? null : this._uid;
      }
    }
  }
};

/* script */
const __vue_script__$D = script$D;

/* template */
var __vue_render__$C = function () {var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('div',{staticClass:"list-view-pf-additional-info-item",class:{'list-view-pf-additional-info-item-stacked': _vm.stacked},on:{"click":_vm.toggle}},[(_vm.expandable && _vm.withSlot.expansion)?_c('div',{staticClass:"list-view-pf-expand",class:{'active': _vm.expanded}},[_c('pf-icon',{class:{'fa-angle-down': _vm.expanded},attrs:{"name":"fa-angle-right"}}),_vm._v(" "),_vm._t("default")],2):_vm._t("default"),_vm._v(" "),(_vm.expandable)?_c('portal',{attrs:{"to":_vm.portal}},[_vm._t("expansion")],2):_vm._e()],2)};
var __vue_staticRenderFns__$C = [];

  /* style */
  const __vue_inject_styles__$D = undefined;
  /* scoped */
  const __vue_scope_id__$D = undefined;
  /* module identifier */
  const __vue_module_identifier__$D = undefined;
  /* functional template */
  const __vue_is_functional_template__$D = false;
  /* style inject */
  
  /* style inject SSR */
  
  /* style inject shadow dom */
  

  
  const __vue_component__$D = normalizeComponent(
    { render: __vue_render__$C, staticRenderFns: __vue_staticRenderFns__$C },
    __vue_inject_styles__$D,
    __vue_script__$D,
    __vue_scope_id__$D,
    __vue_is_functional_template__$D,
    __vue_module_identifier__$D,
    false,
    undefined,
    undefined,
    undefined
  );

//

function isDescendantOf(node, ancestor) {
  while (node) {
    if (node === ancestor) {
      return true;
    }

    node = node.parentElement;
  }

  return false;
}

var script$E = {
  name: 'pf-modal',
  mixins: [SlotMonitor],
  components: {
    Portal: Portal
  },
  props: {
    title: String,
    confirmButton: {
      type: String,
      default: 'OK'
    },
    cancelButton: {
      type: String,
      default: 'Cancel'
    },
    outsideClose: {
      type: Boolean,
      default: false
    }
  },
  mounted: function mounted() {
    document.documentElement.classList.add('modal-open');
  },
  beforeDestroy: function beforeDestroy() {
    document.documentElement.classList.remove('modal-open');
  },
  methods: {
    confirm: function confirm() {
      this.$emit('confirm');
      this.close();
    },
    cancel: function cancel() {
      this.$emit('cancel');
      this.close();
    },
    close: function close() {
      this.$emit('close');
    },
    clickOutside: function clickOutside(e) {
      if (this.outsideClose && !isDescendantOf(e.target, this.$refs.dialog)) {
        this.cancel();
      }
    }
  }
};

/* script */
const __vue_script__$E = script$E;
/* template */
var __vue_render__$D = function () {var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('portal',{attrs:{"to":"modals-target"}},[_c('div',{key:"modal",staticClass:"modal",attrs:{"role":"dialog"},on:{"click":_vm.clickOutside}},[_c('div',{ref:"dialog",staticClass:"modal-dialog"},[_c('div',{staticClass:"modal-content"},[(_vm.title)?_c('div',{staticClass:"modal-header"},[_c('button',{staticClass:"close",attrs:{"type":"button"},on:{"click":_vm.cancel}},[_c('pf-icon',{attrs:{"name":"pficon-close"}})],1),_vm._v(" "),_c('h4',{staticClass:"modal-title"},[_vm._v(_vm._s(_vm.title))])]):_vm._e(),_vm._v(" "),_c('div',{staticClass:"modal-body"},[_vm._t("default")],2),_vm._v(" "),(_vm.withSlot.footer || _vm.cancelButton || _vm.confirmButton)?_c('div',{staticClass:"modal-footer"},[_vm._t("footer",[(_vm.cancelButton)?_c('button',{staticClass:"btn btn-default",attrs:{"type":"button"},on:{"click":_vm.cancel}},[_vm._v(_vm._s(_vm.cancelButton))]):_vm._e(),_vm._v(" "),(_vm.confirmButton)?_c('button',{staticClass:"btn btn-primary",attrs:{"type":"button"},on:{"click":_vm.confirm}},[_vm._v(_vm._s(_vm.confirmButton))]):_vm._e()])],2):_vm._e()])])]),_vm._v(" "),_c('div',{key:"backdrop",staticClass:"modal-backdrop in",on:{"click":_vm.clickOutside}})])};
var __vue_staticRenderFns__$D = [];

  /* style */
  const __vue_inject_styles__$E = undefined;
  /* scoped */
  const __vue_scope_id__$E = undefined;
  /* module identifier */
  const __vue_module_identifier__$E = undefined;
  /* functional template */
  const __vue_is_functional_template__$E = false;
  /* style inject */
  
  /* style inject SSR */
  
  /* style inject shadow dom */
  

  
  const __vue_component__$E = normalizeComponent(
    { render: __vue_render__$D, staticRenderFns: __vue_staticRenderFns__$D },
    __vue_inject_styles__$E,
    __vue_script__$E,
    __vue_scope_id__$E,
    __vue_is_functional_template__$E,
    __vue_module_identifier__$E,
    false,
    undefined,
    undefined,
    undefined
  );

var _e = function e() {
  return (_e = Object.assign || function (e) {
    for (var t, r = 1, s = arguments.length; r < s; r++) {
      for (var a in t = arguments[r]) {
        Object.prototype.hasOwnProperty.call(t, a) && (e[a] = t[a]);
      }
    }

    return e;
  }).apply(this, arguments);
},
    t = {
  kebab: /-(\w)/g,
  styleProp: /:(.*)/,
  styleList: /;(?![^(]*\))/g
};

function r(e, t) {
  return t ? t.toUpperCase() : "";
}

function s(e) {
  for (var s, a = {}, c = 0, o = e.split(t.styleList); c < o.length; c++) {
    var n = o[c].split(t.styleProp),
        i = n[0],
        l = n[1];
    (i = i.trim()) && ("string" == typeof l && (l = l.trim()), a[(s = i, s.replace(t.kebab, r))] = l);
  }

  return a;
}

function a() {
  for (var t, r, a = {}, c = arguments.length; c--;) {
    for (var o = 0, n = Object.keys(arguments[c]); o < n.length; o++) {
      switch (t = n[o]) {
        case "class":
        case "style":
        case "directives":
          if (Array.isArray(a[t]) || (a[t] = []), "style" === t) {
            var i = void 0;
            i = Array.isArray(arguments[c].style) ? arguments[c].style : [arguments[c].style];

            for (var l = 0; l < i.length; l++) {
              var y = i[l];
              "string" == typeof y && (i[l] = s(y));
            }

            arguments[c].style = i;
          }

          a[t] = a[t].concat(arguments[c][t]);
          break;

        case "staticClass":
          if (!arguments[c][t]) break;
          void 0 === a[t] && (a[t] = ""), a[t] && (a[t] += " "), a[t] += arguments[c][t].trim();
          break;

        case "on":
        case "nativeOn":
          a[t] || (a[t] = {});

          for (var p = 0, f = Object.keys(arguments[c][t] || {}); p < f.length; p++) {
            r = f[p], a[t][r] ? a[t][r] = [].concat(a[t][r], arguments[c][t][r]) : a[t][r] = arguments[c][t][r];
          }

          break;

        case "attrs":
        case "props":
        case "domProps":
        case "scopedSlots":
        case "staticStyle":
        case "hook":
        case "transition":
          a[t] || (a[t] = {}), a[t] = _e({}, arguments[c][t], a[t]);
          break;

        case "slot":
        case "key":
        case "ref":
        case "tag":
        case "show":
        case "keepAlive":
        default:
          a[t] || (a[t] = arguments[c][t]);
      }
    }
  }

  return a;
}

// https://www.patternfly.org/styles/icons/
var Icon = {
  name: 'pf-icon',
  functional: true,
  props: {
    name: String,
    src: String,
    tag: {
      type: String,
      default: 'span'
    }
  },
  render: function render(h, _ref) {
    var props = _ref.props,
        data = _ref.data,
        children = _ref.children;
    var staticClass = '';
    var style = {};

    if (props.src) {
      staticClass = 'pficon pf-icon-img';
      style.backgroundImage = "url(\"".concat(props.src, "\")");
    } else {
      var match = /^(fa|pficon|glyphicon)-/.exec(props.name);
      staticClass = match ? match[1] : '';

      if (props.name) {
        staticClass = "".concat(staticClass, " ").concat(props.name);
      }
    }

    return h(props.tag, a(data, {
      attrs: {
        'aria-hidden': 'true'
      },
      staticClass: staticClass,
      style: style
    }), children);
  }
};

var MenuItem = {
  name: 'pf-menu-item',
  functional: true,
  props: {
    title: {
      type: String,
      required: true
    },
    to: [String, Object],
    exact: Boolean,
    icon: String,
    badge: String,
    href: String,
    target: String,
    vertical: Boolean
  },
  render: function render(h, _ref) {
    var props = _ref.props,
        data = _ref.data,
        children = _ref.children;

    var vertical = props.vertical,
        icon = props.icon,
        badge = props.badge,
        title = props.title,
        href = props.href,
        target = props.target,
        attrs = _objectWithoutProperties(props, ["vertical", "icon", "badge", "title", "href", "target"]);

    var tag = typeof attrs.to === 'undefined' ? 'li' : 'router-link';

    if (tag === 'router-link') {
      attrs.tag = 'li';
      attrs.activeClass = 'active';
    }

    var elements = [];

    if (icon) {
      elements.push(h('pf-icon', {
        attrs: {
          name: icon,
          title: title
        }
      }));
    }

    elements.push(h('span', {
      staticClass: 'list-group-item-value'
    }, title));

    if (badge) {
      elements.push(h('div', {
        staticClass: 'badge-container-pf'
      }, [h('div', {
        staticClass: 'badge'
      }, badge)]));
    }

    elements = [h('a', {
      attrs: {
        href: href,
        target: target
      }
    }, elements)];

    if (children) {
      if (vertical) {
        elements = elements.concat(children);
      } else {
        elements.push(h('ul', {
          staticClass: 'nav navbar-nav navbar-persistent'
        }, children));
      }
    }

    return h(tag, a(data, {
      attrs: attrs,
      staticClass: 'list-group-item'
    }), elements);
  }
};



var components = /*#__PURE__*/Object.freeze({
  __proto__: null,
  AggregateStatusCard: __vue_component__,
  ApplicationLauncher: __vue_component__$1,
  LauncherItem: __vue_component__$2,
  C3Chart: __vue_component__$3,
  Card: __vue_component__$5,
  CardNotification: __vue_component__$6,
  Dropdown: __vue_component__$4,
  EmptyChart: __vue_component__$7,
  Sort: __vue_component__$8,
  ColumnPicker: __vue_component__$9,
  Toolbar: __vue_component__$a,
  UtilizationBarChart: __vue_component__$b,
  FilterFields: __vue_component__$e,
  FilterResults: __vue_component__$f,
  Notifications: __vue_component__$h,
  Notification: __vue_component__$g,
  NotificationBell: __vue_component__$i,
  Drawer: __vue_component__$j,
  DrawerGroup: __vue_component__$k,
  DrawerGroupAction: __vue_component__$l,
  DrawerNotification: __vue_component__$m,
  ExpandCollapse: __vue_component__$n,
  Layout: __vue_component__$p,
  Table: __vue_component__$r,
  PaginateControl: __vue_component__$s,
  VerticalNavDivider: __vue_component__$u,
  VerticalSubmenu: __vue_component__$v,
  RadioButton: __vue_component__$w,
  Toggle: __vue_component__$y,
  Combobox: __vue_component__$z,
  Spinner: __vue_component__$x,
  Select: __vue_component__$c,
  Option: __vue_component__$d,
  ListView: __vue_component__$B,
  ListItem: __vue_component__$C,
  ListGroupItem: __vue_component__$A,
  ListItemAdditionalInfo: __vue_component__$D,
  Modal: __vue_component__$E,
  Icon: Icon,
  MenuItem: MenuItem
});

var VuePatternfly = _objectSpread2({
  version: version
}, components, {
  install: function install$1(Vue) {
    for (var _i = 0, _Object$entries = Object.entries(components); _i < _Object$entries.length; _i++) {
      var _ref3 = _Object$entries[_i];

      var _ref2 = _slicedToArray(_ref3, 2);

      var name = _ref2[0];
      var component = _ref2[1];
      Vue.component(component.name || name, component);
    }

    install(Vue);
  }
});

if (typeof window !== 'undefined' && window.Vue) {
  window.Vue.use(VuePatternfly);
}

export default VuePatternfly;
//# sourceMappingURL=vue-patternfly.esm.js.map
